#ifndef SL_CONSOLE_HPP
#define SL_CONSOLE_HPP

#include <string>
#include <SFML/Graphics.hpp>
#include "Engine/Input/Input.hpp"

namespace sl
{

namespace ls
{
class Bindings;
} // ls

class Game;

class Console
{
public:
	Console(Game& game);
	
	
	void init();

	void update();
	
	void execute();
	
	void draw(sf::RenderTarget& target) const;
	
	bool isEnabled() const;
	
private:
	Game& game;
	ls::Bindings& context;
	const Input& input;
	std::string inputBuffer;
	sf::RectangleShape background;
	sf::Text inputText;
	sf::Text outputText;
	bool enabled;
	//! Commands previously entered.
	std::vector<std::string> history;
	//! Which history command you're currently at. history.size() = haven't used (please don't index with this)
	int historyIndex;
	//! How long until holding (instead of pressing) backspace will work (this is so you don't erase 30 chars per second)
	int backspaceCooldown;
};

} // sl

#endif // SL_CONSOLE_HPP