#include "Engine/Events/EventIterator.hpp"

namespace sl
{

EventIterator::EventIterator(const std::deque<std::unique_ptr<const Event>>& eventQueue)
	:eventQueue(eventQueue)
	,it(eventQueue.begin())
{
}

bool EventIterator::poll(const Event*& event)
{
	if (it == eventQueue.end())
	{
		return false;
	}
	else
	{
		event = it->get();
		++it;
		return true;
	}
}

}
