#include "Engine/Events/EventQueue.hpp"

#include "Utility/Assert.hpp"

namespace sl
{

EventQueue::EventQueue()
{

}

void EventQueue::addEvent(std::unique_ptr<const Event> event)
{
	eventQueues[event->getCategory()].push_back(std::move(event));
}

EventIterator EventQueue::iterator(Event::Category category) const
{
	ASSERT(category != Event::Category::EventTypeNum);
	return EventIterator(eventQueues[category]);
}

void EventQueue::reset()
{
	for (auto& eventQueue : eventQueues)
	{
		eventQueue.clear();
	}
}

}
