#ifndef SL_GUI_BAR_HPP
#define SL_GUI_BAR_HPP

#include "Engine/GUI/GUIWidget.hpp"

#include <SFML/Graphics/RectangleShape.hpp>

namespace sl
{
namespace gui
{

class Bar : public GUIWidget
{
public:
	Bar(const Rect<int>& bounds, const sf::Color& low, const sf::Color& high, const sf::Color& outline = sf::Color::White, const sf::Color& background = sf::Color::Transparent);

	void setValue(float val);

private:
	void onDraw(sf::RenderTarget& target) const override;

	void onUpdate(int x, int y) override;


	sf::Color lowColor;
	sf::Color highColor;
	sf::RectangleShape back;
	sf::RectangleShape front;
};

} // gui
} // sl

#endif // SL_GUI_BAR_HPP
