#ifndef SL_GUI_DRAWABLECONTAINER_HPP
#define SL_GUI_DRAWABLECONTAINER_HPP

#include <SFML/Graphics.hpp>

#include "Engine/Graphics/Drawable.hpp"
#include "Engine/GUI/GUIWidget.hpp"
#include "Utility/Memory.hpp"

namespace sl
{
namespace gui
{

//class Drawable;

class DrawableContainer : public GUIWidget
{
public:
	DrawableContainer(const Rect<int>& box, Drawable *nonOwningDrawable);

	DrawableContainer(const Rect<int>& box, std::unique_ptr<Drawable> drawable = nullptr);

	void setDrawable(std::unique_ptr<Drawable> drawable);

	Drawable* getDrawable() const;

private:
	/*		GUIWidget private methods		*/
	void onDraw(sf::RenderTarget& target) const override;

	void onUpdate(int x, int y) override;

	std::unique_ptr<Drawable> drawable;
	Drawable *nonOwningDrawable;
};

} // gui
} // sl

#endif // SL_GUI_DRAWABLECONTAINER_HPP
