/**
 * A separate moveable floating window that wraps another widget
 * and has a X-button / etc
 */
#ifndef SL_GUI_FLOATINGWINDOW_HPP
#define SL_GUI_FLOATINGWINDOW_HPP

#include "Engine/GUI/GUIWidget.hpp"

namespace sl
{
namespace gui
{

class TextLabel;

class FloatingWindow : public GUIWidget
{
public:
	/**
	 * @param window The widget to wrap in a floating window
	 */
	FloatingWindow(std::unique_ptr<GUIWidget> window);

	void setTitle(const std::string& title);

private:

	void onSceneEnter() override;

	void onClick(int mouseX, int mouseY);


	//! Where the user clicked on the title bar
	Vector2i clickedPos;
	//! Whether the user is moving the window (by dragging the title bar)
	bool isMoving;
	TextLabel *titleLabel;
};

} // gui
} // sl

#endif // SL_GUI_FLOATINGWINDOW_HPP
