#ifndef SL_GUI_FONTMANAGER_HPP
#define SL_GUI_FONTMANAGER_HPP

#include <SFML/Graphics/Font.hpp>

#include "Engine/Graphics/SpriteFont.hpp"

namespace sl
{
namespace gui
{

class FontManager
{
public:
	static void create();

	static void destroy();

	static const sf::Font& getFont(const std::string& name);

	static const SpriteFont* getSpriteFont(const std::string& name);
	
private:
	FontManager() {}
	~FontManager() {}
	
	std::map<std::string, sf::Font> fonts;
	
	std::map<std::string, SpriteFont> spriteFonts;

	static FontManager *instance;
};

} // gui
} // sl

#endif // SL_GUI_FONTMANAGER_HPP