#ifndef SL_GUI_NOBACKGROUND_HPP
#define SL_GUI_NOBACKGROUND_HPP

#include "Engine/GUI/WidgetBackground.hpp"
#include "Utility/Memory.hpp"

namespace sl
{
namespace gui
{

class NoBackground : public WidgetBackground
{
public:
	NoBackground();
	/*		WidgetBackground public methods		*/
	void draw(sf::RenderTarget& target) const override;

	std::unique_ptr<WidgetBackground> clone() const override;

private:
	/*		WidgetBackground private methods	*/
	void move(int x, int y) override;

	void setSize(int width, int height) override;

};

} // gui
} // sl

#endif // SL_GUI_NOBACKGROUND_HPP