#ifndef SL_GUI_NORMALBACKGROUND_HPP
#define SL_GUI_NORMALBACKGROUND_HPP

#include <SFML/Graphics/Color.hpp>
#include <SFML/Graphics/Vertex.hpp>
#include "Engine/GUI/WidgetBackground.hpp"
#include "Utility/Rect.hpp"
#include "Utility/Memory.hpp"

namespace sl
{
namespace gui
{

class NormalBackground : public WidgetBackground
{
public:
	NormalBackground(const sf::Color& background, const sf::Color& outline);
	
	NormalBackground(const sf::Color& topleft, const sf::Color& topright, const sf::Color& bottomleft, const sf::Color& bottomright, const sf::Color& outline);

	/*		WidgetBackground public methods		*/
	void draw(sf::RenderTarget& target) const override;

	std::unique_ptr<WidgetBackground> clone() const override;

private:
	//NormalBackground(const NormalBackground& other);
	/*		WidgetBackground private methods	*/
	void move(int x, int y) override;

	void setSize(int width, int height) override;


	sf::Vertex corners[4];
	sf::Vertex outline[5];
	Rect<int> box;
};

} // gui
} // sl

#endif // SL_GUI_NORMALBACKGROUND_HPP