#ifndef SL_GUI_SLIDER_HPP
#define SL_GUI_SLIDER_HPP

#include "Engine/GUI/GUIWidget.hpp"

namespace sl
{
namespace gui
{

class Slider : public GUIWidget
{
public:
	Slider(const Rect<int>& bounds, int minValue, int maxValue, int increment = 1);

	int getValue() const;

	void setValue(int val);

private:
	void onDraw(sf::RenderTarget& target) const override;

	void onUpdate(int x, int y) override;

	void onMouseDown(int x, int y);

	

	int minValue;
	int maxValue;
	int increment;

	int value;

	sf::CircleShape circle;
	sf::RectangleShape bar;
};

} // gui
} // sl

#endif // SL_GUI_SLIDER_HPP