#ifndef SL_GUI_WIDGETBACKGROUND_HPP
#define SL_GUI_WIDGETBACKGROUND_HPP

#include <SFML/Graphics/RenderTarget.hpp>
#include "Utility/Memory.hpp"

namespace sl
{
namespace gui
{

class WidgetBackground
{
public:
	virtual ~WidgetBackground() {}

	virtual void draw(sf::RenderTarget& target) const = 0;

	virtual void move(int x, int y) = 0;

	virtual std::unique_ptr<WidgetBackground> clone() const = 0;
protected:
	WidgetBackground() {}

private:
	virtual void setSize(int width, int height) = 0;

	friend class GUIWidget;
};

} // gui
} // sl

#endif // SL_GUI_WIDGETBACKGROUND_HPP
