#include "Engine/Graphics/Drawable.hpp"

#include "Utility/Assert.hpp"

namespace sl
{

int Drawable::depthConflictCounter = 0;

Drawable::Drawable()
	:depthConflictPower(depthConflictCounter++)
	,height(0)
	,depth(0)
	,bottomPointOffset(0)
{
}

Drawable::~Drawable()
{
}


int Drawable::getDepth() const
{
	return depth;
}

void Drawable::setDepth(int depth)
{
	this->depth = depth;
}

float Drawable::getAnimationSpeed() const
{
	return 0;
}

void Drawable::setAnimationSpeed(float animationSpeed)
{
	//	more nothing...
}

bool Drawable::isDone() const
{
	return false;
}

void Drawable::rotate(float newRotation)
{
	ERROR("Drawble::rotate() not implemented");
}

void Drawable::setColor(const sf::Color& color)
{
	ERROR("Drawable::setColor() not implemented");
}


void Drawable::setHeight(int height)
{
	this->height = height;
}

int Drawable::getHeight() const
{
	return height;
}

int Drawable::getDepthConflictPower() const
{
	return depthConflictPower;
}

void Drawable::setBottomPointOffset(int offset)
{
	bottomPointOffset = offset;
}

int Drawable::getBottomPointOffset() const
{
	return bottomPointOffset;
}

void Drawable::serializeDrawable(Serialize& out) const
{
	SAVEVAR(i, height);
	SAVEVAR(i, depth);
	SAVEVAR(i, bottomPointOffset);
}

void Drawable::deserializeDrawable(Deserialize& in)
{
	LOADVAR(i, height);
	LOADVAR(i, depth);
	LOADVAR(i, bottomPointOffset);
}

} // sl