//  right now this just wraps sf::RenderTarget
//  so make this do actual stuff when we switch over to SDL
#ifndef SL_RENDERTARGET_HPP
#define SL_RENDERTARGET_HPP

#include <SFML/Graphics.hpp>
#include <vector>
#include <tuple>
#include "Engine/Graphics/Drawable.hpp"

namespace sl
{

class RenderTarget
{
public:
	RenderTarget(sf::RenderTarget& target);


	void draw(const sf::Drawable& drawable, const sf::RenderStates& renderState = sf::RenderStates::Default);
	
	void draw(const sf::Vertex *vertices, unsigned int vertexCount, sf::PrimitiveType type);

	void draw(const Drawable& drawable);

	void render();

	sf::RenderTarget& getSFMLTarget();
//#ifndef SL_DEBUG
private:
//#endif
	sf::RenderTarget& target;
	std::vector<const Drawable*> drawQueue;
	std::vector<std::pair<const sf::Drawable*, sf::RenderStates>> sfDrawQueue;
	std::vector<std::tuple<const sf::Vertex *, unsigned int, sf::PrimitiveType> > sfDrawVectorQueue;
};

}

#endif
