#ifndef SL_SPRITEFONT_HPP
#define SL_SPRITEFONT_HPP

#include <SFML/Graphics/Sprite.hpp>

#include <string>

#include "Engine/Graphics/Texture.hpp"

namespace sl
{

class SpriteFont
{
public:
	SpriteFont(const std::string& fname, int charWidth, int charHeight, int vSpace, int hSpace, int specialCount, std::map<char, int>&& yOffsets);

	class Writer
	{
	public:
		Writer(const SpriteFont& font, float scalar = 1.f, const sf::Color& color = sf::Color::White);

		
		const sf::Sprite& getChar(char c, const sf::Vector2f& pos) const;
		
	private:
		const SpriteFont& font;
	};

	class RainbowWriter
	{
	public:
		RainbowWriter(const SpriteFont& font, float scalar = 1.f);

		const sf::Sprite& getChar(char c, const sf::Vector2f& pos) const;

	private:
		const SpriteFont& font;
		std::vector<sf::Color> colours;
		mutable std::vector<sf::Color>::const_iterator it;
	};

	int getSymbolWidth() const;

	int getSymbolHeight() const;

private:

	const sf::Sprite& getCharImpl(char c, const sf::Vector2f& pos) const;


	int charWidth;
	int charHeight;
	int vSpace;
	int hSpace;
	int specialCount;
	Texture texture;
	mutable sf::Sprite sprite;
	int tilesAcross;
	std::map<char, int> yOffsets;
};

} // sl

#endif // SL_SPRITEFONT_HPP