#ifndef SL_KEY_HPP
#define SL_KEY_HPP

#include <cstdint>

namespace sl
{

enum class Key
{
	// Movement
	MoveLeft = 0,
	MoveRight,
	MoveUp,
	MoveDown,
	Sprint,
	Sneak,

	// Overworld Actions
	Interact,
	UseItem,
	CycleCallout,
	ActionChooser,

	// Driving
	ExitCar,
	Brake,
	Accelerate,
	Reverse,
	SteerLeft,
	SteerRight,
	Cruise,
	Autopilot, // REMOVE after testing

	// HUD stuff
	Pause,
	OpenInventory,
	ToggleHud,
	ToggleMap,

	// GUI
	GUIClick,
	GUIRightClick,
	GUIUp,
	GUIDown,
	GUIBack,
	GUIAccept,
	GUILeft,
	GUIRight
};

typedef uint64_t CustomAction;
static constexpr CustomAction NO_CUSTOM_ACTION = 0;

} // sl

#endif // SL_KEY_HPP