#include "Engine/Physics/HeightMap.hpp"

namespace sl
{

HeightMap::HeightMap(const Rect<int>& bounds)
	:bounds(bounds)
	,node(*this)
{
}

HeightMap::~HeightMap()
{
}

const Rect<int>& HeightMap::getBounds() const
{
	return bounds;
}

IntrusiveListNode<HeightMap>& HeightMap::getLink()
{
	return node;
}

void HeightMap::setPos(int x, int y)
{
	bounds.left = x;
	bounds.top = y;
}

void HeightMap::setPos(const Vector2i& vec)
{
	bounds.left = vec.x;
	bounds.top = vec.y;
}

}// sl