#ifndef SL_HEIGHTMAP_HPP
#define SL_HEIGHTMAP_HPP

#include "Utility/Rect.hpp"
#include "Utility/IntrusiveList.hpp"

namespace sl
{

#ifdef SL_DEBUG
class AbstractScene;
class RenderTarget;
#endif

class HeightMap
{
public:
	virtual ~HeightMap();

	virtual bool affects(int x, int y) const = 0;

	virtual int getHeightAt(int x, int y) const = 0;

	virtual int getHeightAt(const Rect<int>& area) const = 0;

	const Rect<int>& getBounds() const;

	IntrusiveListNode<HeightMap>& getLink();

	void setPos(int x, int y);

	void setPos(const Vector2i& vec);

#ifdef SL_DEBUG
	virtual void debugDraw(AbstractScene& scene, RenderTarget& renderTarget) const = 0;
#endif

protected:
	HeightMap(const Rect<int>& bounds);

	Rect<int> bounds;
private:
	IntrusiveListNode<HeightMap> node;
};

} // sl

#endif // SL_HEIGHTMAP_HPP