#ifndef SL_HEIGHTRECT_HPP
#define SL_HEIGHTRECT_HPP

#include "Engine/Physics/HeightMap.hpp"

namespace sl
{

class HeightRect : public HeightMap
{
public:
	HeightRect(const Rect<int>& bounds, int topLeftHeight, int topRightHeight, int bottomLeftHeight, int bottomRightHeight);
	
	HeightRect(const HeightRect& copy);
	
	~HeightRect();

	HeightRect& operator=(const HeightRect& rhs);

	

	bool affects(int x, int y) const override;

	int getHeightAt(int x, int y) const override;

	int getHeightAt(const Rect<int>& area) const override;

#ifdef SL_DEBUG
	void debugDraw(AbstractScene& scene, RenderTarget& renderTarget) const override;
#endif

private:
	int topLeftHeight;
	int topRightHeight;
	int bottomLeftHeight;
	int bottomRightHeight;
};

} // sl

#endif // SL_HEIGHTRECT_HPP