#include "Engine/Refable.hpp"

#include "Utility/Assert.hpp"

namespace sl
{

Refable::Refable()
	:alive(std::make_shared<int>(1))
{
}

Refable::~Refable()
{
	ASSERT(alive && *alive == 1);
	*alive = 0;
}


bool Refable::canDestroy() const
{
	ASSERT(alive && *alive >= 1);
	return *alive == 1;
}

} // sl
