#include "Engine/ScenePos.hpp"

#include "Engine/Entity.hpp"
#include "Engine/Scene.hpp"
#include "Engine/Serialization/Serialization.hpp"

namespace sl
{

ScenePos::ScenePos(const Entity& entity)
	:scene(entity.getScene())
	,pos(entity.getPos())
{
}

/*static*/ScenePos ScenePos::createImpl(Deserialize& in)
{
	Scene *scene = static_cast<Scene*>(in.ptr("scene"));
	const float x = in.f("x");
	const float y = in.f("y");
	return ScenePos(*scene, Vector2f(x, y));
}

// non-member:
namespace AutoSerialize
{
void serialize(Serialize& out, const ScenePos& sp)
{
	out.ptr("scene", sp.getScene());
	out.f("x", sp.getPos().x);
	out.f("y", sp.getPos().y);
}
} // AutoDeserialize

} // sl