/**
 * Assumes you are calling these inside the sl namespace.
 */
#ifndef SL_AUTODECLAREOBJECTSERIALIZATION_HPP
#define SL_AUTODECLAREOBJECTSERIALIZATION_HPP

namespace sl
{
class Deserialize;
class Serialize;
} // sl

#define DEC_SERIALIZE_OBJ(T) namespace AutoDeserialize { \
	void deserialize(Deserialize& in, T& val); \
	} \
	namespace AutoSerialize { \
	void serialize(Serialize& in, const T& val); \
	}
#define DEC_SERIALIZE_OBJ_CTOR(T) namespace AutoDeserialize { \
	void deserialize(Deserialize& in, T& val); \
	template <typename U> U create(Deserialize& in); \
	template <> \
	T create(Deserialize& in); \
	} \
	namespace AutoSerialize { \
	void serialize(Serialize& in, const T& val); \
	}

#endif // SL_AUTODECLAREOBJECTSERIALIZATION_HPP