#ifndef SL_SERIALIZEMATRIX_HPP
#define SL_SERIALIZEMATRIX_HPP

#include "Engine/Serialization/AutoDeserialize.hpp"
#include "Engine/Serialization/AutoSerialize.hpp"
#include "Engine/Serialization/Serialization.hpp"
#include "Utility/Vector.hpp"

namespace sl
{

namespace AutoDeserialize
{
template <typename T>
void deserialize(Deserialize& in, Matrix<T>& mat)
{
	in.startObject("Matrix<T>");
	for (int r = 0; r < mat.getRows(); ++r)
	{
		for (int c = 0; c < mat.getCols(); ++c)
		{
			deserialize(in, mat(r, c));
		}
	}
	in.endObject("Matrix<T>");
}
} // AutoDeserialize

namespace AutoSerialize
{
template <typename T>
void serialize(Serialize& out, const Matrix<T>& mat)
{
	out.startObject("Matrix<T>");
	for (int r = 0; r < mat.getRows(); ++r)
	{
		for (int c = 0; c < mat.getCols(); ++c)
		{
			serialize(out, mat(r, c));
		}
	}
	out.endObject("Matrix<T>");
}
} // AutoSerialize

} // sl

#endif // SL_SERIALIZEMATRIX_HPP