#ifndef SL_SERIALIZEVECTOR_HPP
#define SL_SERIALIZEVECTOR_HPP

#include "Engine/Serialization/AutoDeserialize.hpp"
#include "Engine/Serialization/AutoSerialize.hpp"
#include "Engine/Serialization/Serialization.hpp"
#include "Utility/Vector.hpp"

namespace sl
{

namespace AutoDeserialize
{
template <typename T, unsigned int N>
void deserialize(Deserialize& in, Vector<T, N>& vec)
{
	in.startObject("Vector<T, N>");
	for (int i = 0; i < N; ++i)
	{
		deserialize(in, vec[i]);
	}
	in.endObject("Vector<T, N>");
}
} // AutoDeserialize

namespace AutoSerialize
{
template <typename T, unsigned int N>
void serialize(Serialize& out, const Vector<T, N>& vec)
{
	out.startObject("Vector<T, N>");
	for (int i = 0; i < N; ++i)
	{
		serialize(out, vec[i]);
	}
	out.endObject("Vector<T, N>");
}
} // AutoSerialize

} // sl

#endif // SL_SERIALIZEVECTOR_HPP