#ifndef SL_SETTINGS_HPP
#define SL_SETTINGS_HPP

#include <functional>
#include <map>
#include <string>
#include <vector>

namespace sl
{

class Settings
{
public:
	struct Setting
	{
		Setting(const std::string& name)
			:properName(name)
		{
		}

		std::string properName;
		int value;
		std::function<void(int)> onChange;
		std::function<std::string(int)> name;
		std::function<int(int)> next;
		std::function<int()> begin;
		std::function<int()> end;
	};

	Settings();

	bool exists(const std::string& id) const;

	void createSetting(const std::string& id, const std::string& name, int defaultValue);

	void createSystemSetting(const std::string& id, int value);

	void set(const std::string& id, int value);

	void set(Setting& setting, int value);

	int get(const std::string& id) const;

	const std::map<std::string, Setting>& hackyIterator() const;

	void setOnChangeCallback(const std::string& setting, const std::function<void(int)>& callback);

	void setValuesByRange(const std::string& id, int min, int max, int increment = 1);

	void setValuesCusom(const std::string& id, const std::function<int()>& begin, const std::function<int()>& end, const std::function<int(int)> next = increment);

	void setNameFunc(const std::string& id, const std::function<std::string(int)>& nameFunc);

	const Setting& getSetting(const std::string& setting) const;

	bool save() const;

	bool load();

	// @todo decide whether you want this class to be a singleton or to keep it as a member of Game
	// and have to pass around Game everywhere
	static Settings *fuckYouSingletonHack();

private:

	static int increment(int x);

	static const char *filename;


	std::map<std::string, Setting> settings;

	const std::string systemSettingName;

	static Settings *shittyHackSingleton;
};

} // sl

#endif
