#include "Home/CellDoor.hpp"

#include "Engine/Graphics/Sprite.hpp"
#include "Engine/Serialization/AutoDeserialize.hpp"
#include "Engine/Serialization/AutoSerialize.hpp"
#include "Home/BuildingLevel.hpp"
#include "Home/WallGrid.hpp"
#include "Engine/Scene.hpp"
#include "Engine/Input/Input.hpp"
#include "Engine/GUI/NormalBackground.hpp"
#include "Player/Player.hpp"

namespace sl
{

//CellDoor::CellDoor(DeserializeConstructor)
//	:Entity(0, 0, 32, 40, "CellDoor")
//	,grid(nullptr)
//	,opened(false)
//	,tx(-1)
//	,ty(-1)
//{
//}

CellDoor::CellDoor(int tx, int ty, WallGrid& grid)
	:Entity(tx * grid.getTileSize(), (ty + 1) * grid.getTileSize() - 8, 32, 40, "CellDoor")
	,grid(&grid)
	,opened(false)
	,tx(tx)
	,ty(ty)
{
}

bool CellDoor::isStatic() const
{
	return true;
}

const Entity::Type CellDoor::getType() const
{
	return Entity::makeType("CellDoor");
}

void CellDoor::onUpdate()
{
	// TODO: wtf is this shit? why is this here? why is this not a button callout????????????????
	Player *player = static_cast<Player*>(scene->checkCollision(*this, "Player"));
	if (player)
	{
		if (scene->getPlayerController().pressed(Key::Interact))
		{
			if (opened)
			{
				ASSERT(grid->closeDoorAt(tx, ty));
			}
			else
			{
				ASSERT(grid->openDoorAt(tx, ty));
			}
		}
	}
}

void CellDoor::open()
{
	opened = true;
}

void CellDoor::close()
{
	opened = false;
}

//// private
//void CellDoor::deserialize(Deserialize& in)
//{
//	deserializeEntity(in);
//	AutoDeserialize::fields(in, opened, tx, ty);
//	grid = &const_cast<WallGrid&>(static_cast<BuildingLevel*>(scene)->getWallGrid());
//}
//
//void CellDoor::serialize(Serialize& out) const
//{
//	serializeEntity(out);
//	// no need to store WallGrid, we just get that from our scene
//	AutoSerialize::fields(out, opened, tx, ty);
//}

} // sl
