#ifndef SL_DECORTYPEDATABASE_HPP
#define SL_DECORTYPEDATABASE_HPP

#include "Utility/Assert.hpp"

namespace sl
{

template <typename T>
class DecorTypeDatabase
{
public:
	void set(typename T::ID id, const typename T::Definition& info);

	const typename T::Definition& get(typename T::ID id) const;

private:
	typename T::Definition definitions[T::IDCount];
};

template <typename T>
void DecorTypeDatabase<T>::set(typename T::ID id, const typename T::Definition& info)
{
	ASSERT(static_cast<int>(id) >= 0 && static_cast<int>(id) < T::IDCount);
	definitions[static_cast<int>(id)] = info;
}

template <typename T>
const typename T::Definition& DecorTypeDatabase<T>::get(typename T::ID id) const
{
	ASSERT(static_cast<int>(id) >= 0 && static_cast<int>(id) < T::IDCount);
	return definitions[static_cast<int>(id)];
}

} // sl

#endif
