#ifndef SL_DUNGEONOBJECTDATABASE_HPP
#define SL_DUNGEONOBJECTDATABASE_HPP

#include <map>
#include <string>
#include <vector>

#include "NPC/Stats/ColorPref.hpp"

namespace sl
{

class DungeonObjectDatabase
{
public:
	class Entry
	{
	public:
		std::vector<std::string> representations;
		std::string desc;
		float style[3];
		enum Style
		{
			GIRLY = 0, // Boyish (-1) to Girly (1)
			FANCY,     // Ghetto (-1) to Fancy (1)
			COMFY,     // Cold   (-1) to Comfy (1)

			STYLE_COUNT
		};
		ColorPref color;
		int cost;
	};
	typedef std::map<std::string, Entry> Data;

	
	Data::const_iterator begin() const;

	Data::const_iterator end() const;

	int size() const;


	static DungeonObjectDatabase& get();

private:
	DungeonObjectDatabase();

	void load();


	Data data;
};

} // sl

#endif // SL_DUNGEONOBJECTDATABASE_HPP