#include "Home/FloorType.hpp"

#include "Utility/Assert.hpp"

namespace sl
{

FloorType::Definition::Definition()
	:fname("invalid")
	,previewFilename(fname)
	,cost(-1)
	,style(DecorStyle::Girly)
{
}

FloorType::Definition::Definition(const std::string& fname, int cost, DecorStyle style)
	:fname("tiles/" + fname + ".png")
	,previewFilename(this->fname)
	,cost(cost)
	,style(style)
{
}






FloorType::FloorType()
	:database(nullptr)
	,id(FloorType::ID::Concrete)
{
}

FloorType::FloorType(const DecorTypeDatabase<FloorType>& database, ID id)
	:database(&database)
	,id(id)
{
}

const FloorType::Definition& FloorType::info() const
{
	ASSERT(database != nullptr);
	return database->get(id);
}

bool FloorType::isValid() const
{
	return database != nullptr;
}

FloorType::ID FloorType::getID() const
{
	return id;
}

void FloorType::setID(ID id)
{
	this->id = id;
}

} // sl