#ifndef SL_FLOORTYPE_HPP
#define SL_FLOORTYPE_HPP

#include <string>

#include "Home/DecorStyle.hpp"
#include "Home/DecorTypeDatabase.hpp"

namespace sl
{

class FloorType
{
public:
	enum class ID
	{
		Concrete = 0,
		Girly,
		MaroonCarpet,
		Tiles,
		Dirt,
		Grass,
		Hardwood,
		Marble,
		Sand,
		FlowerCarpet
	};
	static const int IDCount = 10;

	class Definition
	{
	public:
		Definition();

		Definition(const std::string& fname, int cost, DecorStyle style);


		std::string fname;
		std::string previewFilename;
		int cost;
		DecorStyle style;
	};

	FloorType();

	FloorType(const DecorTypeDatabase<FloorType>& database, ID id);


	const Definition& info() const;

	bool isValid() const;

	ID getID() const;

	void setID(ID id);


private:

	const DecorTypeDatabase<FloorType> *database;
	ID id;
};

} // sl

#endif