#include "Home/Furniture.hpp"

#include "Engine/Door.hpp"
#include "Engine/Graphics/Sprite.hpp"
#include "Pathfinding/NodeID.hpp"
#include "Engine/Physics/HeightRect.hpp"
#include "Town/StaticGeometry.hpp"

namespace sl
{

void createStairsUpLeft(const Vector2f& pos,  Scene& scene, const Vector2f& target, Scene& targetScene, StorageType storageType)
{
	//Drawable *sprite = new Sprite("stairs_up_left.png", 0, 38);
	//sprite->setBottomPointOffset(-23);
	//scene.addImmediately(new StaticGeometry(pos.x, pos.y + 6, 27, 3, {sprite}), storageType);
	//scene.addAdditiveHeightMap(new HeightRect(Rect<int>(pos.x, pos.y + 8, 27, 24), 18, 0, 18, 0));
	const int middleOfEntranceX = (pos.x) / scene.getTileSize();
	const int middleOfEntranceY = (pos.y) / scene.getTileSize();
	pf::NodeID entranceNode(middleOfEntranceX, middleOfEntranceY, &scene);
	pf::NodeID exitNode(target.x / targetScene.getTileSize(), target.y / targetScene.getTileSize(), &targetScene);
	scene.addImmediately(new Door(pos + Vector2f(11, 2), 4, 12, target, &targetScene, entranceNode, exitNode), storageType);
}

void createStairsDownLeft(const Vector2f& pos,  Scene& scene, const Vector2f& target, Scene& targetScene, StorageType storageType)
{
	//Drawable *sprite = new Sprite("stairs_down_left.png", 0, 5);
	//sprite->setBottomPointOffset(-28);
	//scene.addImmediately(new StaticGeometry(pos.x, pos.y + 5, 27, 3, {sprite}), storageType);
	//scene.addSubtractiveHeightMap(new HeightRect(Rect<int>(pos.x, pos.y + 8, 27, 24), -18, 0, -18, 0));
	const int middleOfEntranceX = (pos.x) / scene.getTileSize();
	const int middleOfEntranceY = (pos.y) / scene.getTileSize();
	pf::NodeID entranceNode(middleOfEntranceX, middleOfEntranceY, &scene);
	pf::NodeID exitNode(target.x / targetScene.getTileSize(), target.y / targetScene.getTileSize(), &targetScene);
	scene.addImmediately(new Door(pos + Vector2f(0, 2), 4, 12, target, &targetScene, entranceNode, exitNode), storageType);
}

} // sl
