#include "Home/FurnitureType.hpp"

#include "Utility/Assert.hpp"

namespace sl
{

FurnitureType::Definition::Definition()
	:fname("invalid")
	,previewFilename(fname)
	,cost(-1)
	,style(DecorStyle::Girly)
	,offset()
{
}

FurnitureType::Definition::Definition(const std::string& fname, int cost, DecorStyle style, const Vector2f& offset)
	:fname("furniture/" + fname + ".png")
	,previewFilename("furniture/" + fname + ".png")
	,cost(cost)
	,style(style)
	,offset(offset)
{
}





FurnitureType::FurnitureType()
	:database(nullptr)
	,id(FurnitureType::ID::Bookcase)
{
}

FurnitureType::FurnitureType(const DecorTypeDatabase<FurnitureType>& database, ID id)
	:database(&database)
	,id(id)
{
}

const FurnitureType::Definition& FurnitureType::info() const
{
	ASSERT(database != nullptr);
	return database->get(id);
}

bool FurnitureType::isValid() const
{
	return database != nullptr;
}

FurnitureType::ID FurnitureType::getID() const
{
	return id;
}

void FurnitureType::setID(ID id)
{
	this->id = id;
}


} // sl
