#ifndef SL_FURNITURETYPE_HPP
#define SL_FURNITURETYPE_HPP

#include <string>

#include "Home/DecorStyle.hpp"
#include "Home/DecorTypeDatabase.hpp"
#include "Utility/Vector.hpp"

namespace sl
{

class FurnitureType
{
public:
	enum class ID
	{
		Bookcase,
		Computer,
		GirlyBed,
		DirtyBed,
		PlainBigBed,
		FlowerBed,
		Nightstand,
		GirlyDesk,
		GirlyBeanBag,
		TV,
		HDTV
	};
	static const int IDCount = 11;

	class Definition
	{
	public:
		Definition();

		Definition(const std::string& fname, int cost, DecorStyle style, const Vector2f& offset);

		std::string fname;
		std::string previewFilename;
		int cost;
		DecorStyle style;
		Vector2f offset;
	};

	FurnitureType();

	FurnitureType(const DecorTypeDatabase<FurnitureType>& database, ID id);


	const Definition& info() const;

	bool isValid() const;

	ID getID() const;

	void setID(ID id);


private:

	const DecorTypeDatabase<FurnitureType> *database;
	ID id;
};

} // sl

#endif // SL_FURNITURETYPE_HPP
