#include "Home/Internet/Computer.hpp"

#include "Engine/Graphics/Sprite.hpp"
#include "Engine/Scene.hpp"
#include "Engine/Input/Input.hpp"
#include "Engine/GUI/NormalBackground.hpp"
#include "Player/Player.hpp"

namespace sl
{

Computer::Computer(int x, int y)
	:Entity(x, y, 32, 24, "Computer")
	//,internet()
	,inUse(false)
{
}

bool Computer::isStatic() const
{
	return true;
}

const Entity::Type Computer::getType() const
{
	return Entity::makeType("Computer");
}

void Computer::shutdown()
{
	inUse = false;
}

void Computer::onUpdate()
{
	// TODO: reneable
	//if (inUse)
	//{
	//	if (!internet)
	//	{
	//		internet.setHandle(std::make_unique<Internet>(Rect<int>(400, 300), *this));
	//		internet.setScene(scene);
	//	}
	//	if (!internet.isEnabled())
	//	{
	//		internet.enable();
	//		internet->visitPage("home");//"en.wikipedia.org/wiki/SimLoli");
	//	}
	//}
	//else
	//{
	//	internet.disable();
	//	Player *player = (Player*)scene->checkCollision(*this, "Player");
	//	if (player)
	//	{
	//		player->addActionCallout(Player::CalloutType::Use, "Use computer", [this] {
	//			inUse = true;
	//		}, this);
	//	}
	//}
	//if (internet)
	//{
	//	internet->update((512 - 400) / 2, (384 - 300) / 2);
	//}
}

void Computer::deserialize(Deserialize& in)
{
	deserializeEntity(in);
	LOADVAR(b, inUse);
}

void Computer::serialize(Serialize& out) const
{
	ASSERT(!inUse);
	serializeEntity(out);
	SAVEVAR(b, inUse);
}

}
