#include "Home/Internet/Website.hpp"

namespace sl
{

Website::Website(std::function<gui::GUIWidget*()> createFunction, const std::string url)
	:creator(createFunction)
	,tags()
	,url(url)
{
}

void Website::addTags(const std::initializer_list<std::string>& tags)
{
	for (const std::string& tag : tags)
	{
		this->tags.insert(tag);
	}
}
	
gui::GUIWidget* Website::visit()
{
	return creator();
}

const std::string& Website::getURL() const
{
	return url;
}

int Website::getRelevancy(const std::initializer_list<std::string>& tags) const
{
	int relevancy = 0;
	for (const std::string& wantedTag : tags)
	{
		if (this->tags.count(wantedTag))
		{
			++relevancy;
		}
	}
	return relevancy;
}

} // sl