#ifndef SL_WEBSITE_HPP
#define SL_WEBSITE_HPP

#include <functional>
#include <initializer_list>
#include <set>
#include <string>

#include "Engine/GUI/GUIWidget.hpp"

namespace sl
{

class Website
{
public:
	Website(std::function<gui::GUIWidget*()> createFunction, const std::string url);

	void addTags(const std::initializer_list<std::string>& tags);
	
	gui::GUIWidget* visit();


	const std::string& getURL() const;
	
	int getRelevancy(const std::initializer_list<std::string>& tags) const;

private:
	std::function<gui::GUIWidget*()> creator;
	std::set<std::string> tags;
	std::string url;
};

} // sl

#endif // SL_WEBSITE_HPP