//#include "Home/Internet/Wiki.hpp"
//
//#include <SFML/Graphics/Text.hpp>
//
//#include "Engine/GUI/Button.hpp"
//#include "Engine/GUI/FontManager.hpp"
//#include "Engine/GUI/NormalBackground.hpp"
//#include "Engine/GUI/TextLabel.hpp"
//#include "Home/Internet/Hyperlink.hpp"
//#include "Home/Internet/Internet.hpp"
//#include "Utility/StringUtil.hpp"
//
//namespace sl
//{
//
//Wiki::Wiki(Internet& internet)
//	:internet(internet)
//{
//	page.reset(new gui::GUIWidget(Rect<int>(384, 900)));
//}
//
//Wiki::~Wiki()
//{
//}
//
//template <typename T, typename... Args>
//void Wiki::addParagraph(const T& head, Args&&... tail)
//{
//	sf::Text renderText("", gui::FontManager::getFont("resources/arial.ttf"), 12);
//	ParagraphMetadata metadata(renderText);
//	addParagraphHelper(metadata, head, std::forward<Args>(tail)...);
//}
//
//
//template <typename T, typename... Args>
//void Wiki::addParagraphHelper(ParagraphMetadata& metadata, const T& head, Args&&... tail)
//{
//	addParagraphComponent(metadata, head);
//	addParagraphHelper(metadata, std::forward<Args>(tail)...);
//}
//
//template <typename T>
//void Wiki::addParagraphHelper(ParagraphMetadata& metadata, const T& head)
//{
//	addParagraphComponent(metadata, head);
//}
//
//template <>
//void Wiki::addParagraphComponent<Wiki::Link>(ParagraphMetadata& metadata, const Link& link)
//{
//	page->addWidget(addText(metadata, link.text, link.target.c_str()));
//}
//
//template <typename T>
//void Wiki::addParagraphComponent(ParagraphMetadata& metadata, const T& component)
//{
//	std::stringstream ss;
//	ss << component;
//	page->addWidget(addText(metadata, ss.str()));
//}
//
//std::unique_ptr<gui::GUIWidget> Wiki::addText(ParagraphMetadata& metadata, const std::string& text, const char *target) const
//{
//	std::vector<std::string> words;
//	splitBy(words, text, ' ');
//	int wordLength = 0;
//	std::string buffer;
//	std::unique_ptr<Hyperlink> hyperlink;
//	if (target)
//	{
//		hyperlink = unique<Hyperlink>(internet, sf::Color::Magenta, sf::Color::Blue);
//	}
//	for (const std::string& word : words)
//	{
//		//	sum up the space used to write each word (including kerning)
//		wordLength = metadata.font->getGlyph(word[0], metadata.fontSize, false).advance;
//		for (int i = 1; i < word.length(); ++i)
//		{
//			wordLength += metadata.font->getGlyph(word[i], metadata.fontSize, false).advance + metadata.font->getKerning(word[i - 1], word[i], metadata.fontSize);
//		}
//
//		if (metadata.lineWidth == 0)
//		{
//			buffer += word;
//			metadata.lineWidth += wordLength;
//		}
//		else
//		{
//			if (metadata.lineWidth + metadata.spaceSize + wordLength > page->getBox().width)
//			{
//				if (target)
//				{
//					hyperlink->addLinkComponent(metadata.lineWidth, metadata.y, buffer, target);
//					buffer.clear();
//				}
//				else
//				{
//					buffer += '\n';
//				}
//				metadata.lineWidth = metadata.spaceSize + wordLength;
//				metadata.y += metadata.fontSize * 2;//metadata.font->getGlyph('T', metadata.fontSize, false).bounds.height;
//			}
//			else
//			{
//				buffer += ' ';
//				metadata.lineWidth += metadata.spaceSize;
//			}
//			buffer += word;
//			metadata.lineWidth += wordLength;
//		}
//	}
//	if (target)
//	{
//		hyperlink->addLinkComponent(metadata.lineWidth, metadata.y, buffer, target);
//		buffer.clear();
//		return std::move(hyperlink);
//	}
//	Rect<int> box(metadata.lineWidth, metadata.y, 384, 900);
//	std::unique_ptr<gui::TextLabel> textLabel(new gui::TextLabel(box, buffer, gui::TextLabel::Left, gui::TextLabel::Top, 0, 0));
//	textLabel->extendVerticallyToFitText();
//	return std::move(textLabel);
//}
//
//gui::GUIWidget* Wiki::create()
//{
//	gui::TextLabel *pageText = new gui::TextLabel(Rect<int>(384, 640), text.str(), gui::TextLabel::Left, gui::TextLabel::Top, 32, 32);
//	pageText->setColour(sf::Color::Black);
//	page->addWidget(std::unique_ptr<gui::GUIWidget>(pageText));
//	page->applyBackground(gui::NormalBackground(sf::Color(222, 222, 222), sf::Color::Red));
//	return page.release();
//}
//
//
//Wiki::ParagraphMetadata::ParagraphMetadata(const sf::Text& text)
//	:font(text.getFont())
//	,fontSize(text.getCharacterSize())
//	,lineWidth(0)
//	,spaceSize(font->getGlyph(' ', fontSize, false).advance)
//	,y(0)
//{
//}
//
//
////-----------------------------------------------------------------------------
////--------------------  Specific Page Creation Functions  ---------------------
//
//gui::GUIWidget* Wiki::testPage(Internet *internet)
//{
//	Wiki wiki(*internet);
//
//	wiki.addParagraph(Link("I am a hyperlink.", "home"));
//	wiki.addParagraph("This is some sample text. ", Link("And here's a link to /jp/!", "boards.4chan.org/jp/"), " And here's some more.");
//
//	return wiki.create();
//}
//
//gui::GUIWidget* Wiki::loliblog(Internet *internet)
//{
//	Wiki wiki(*internet);
//
//	wiki.addParagraph(Link("I am a hyperlink.", "home"));
//	wiki.addParagraph("December 27th, 2014");
//	wiki.addParagraph("Today I saw a really");
//
//	return wiki.create();
//}
//
//} // sl
