#ifndef SL_OPENABLEDOOR_HPP
#define SL_OPENABLEDOOR_HPP

#include "Engine/Entity.hpp"

namespace sl
{

class StaticGeometry;

class OpenableDoor : public Entity
{
public:
	DECLARE_SERIALIZABLE_METHODS(OpenableDoor)
	enum class DoorType
	{
		Regular,
		SlidingBookcase
	};
	OpenableDoor(int x, int y, DoorType type);

	~OpenableDoor();

	bool isStatic() const override;

	const Type getType() const override;

	void open();

	void close();


private:

	void onEnter() override;

	void onExit() override;

	void onUpdate() override;


	//! Whether the door is open or not
	bool opened;
	DoorType type;
	IntrusiveMultiList<Entity> geo;
};

} // sl

#endif // SL_OPENABLEDOOR_HPP