
#ifndef SL_ROOMDOOR_HPP
#define SL_ROOMDOOR_HPP

#include "Utility/Vector.hpp"

namespace sl
{

class CellDoor;

class WallGrid;

class RoomDoor
{
public:
	enum class Orientation
	{
		North = 0,
		South,
		West,
		East
	};

	RoomDoor(RoomDoor&& other);

	RoomDoor(const Vector2i& position, Orientation orientation, WallGrid *grid);

	~RoomDoor();

	RoomDoor& operator=(RoomDoor&& rhs);

	unsigned int x() const;

	unsigned int y() const;

	bool isOpen() const;

	Orientation getOrientation() const;

	void open();

	void close();

	
private:
	RoomDoor(const RoomDoor&);
	RoomDoor& operator=(const RoomDoor&);



	Vector2i position;
	bool opened;
	Orientation orientation;
	CellDoor *cellDoor;
};

} // sl

#endif // SL_ROOMDOOR_HPP