#include "Home/WallType.hpp"

#include "Utility/Assert.hpp"

namespace sl
{

WallType::Definition::Definition()
	:fname("invalid")
	,previewFilename(fname)
	,cost(-1)
	,style(DecorStyle::Girly)
{
}

WallType::Definition::Definition(const std::string& fname, int cost, DecorStyle style)
	:fname(fname)
	,previewFilename("walls/" + fname + "/top.png")
	,cost(cost)
	,style(style)
{
}





WallType::WallType()
	:database(nullptr)
	,id(WallType::ID::Concrete)
{
}

WallType::WallType(const DecorTypeDatabase<WallType>& database, ID id)
	:database(&database)
	,id(id)
{
}

const WallType::Definition& WallType::info() const
{
	ASSERT(database != nullptr);
	return database->get(id);
}

bool WallType::isValid() const
{
	return database != nullptr;
}

WallType::ID WallType::getID() const
{
	return id;
}

void WallType::setID(ID id)
{
	this->id = id;
}


} // sl