#ifndef SL_WALLTYPE_HPP
#define SL_WALLTYPE_HPP

#include <string>

#include "Home/DecorStyle.hpp"
#include "Home/DecorTypeDatabase.hpp"

namespace sl
{

class WallType
{
public:
	enum class ID
	{
		Concrete = 0,
		Girly,
		Yellow,
		Lewd,
		Redwood,
		Brick
	};
	static const int IDCount = 6;

	class Definition
	{
	public:
		Definition();

		Definition(const std::string& fname, int cost, DecorStyle style);

		std::string fname;
		std::string previewFilename;
		int cost;
		DecorStyle style;
	};

	WallType();

	WallType(const DecorTypeDatabase<WallType>& database, ID id);


	const Definition& info() const;

	bool isValid() const;

	ID getID() const;

	void setID(ID id);


private:

	const DecorTypeDatabase<WallType> *database;
	ID id;
};

} // sl

#endif