#ifndef SL_HOTBAR_HPP
#define SL_HOTBAR_HPP

#include "Items/Inventory.hpp"

#include <list>

namespace sl
{

class Hotbar
{
public:
	Hotbar(Inventory& inventory);

	void addItem(Inventory::ItemRef item);

	void removeItem(Inventory::ItemRef item);

	void cycleSelected(int offset);

	const Inventory::ItemRef* getSelected(int offset = 0) const;

	const Inventory::ItemRef* get(int index) const;

	int getSize() const;

private:
	static const int MAX_SIZE = 5;
	
	Inventory& inventory;
	std::list<Inventory::ItemRef> equipped;
	int selectedIndex;
};

} // s;

#endif // SL_HOTBAR_HPP