#ifndef SL_ITEMTODRAWABLES_HPP
#define SL_ITEMTODRAWABLES_HPP

#include "Engine/GUI/GUIWidget.hpp"
#include "Items/Item.hpp"

#include <memory>

namespace sl
{

extern std::unique_ptr<Drawable> itemToDrawable(Item::Type type, bool center);

extern std::unique_ptr<gui::GUIWidget> itemToGUI(Item::Type type);

// Creates a CENTERED Drawable inside a DrawableContainer, with a background applied
class ItemToBoxedGUI
{
public:
	ItemToBoxedGUI(const Rect<int>& bounds);

	std::unique_ptr<gui::GUIWidget> operator()(Item::Type type) const;

private:
	Rect<int> bounds;
};

} // sl

#endif // SL_ITEMTODRAWABLES_HPP