#include "Items/ItemUseActionFactory.hpp"

#include "Items/Item.hpp"
#include "Items/SubdueUseAction.hpp"

namespace sl
{

std::vector<std::unique_ptr<ItemUseAction>> makeItemuseActions(Item& item)
{
	std::vector<std::unique_ptr<ItemUseAction>> actions;
	if (item.getSubdueStats())
	{
		actions.push_back(std::make_unique<SubdueUseAction>(item));
	}
	return std::move(actions);
}

} // sl