#include "Items/SubdueUseAction.hpp"

#include "Items/Item.hpp"
#include "Utility/Assert.hpp"

namespace sl
{

SubdueUseAction::SubdueUseAction(Item& item)
	:item(item)
{
}

bool SubdueUseAction::canUse(const NPC& npc) const
{
	return !item.hasUses() || item.getUses() > 0;
}

ItemUseAction::UseResult SubdueUseAction::use(NPC& targetNPC)
{
	if (time == 0)
	{
		item.setUses(item.getUses() - 1);
	}
	if (++time >= item.getSubdueStats()->timer)
	{
		time = 0;
		return UseResult::Success;
	}
	// TODO: possible escape
	return UseResult::InProgress;
}

} // sl