#include "Items/ThrowItemAction.hpp"

#include "Items/Item.hpp"
#include "Utility/Assert.hpp"

namespace sl
{

ThrowItemAction::ThrowItemAction(Item& item)
	:item(item)
{
}

bool ThrowItemAction::canUse(const NPC& npc) const
{
	return !item.hasUses() || item.getUses() > 0;
}

ItemUseAction::UseResult ThrowItemAction::use(NPC& targetNPC)
{
	return UseResult::Success;
}

} // sl