#ifndef SL_GAMEOVER_HPP
#define SL_GAMEOVER_HPP

#include "Engine/AbstractScene.hpp"
#include "Engine/GUI/WidgetHandle.hpp"

namespace sl
{

class PlayerStats;
class World;

class GameOver : public AbstractScene
{
public:
	GameOver(Game *game, World *world, const PlayerStats& playerStats);


private:
	enum class SubMenu
	{
		Main,
		Crimes
	};

	const sf::Vector2f getView() const override;

	void onUpdate(Timestamp timestamp) override;

	void onDraw(RenderTarget& target) override;

	void changeSubMenu(SubMenu subMenu);

	void exit();

	
	World *world;
	const PlayerStats& playerStats;
	SubMenu subMenu;
	gui::WidgetHandle<gui::GUIWidget> widget;
	std::unique_ptr<gui::GUIWidget> deleteNextStep;
};

} // sl

#endif // SL_GAMEOVER_HPP