#ifndef SL_GUI_HUD_HPP
#define SL_GUI_HUD_HPP

#include "Engine/GUI/GUIWidget.hpp"
#include "Town/Map/MapGUI.hpp"

namespace sl
{

class PlayerStats;

namespace map
{
class Map;
} // map

namespace gui
{
class Bar;
class DrawableContainer;
class TextLabel;

class HUD : public GUIWidget
{
public:
	HUD(const PlayerStats& stats);

	void toggleMapMode();

private:
	void refreshMapGUI();

	void onUpdate(int x, int y) override;

	void onSceneEnter() override;

	void onSceneExit() override;

	void makeHotbar();

	TextLabel *time;
	const PlayerStats& stats;
	Bar *hpBar;
	Bar *staminaBar;
	GUIWidget *hotbar;
	GUIWidget *mapWidget;
	map::Map *map;
	//MapGUI *mapGUI;
	enum class MapMode
	{
		Disabled,
		Minimap,
		Map
	};
	MapMode mapMode;
	//! Last action we saw here. This is just here to avoid re-making the action GUI every frame.
	CustomAction lastAction;
	//! Action pop-up widget
	GUIWidget *actionGUI;
};

} // gui
} // sl

#endif // SL_GUI_HUD_HPP