#include "Menus/InGameMenuController.hpp"

#include "Engine/Game.hpp"
#include "Town/World.hpp"
#include "Menus/Pause/PauseMenu.hpp"
#include "Menus/Pause/InventoryMenu.hpp"
#include "Engine/AbstractScene.hpp"

#include "Player/Player.hpp"

namespace sl
{

InGameMenuController::InGameMenuController(const PlayerStats& stats)
	:Entity()
	,stats(stats)
{

	hud.setHandle(unique<gui::HUD>(stats));
}

const Types::Type InGameMenuController::getType() const
{
	return "InGameMenuController";
}

/*				private				*/
void InGameMenuController::onUpdate()
{
	if (scene->getPlayerController().pressed(Key::Pause))
	{
		Game *game = scene->getGame();

		World *world = scene->getWorld();
		game->addScene(unique<PauseMenu>(game, world));
		world->stop();
	}
	// TODO HACK DEMO re-add
	//else if (scene->getPlayerController().pressed(Key::OpenInventory))
	//{
	//	Game *game = scene->getGame();

	//	World *world = scene->getWorld();
	//	game->addScene(unique<InventoryMenu>(game, world, scene->getPlayer()->getStats()));
	//	//world->stop();
	//}
	//
	//if (scene->getPlayerController().pressed(Key::ToggleHud))
	//{
	//	if (hud.isEnabled())
	//	{
	//		hud.disable();
	//	}
	//	else
	//	{
	//		hud.enable();
	//	}
	//}

	if (scene->getPlayerController().pressed(Key::ToggleMap))
	{
		hud->toggleMapMode();
	}

	hud->update();
}

void InGameMenuController::onEnter()
{
	hud.setScene(scene);
	hud.enable();
}

void InGameMenuController::onExit()
{
	hud.disable();
	hud.setScene(nullptr);
}

} // sl