#ifndef SL_GUI_GALLERYTEST_HPP
#define SL_GUI_GALLERYTEST_HPP

#include "Engine/GUI/GUIWidget.hpp"
#include "NPC/FramerateSpec.hpp"
#include "NPC/NPCAppearance.hpp"

namespace sl
{
namespace gui
{

class GalleryTest : public GUIWidget
{
public:
	GalleryTest();

private:
	void onOptionChange(const std::string& option);

	void refreshPicture();

	void reloadPoseList();

	void reloadActionList();

	void reloadFaceList();

	void reloadHairList();

	void reloadCumList();

	std::string GalleryTest::makePath() const;

	NPCAppearance npc;
	GUIWidget *sublist;
	GUIWidget *picture;
	std::string pose;
	std::string action;
	std::string face;
	FramerateSpec animation;
	DNA::EyeColor eyeColor;
	DNA::SkinColor skinColor;
	DNA::HairColor hairColor;
	std::map<ClothingType, std::vector<std::string>> clothing;
	std::map<std::string, int> ageMap;

	// menu options available at each time
	std::vector<std::string> poses;
	std::vector<std::string> actions;
	std::vector<std::string> faces;
	std::vector<std::string> hairstyles;
	std::vector<std::string> cumTypes;
};

} // gui
} // sl
#endif // SL_GUI_GALLERYTEST_HPP