#ifndef SL_MAINMENU_HPP
#define SL_MAINMENU_HPP

#include <vector>
#include <map>

#include "Engine/AbstractScene.hpp"
#include "Engine/GUI/WidgetHandle.hpp"
#include "Town/World.hpp"

namespace sl
{

namespace map
{
class MapData;
class Map;
} // map

namespace gui
{
class TextLabel;
} // gui

class MainMenu : public AbstractScene
{
public:
	MainMenu(Game *game);


private:
	enum class SubMenu
	{
		Main,
		NewGame,
		Options,
		GalleryTest,
		Input,
		GamepadConfig,
		Fetishes,
		GenSettings
	};

	class GenerationData
	{
	};
	class DemographicsSettings
	{

	};

	const sf::Vector2f getView() const override;

	void onUpdate(Timestamp timestamp) override;

	void onDraw(RenderTarget& target) override;


	void changeSubMenu(SubMenu subMenu);

	void exit();

	void generate();

	void start();

	void generationListener(int progress, const char *category, const map::MapData& minimapData);




	SubMenu subMenu;
	//std::map<SubMenu, WidgetHandle<GUIWidget>> submenus;
	gui::WidgetHandle<gui::GUIWidget> widget;
	std::unique_ptr<gui::GUIWidget> deleteNextStep;

	/*			Generation stuff		*/
	GenerationData generationData;
	DemographicsSettings demographicsSettings;
	gui::TextLabel *loadingText;
	sf::RectangleShape *loadingBar;
	map::Map *minimap;
	std::unique_ptr<World> generatedWorld;
};

} // sl

#endif // SL_MAINMENU_HPP
