#ifndef SL_INVENTORYMENU_HPP
#define SL_INVENTORYMENU_HPP

#include "Engine/AbstractScene.hpp"
#include "Engine/GUI/WidgetHandle.hpp"
#include "Engine/GUI/TextLabel.hpp"

namespace sl
{

class ConsumableItem;
class PlayerStats;
class World;

class InventoryMenu : public AbstractScene
{
public:
	InventoryMenu(Game *game, World *world, PlayerStats& stats);


private:
	enum class SubMenu
	{
		Items,
		Equipment,
		Stats,
		Map,
		Log
	};

	const sf::Vector2f getView() const override;
	void onUpdate(int64_t timestamp) override;
	void onDraw(RenderTarget& target) override;

	void changeSubMenu(SubMenu subMenu);
	void close();
	
	World *world;
	PlayerStats& stats;
	SubMenu subMenu;
	gui::WidgetHandle<gui::GUIWidget> widget;
	std::unique_ptr<gui::GUIWidget> deleteNextStep;
};

} // sl

#endif // SL_INVENTORYMENU_HPP