#ifndef SL_PAUSEMENU_HPP
#define SL_PAUSEMENU_HPP

#include "Engine/AbstractScene.hpp"
#include "Engine/GUI/WidgetHandle.hpp"

namespace sl
{

class World;

class PauseMenu : public AbstractScene
{
public:
	PauseMenu(Game *game, World *world);


private:
	enum class SubMenu
	{
		Main,
		Options
	};

	const sf::Vector2f getView() const override;
	void onUpdate(Timestamp timestamp) override;
	void onDraw(RenderTarget& target) override;

	void changeSubMenu(SubMenu subMenu);
	void close();
	void exit();
	
	World *world;
	SubMenu subMenu;
	gui::WidgetHandle<gui::GUIWidget> widget;
	std::unique_ptr<gui::GUIWidget> deleteNextStep;
};

} // sl

#endif // SL_PAUSEMENU_HPP