#include "Menus/PauseScene.hpp"

#include "Engine/Game.hpp"


namespace sl
{

PauseScene::PauseScene(AbstractScene *scene, std::unique_ptr<gui::GUIWidget> widget)
	:AbstractScene(scene->getGame(), scene->getGame()->getWindowWidth(), scene->getGame()->getWindowHeight(), -2)
	,scene(scene)
	,widget()
{
	scene->stop();
	this->widget.setHandle(std::move(widget));
	this->widget.setScene(this);
	this->widget.enable();
}

PauseScene::~PauseScene()
{
	scene->start();
}


/*			private			*/
const sf::Vector2f PauseScene::getView() const
{
	return sf::Vector2f(getViewWidth() / 2, getViewHeight() / 2);
}

void PauseScene::onUpdate(Timestamp timestamp)
{
	widget->update();
}

void PauseScene::onDraw(RenderTarget& target)
{
}


} // sl
