#ifndef SL_PAUSESCENE_HPP
#define SL_PAUSESCENE_HPP

#include "Engine/AbstractScene.hpp"
#include "Engine/GUI/WidgetHandle.hpp"

namespace sl
{

class PauseScene : public AbstractScene
{
public:
	/**
	 * Pauses {\code scene}, then when this scene exits, resume it. 
	 * @param scene. Scene to pause.
	 * @param widget A widget to add to the scene and run.
	 */
	PauseScene(AbstractScene *scene, std::unique_ptr<gui::GUIWidget> widget);

	~PauseScene();

private:

	const sf::Vector2f getView() const override;
	void onUpdate(Timestamp timestamp) override;
	void onDraw(RenderTarget& target) override;
	
	AbstractScene *scene;
	gui::WidgetHandle<> widget;
};

} // sl

#endif // SL_PAUSESCENE_HPP