#include "NPC/AnimationSequence.hpp"

#include "Engine/Graphics/Animation.hpp"
#include "Utility/Assert.hpp"

namespace sl
{

AnimationSequence::AnimationSequence(Animation& animation)
	:animation(animation)
{
	ASSERT(!animation.isRepeating());
}

bool AnimationSequence::sequence()
{
	return animation.isDone();
}

bool AnimationSequence::isInstantaneouslySequenced() const
{
	return false;
}

void AnimationSequence::resetSequence()
{
	animation.reset();
}

} // sl
