#ifndef SL_BED_HPP
#define SL_BED_HPP

#include "NPC/NPC.hpp"

#include "Engine/Entity.hpp"
#include "Engine/Ref.hpp"

namespace sl
{

class Random;

class Bed : public Entity
{
public:
	DECLARE_SERIALIZABLE_METHODS(Bed)

	Bed(const Rect<int>& bounds);

	const Types::Type getType() const override;

	void setOccupant(NPC *occupant);

	NPC* getOccupant() const;

	Vector2f getSleepPos() const;

	void addExitPos(const Vector2f& exitPos);

	Vector2f getExitPos(Random& rng) const;

	const std::vector<Vector2f>& getExitPositions() const;

private:
	void onUpdate() override;

	void loadInUseDrawables();

	void loadEmptyDrawables();
	
	Ref<NPC> occupant;
	std::vector<Vector2f> exitPositions;
};

} // sl

#endif // SL_BED_HPP
