#ifndef SL_AI_ALWAYSSUCCEED_HPP
#define SL_AI_ALWAYSSUCCEED_HPP

#include <memory>

#include "NPC/Behaviors/BehaviorTreeNode.hpp"

namespace sl
{
namespace ai
{

class AlwaysSucceed : public BehaviorTreeNode
{
public:
	AlwaysSucceed(std::unique_ptr<BehaviorTreeNode> node, const char *debugText ="AlwaysSucceed");


	Result execute(BehaviorContext& context) override;

	void abort(BehaviorContext& context) override;

private:
	std::unique_ptr<BehaviorTreeNode> node;
};

extern std::unique_ptr<BehaviorTreeNode> neverSucceed(std::unique_ptr<BehaviorTreeNode> node);

} // ai
} // sl

#endif // SL_AI_ALWAYSSUCCEED_HPP