#ifndef SL_AI_CANSEE_HPP
#define SL_AI_CANSEE_HPP

#include <memory>
#include <string>

#include "NPC/Behaviors/BehaviorTreeNode.hpp"
#include "NPC/Locators/MultiTargetLocator.hpp"

namespace sl
{
namespace ai
{

class CanSee : public BehaviorTreeNode
{
public:
	CanSee(std::unique_ptr<MultiTargetLocator> locator, std::string resultSaveLocation = std::string(), bool blocking = false);


	Result execute(BehaviorContext& context) override;

	void abort(BehaviorContext&) override;

private:
	std::vector<Target> targets;
	std::unique_ptr<MultiTargetLocator> locator;
	std::string resultSaveLocation;
	bool running;
	//! Whether to wait until higher-priority targets are done pathing before prematurely-exiting on a lower-priority visible target.
	bool blocking;
};

} // ai
} // sl

#endif // SL_AI_CANSEE_HPP