#ifndef SL_AI_CHANCE_HPP
#define SL_AI_CHANCE_HPP

#include <functional>
#include <memory>

#include "NPC/Behaviors/BehaviorTreeNode.hpp"

namespace sl
{
namespace ai
{

class Chance : public BehaviorTreeNode
{
public:
	Chance(std::unique_ptr<BehaviorTreeNode> node, float probability);

	Chance(std::unique_ptr<BehaviorTreeNode> node, std::function<float(BehaviorContext&)> probabilityFunc);


	Result execute(BehaviorContext& context) override;

	void abort(BehaviorContext& context) override;


private:
	std::unique_ptr<BehaviorTreeNode> node;
	std::function<float(BehaviorContext&)> probabilityFunc;
	bool isComputing;
};

} // ai
} // sl

#endif // SL_AI_CHANCE_HPP