#include "NPC/Behaviors/CheckTime.hpp"

#include "NPC/Behaviors/BehaviorContext.hpp"
#include "Utility/Assert.hpp"

namespace sl
{
namespace ai
{

CheckTime::CheckTime(const RecurringTimeInterval& requiredTime)
	:BehaviorTreeNode("CheckTime")
	,requiredTime(requiredTime)
{
}

BehaviorTreeNode::Result CheckTime::execute(BehaviorContext& context)
{
	if (requiredTime.isWithin(context.getGameTime()))
	{
		return Result::Success;
	}
	else
	{
		return Result::Failure;
	}
}


} // ai
} // sl