#include "NPC/Behaviors/Chloroformed.hpp"

#include "NPC/Behaviors/AcceptTalkWithPlayer.hpp"
#include "NPC/Behaviors/BehaviorContext.hpp"
#include "NPC/NPC.hpp"

namespace sl
{
namespace ai
{

Chloroformed::Chloroformed()
	:BehaviorTreeNode("Chloro")
	,talk(unique<AcceptTalkWithPlayer>("chloro_begin"))
{
#ifdef SL_DEBUG
	this->talk->setParent(this);
#endif // SL_DEBUG
}

BehaviorTreeNode::Result Chloroformed::execute(BehaviorContext& context)
{
	int& chloro = context.getNPC().getSoul()->getStatus().chloroformTimer;
	if (chloro <= 0)
	{
		return Result::Failure;
	}
	
#ifdef SL_DEBUG
	const Result result = talk->debugExecute(context);
#else // SL_DEBUG
	const Result result = talk->execute(context);
#endif // SL_DEBUG
	--chloro;
	if (result == Result::Success)
	{
		return Result::Success;
	}
	return Result::Running;
}

void Chloroformed::abort(BehaviorContext& context)
{
	talk->abort(context);
}

} // ai
} // sl