#ifndef SL_AI_COUNTER_HPP
#define SL_AI_COUNTER_HPP

#include "NPC/Behaviors/BehaviorTreeNode.hpp"

#include <string>

namespace sl
{
namespace ai
{

class Counter : public BehaviorTreeNode
{
public:
	Counter(std::unique_ptr<BehaviorTreeNode> node, std::string counterName = "timer");

	Result execute(BehaviorContext& context) override;

	void abort(BehaviorContext& context) override;


private:
	std::unique_ptr<BehaviorTreeNode> node;
	std::string counterName;
	bool initialized;
};

} // ai
} // sl

#endif // SL_AI_COUNTER_HPP