#include "NPC/Behaviors/CustomCondition.hpp"

#include "Utility/Assert.hpp"
#include "Utility/Memory.hpp"

namespace sl
{
namespace ai
{

CustomCondition::CustomCondition(const std::function<bool(BehaviorContext&)> boolPredicate, const char *customDebugString)
	:CustomCondition(std::function<Result(BehaviorContext&)>([boolPredicate](BehaviorContext& context) -> Result {
		return boolPredicate(context) ? Result::Success : Result::Failure;
	}), customDebugString)
{
}

CustomCondition::CustomCondition(const std::function<Result(BehaviorContext&)>& condition, const char *customDebugString)
	:BehaviorTreeNode(customDebugString)
	,condition(condition)
{
}

BehaviorTreeNode::Result CustomCondition::execute(BehaviorContext& context)
{
	return condition(context);
}

} // ai
} // sl