#ifndef SL_AI_CUSTOMCONDITION_HPP
#define SL_AI_CUSTOMCONDITION_HPP

#include <functional>
#include <memory>

#include "NPC/Behaviors/BehaviorTreeNode.hpp"

namespace sl
{
namespace ai
{

class CustomCondition : public BehaviorTreeNode
{
public:
	CustomCondition(const std::function<bool(BehaviorContext&)> boolPredicate, const char *customDebugString = "Check");

	CustomCondition(const std::function<Result(BehaviorContext&)>& condition, const char *customDebugString = "CustomCondition");


	Result execute(BehaviorContext& context) override;


private:
	std::function<Result(BehaviorContext& context)> condition;
};

} // ai
} // sl

#endif // SL_AI_CUSTOMCONDITION_HPP