/**
 * @section DESCRIPTION
 * Handy helper functions for dialogue-related nodes.
 */
#ifndef SL_AI_DIALOGUETRANSITIONS_HPP
#define SL_AI_DIALOGUETRANSITIONS_HPP

#include "NPC/Behaviors/BehaviorTreeNode.hpp"

#include <memory>

namespace sl
{
namespace ai
{

class BehaviorContext;

/**
 * Loads a behavior tree that should be executed upon a dialogue terminating.
 * Note: when the dialogue should simply end with nothing else, it returns a Succeed node.
 * @return The tree to execute if it is finishing, or nullptr if it's still going
 */
extern std::unique_ptr<BehaviorTreeNode> getDialogueAction(BehaviorContext& context);

} // ai
} // sl

#endif // SL_AI_DIALOGUETRANSITIONS_HPP