#include "NPC/Behaviors/FixedResult.hpp"

namespace sl
{
namespace ai
{

FixedResult::FixedResult(Result result, std::unique_ptr<BehaviorTreeNode> child)
	:BehaviorTreeNode("FixedResult")
	,result(result)
	,child(std::move(child))
{
}

BehaviorTreeNode::Result FixedResult::execute(BehaviorContext& context)
{
	// @TODO figure out if we ever want to return RUNNING as a parameter, and if we want to return
	// RUNNING when child is running (ie make this like AlwaysSucceed, but also allow for AlwaysFail)
	// then again that's just Not(AlwaysSucceed)...
	if (child)
	{
#ifdef SL_DEBUG
		child->debugExecute(context);
#else
		child->execute(context);
#endif // SL_DEBUG
	}
	return result;
}

void FixedResult::abort(BehaviorContext& context)
{
	if (child)
	{
		child->abort(context);
	}
}

} // ai
} // sl