#ifndef SL_AI_FIXEDRESULT_HPP
#define SL_AI_FIXEDRESULT_HPP

#include <memory>

#include "NPC/Behaviors/BehaviorTreeNode.hpp"

namespace sl
{
namespace ai
{

class FixedResult : public BehaviorTreeNode
{
public:
	FixedResult(Result result, std::unique_ptr<BehaviorTreeNode> child = nullptr);

	Result execute(BehaviorContext& context) override;

	void abort(BehaviorContext& context) override;

private:

	const Result result;
	std::unique_ptr<BehaviorTreeNode> child;
};

} // ai
} // sl

#endif // SL_AI_FIXEDRESULT_HPP