#ifndef SL_AI_FOLLOWSCHEDULE_HPP
#define SL_AI_FOLLOWSCHEDULE_HPP

#include <map>
#include <memory>
#include <string>

#include "NPC/Behaviors/BehaviorTreeNode.hpp"
#include "NPC/Schedule.hpp"

namespace sl
{
namespace ai
{

// TODO: parameterize schedules somehow?
class FollowSchedule : public BehaviorTreeNode
{
public:
	FollowSchedule();

	Result execute(BehaviorContext& context) override;

	void abort(BehaviorContext& context) override;

	void addChild(const std::string& id, std::unique_ptr<BehaviorTreeNode> behavior);

	static float getPriority(BehaviorContext& context);

private:
	static Schedule::InterpolatedSchedule::Interpolation schedule(BehaviorContext& context);

	static bool teleportIfOffsceenAndFar(BehaviorContext& context, const Schedule::InterpolatedSchedule::Interpolation& interpolation);

	std::map<std::string, std::unique_ptr<BehaviorTreeNode>> children;
	decltype(children)::iterator toAbort;
	std::unique_ptr<BehaviorTreeNode> walkTo;
};

} // ai
} // sl

#endif // SL_AI_FOLLOWSCHEDULE_HPP