#ifndef SL_AI_ACTIVESELECTOR_HPP
#define SL_AI_ACTIVESELECTOR_HPP

#include <memory>
#include <vector>

#include "NPC/Behaviors/BehaviorTreeNode.hpp"

namespace sl
{
namespace ai
{

class ForgetfulSelector : public BehaviorTreeNode
{
public:
	ForgetfulSelector(const char *customName = "ForgetfulSelector");

	Result execute(BehaviorContext& context) override;

	void addChild(std::unique_ptr<BehaviorTreeNode> child);

	void abort(BehaviorContext& context) override;

private:
	std::vector<std::unique_ptr<BehaviorTreeNode>> children;
};

} // ai
} // sl

#endif // SL_AI_ACTIVESELECTOR_HPP