#ifndef SL_AI_IFELSE_HPP
#define SL_AI_IFELSE_HPP

#include <memory>

#include "NPC/Behaviors/BehaviorTreeNode.hpp"

namespace sl
{
namespace ai
{

class IfElse : public BehaviorTreeNode
{
public:
	IfElse(std::unique_ptr<BehaviorTreeNode> condition, std::unique_ptr<BehaviorTreeNode> onSuccess, std::unique_ptr<BehaviorTreeNode> onFail, bool isActive);


	Result execute(BehaviorContext& context) override;

	void abort(BehaviorContext& context) override;

private:
	std::unique_ptr<BehaviorTreeNode> condition;
	std::unique_ptr<BehaviorTreeNode> onSuccess;
	std::unique_ptr<BehaviorTreeNode> onFail;
	Result conditionResult;
	bool isActive;
};

} // ai
} // sl

#endif // SL_AI_IFELSE_HPP