#include "NPC/Behaviors/Not.hpp"

#include "Utility/Assert.hpp"

namespace sl
{
namespace ai
{

Not::Not(std::unique_ptr<BehaviorTreeNode> node)
	:BehaviorTreeNode("Not")
	,node(std::move(node))
{
#ifdef SL_DEBUG
	this->node->setParent(this);
#endif // SL_DEBUG
}

BehaviorTreeNode::Result Not::execute(BehaviorContext& context)
{
#ifdef SL_DEBUG
	Result result = node->debugExecute(context);
#else // SL_DEBUG
	Result result = node->execute(context);
#endif // SL_DEBUG
	if (result == Result::Success)
	{
		return Result::Failure;
	}
	else if (result == Result::Failure)
	{
		return Result::Success;
	}
	return result;
}

void Not::abort(BehaviorContext& context)
{
	node->abort(context);
}


} // ai
} // sl