#include "NPC/Behaviors/PeeNode.hpp"

#include "Engine/Scene.hpp"
#include "NPC/Behaviors/BehaviorContext.hpp"
#include "NPC/NPC.hpp"
#include "NPC/UrinePuddle.hpp"

namespace sl
{
namespace ai
{

PeeNode::PeeNode(bool makePuddle)
	:BehaviorTreeNode("Pee")
	,puddle(nullptr)
	,peeCooldown(0)
	,makePuddle(makePuddle)
{
}

BehaviorTreeNode::Result PeeNode::execute(BehaviorContext& context)
{
	if (makePuddle && puddle == nullptr)
	{
		puddle = new UrinePuddle(context.getNPC().getPos().x, context.getNPC().getPos().y + 7, Urine());
		context.getScene()->addEntityToList(puddle);
	}
	// to avoid numerical issues, only take pee every 30 updates
	if (--peeCooldown <= 0)
	{
		const Urine urine = context.getSoul().urinate();
		if (urine.fluid == 0)
		{
			abort(context);
			return Result::Success;
		}
		if (makePuddle)
		{
			puddle->addFluid(urine);
		}
		peeCooldown = 30;
	}
	return Result::Running;
	}

void PeeNode::abort(BehaviorContext& context)
{
	puddle = nullptr;
	peeCooldown = 0;
}

} // ai
} // sl