#ifndef SL_AI_PLAYANIMATION_HPP
#define SL_AI_PLAYANIMATION_HPP

#include <functional>
#include <memory>
#include <string>

#include "NPC/Behaviors/BehaviorTreeNode.hpp"

namespace sl
{
namespace ai
{

class PlayAnimation : public BehaviorTreeNode
{
public:
	PlayAnimation(const std::string& key);

	PlayAnimation(std::function<std::string(BehaviorContext&)> key);


	Result execute(BehaviorContext& context) override;

	void abort(BehaviorContext& context) override;


private:
	std::function<std::string(BehaviorContext&)> key;
	bool running;
};

} // ai
} // sl

#endif // SL_AI_PLAYANIMATION_HPP