#ifndef SL_AI_RANDOMSELECTOR_HPP
#define SL_AI_RANDOMSELECTOR_HPP

#include <memory>
#include <vector>

#include "NPC/Behaviors/BehaviorTreeNode.hpp"

namespace sl
{
namespace ai
{

class RandomSelector : public BehaviorTreeNode
{
public:
	RandomSelector(const char *customDebugName = "Selector");

	Result execute(BehaviorContext& context) override;

	void abort(BehaviorContext& context) override;

	void addChild(std::unique_ptr<BehaviorTreeNode> child);

private:
	std::vector<std::unique_ptr<BehaviorTreeNode>> children;
	int childRunningIndex;
	std::vector<int> indices;

	static const int RESHUFFLE_INDICES = -1;
};

} // ai
} // sl

#endif // SL_AI_RANDOMSELECTOR_HPP