#ifndef SL_AI_RUNATMOST_HPP
#define SL_AI_RUNATMOST_HPP

#include <memory>

#include "NPC/Behaviors/BehaviorTreeNode.hpp"

namespace sl
{
namespace ai
{

class RunAtMost : public BehaviorTreeNode
{
public:
	RunAtMost(std::unique_ptr<BehaviorTreeNode> node, int times);


	Result execute(BehaviorContext& context) override;

	void abort(BehaviorContext& context) override;

private:
	std::unique_ptr<BehaviorTreeNode> node;
	int currentTimes;
	const int times;
};

} // ai
} // sl

#endif // SL_AI_RUNATMOST_HPP