#ifndef SL_AI_SELECTOR_HPP
#define SL_AI_SELECTOR_HPP

#include <memory>
#include <vector>

#include "NPC/Behaviors/BehaviorTreeNode.hpp"

namespace sl
{
namespace ai
{

class Selector : public BehaviorTreeNode
{
public:
	Selector(const char *customDebugName = "Selector");

	Result execute(BehaviorContext& context) override;

	void abort(BehaviorContext& context) override;

	void addChild(std::unique_ptr<BehaviorTreeNode> child);

private:
	std::vector<std::unique_ptr<BehaviorTreeNode>> children;
	int childRunningIndex;
};

} // ai
} // sl

#endif // SL_AI_SELECTOR_HPP