#ifndef SL_AI_SLEEPINBED_HPP
#define SL_AI_SLEEPINBED_HPP

#include <memory>
#include <vector>

#include "NPC/Behaviors/BehaviorTreeNode.hpp"

namespace sl
{
namespace ai
{

class SleepInBed : public BehaviorTreeNode
{
public:
	SleepInBed(const char *key = nullptr);

	Result execute(BehaviorContext& context) override;

	void abort(BehaviorContext& context) override;

private:
	const char *key;
	bool running;
	std::unique_ptr<BehaviorTreeNode> walkToBed;
	std::unique_ptr<BehaviorTreeNode> sleepDialogue;
	int zzz;
};

} // ai
} // sl

#endif // SL_AI_SLEEPINBED_HPP