#ifndef SL_AI_UTIL_HPP
#define SL_AI_UTIL_HPP

#include <memory>

namespace sl
{
namespace ai
{

template <typename BT, typename... Args>
std::unique_ptr<BT> makebt(Args&&... args)
{
	auto ret = std::make_unique<BT>();
	const bool ignored[] = { ([&ret](auto&& node) { ret->addChild(std::move(node)); }(args), false)... };
	return ret;
}

} // ai
} // sl

#endif // SL_AI_UTIL_HPP