#ifndef SL_AI_UTILITYNODE_HPP
#define SL_AI_UTILITYNODE_HPP

#include <functional>
#include <memory>
#include <vector>

#include "NPC/Behaviors/BehaviorTreeNode.hpp"

namespace sl
{
namespace ai
{

class UtilityNode : public BehaviorTreeNode
{
public:
	typedef std::function<float(BehaviorContext&)> PriorityFn;

	UtilityNode(const char *customName = "UtilityNode");

	Result execute(BehaviorContext& context) override;

	void addChild(PriorityFn f, std::unique_ptr<BehaviorTreeNode> child);

	void addChild(float p, std::unique_ptr<BehaviorTreeNode> child);

	void abort(BehaviorContext& context) override;

private:
	std::vector<std::pair<PriorityFn, std::unique_ptr<BehaviorTreeNode>>> children;
};

} // ai
} // sl

#endif // SL_AI_UTILITYNODE_HPP