#ifndef SL_AI_WAIT_HPP
#define SL_AI_WAIT_HPP

#include <functional>

#include "NPC/Behaviors/BehaviorTreeNode.hpp"

namespace sl
{
namespace ai
{

class Wait : public BehaviorTreeNode
{
public:
	Wait(int ticksToWait);

	Wait(int minTicks, int maxTicks);

	Wait(const std::function<int(BehaviorContext&)>& tickGenerator);

	Result execute(BehaviorContext& context) override;

	void abort(BehaviorContext& context) override;

private:
	std::function<int(BehaviorContext&)> tickGenerator;
	int countdown;
};

} // ai
} // sl

#endif // SL_AI_WAIT_HPP