#ifndef SL_AI_WALKSPEED_HPP
#define SL_AI_WALKSPEED_HPP

#include <functional>
#include <memory>

#include "NPC/Behaviors/BehaviorTreeNode.hpp"

namespace sl
{
namespace ai
{

class WalkSpeed : public BehaviorTreeNode
{
public:
	WalkSpeed(std::unique_ptr<BehaviorTreeNode> node, float speed);

	WalkSpeed(std::unique_ptr<BehaviorTreeNode> node, std::function<float(BehaviorContext&)> speed);


	Result execute(BehaviorContext& context) override;

	void abort(BehaviorContext& context) override;


private:
	std::unique_ptr<BehaviorTreeNode> node;
	std::function<float(BehaviorContext&)> speed;
};

} // ai
} // sl

#endif // SL_AI_WALKSPEED_HPP