#ifndef SL_AI_WALKTO_HPP
#define SL_AI_WALKTO_HPP

#include <memory>

#include "NPC/Behaviors/BehaviorTreeNode.hpp"
#include "NPC/Locators/TargetLocator.hpp"

namespace sl
{
namespace ai
{

class WalkTo : public BehaviorTreeNode
{
public:
	WalkTo(std::unique_ptr<TargetLocator> locator);

	/**
	 * Upon finding a target, stores it in the BehaviorContext under storeKey.
	 * Make sure you use a MemoryNode first!
	 */
	WalkTo(std::unique_ptr<TargetLocator> locator, std::string storeKey);

	Result execute(BehaviorContext& context) override;

	void abort(BehaviorContext& context) override;

private:
	
	std::unique_ptr<TargetLocator> locator;
	bool isTargetValid;
	Target target;
	std::string storeKey;
};

} // ai
} // sl

#endif // SL_AI_WALKTO_HPP