#ifndef SL_AI_WEIGHTMAP_HPP
#define SL_AI_WEIGHTMAP_HPP

#include <functional>
#include <memory>
#include <string>

#include "NPC/Behaviors/BehaviorTreeNode.hpp"

namespace sl
{
namespace ai
{

class WeightMap : public BehaviorTreeNode
{
public:
	WeightMap(std::unique_ptr<BehaviorTreeNode> node, std::string map);

	WeightMap(std::unique_ptr<BehaviorTreeNode> node, std::function<std::string(BehaviorContext&)> map);


	Result execute(BehaviorContext& context) override;

	void abort(BehaviorContext& context) override;


private:
	std::unique_ptr<BehaviorTreeNode> node;
	std::function<std::string(BehaviorContext&)> weightMap;
};

} // ai
} // sl

#endif // SL_AI_WEIGHTMAP_HPP