#ifndef SL_AI_WHILE_HPP
#define SL_AI_WHILE_HPP

#include <memory>

#include "NPC/Behaviors/BehaviorTreeNode.hpp"

namespace sl
{
namespace ai
{

class While : public BehaviorTreeNode
{
public:
	While(std::unique_ptr<BehaviorTreeNode> node);

	static std::unique_ptr<BehaviorTreeNode> makeActive(std::unique_ptr<BehaviorTreeNode> condition, std::unique_ptr<BehaviorTreeNode> node);

	static std::unique_ptr<BehaviorTreeNode> make(std::unique_ptr<BehaviorTreeNode> condition, std::unique_ptr<BehaviorTreeNode> node);

	Result execute(BehaviorContext& context) override;

	void abort(BehaviorContext& context) override;


private:
	std::unique_ptr<BehaviorTreeNode> node;
};

} // ai
} // sl

#endif // SL_AI_WHILE_HPP