#include "NPC/Blood.hpp"

#include <sstream>
#include "Engine/Settings.hpp"
#include "Utility/Random.hpp"
#include "Engine/Graphics/Sprite.hpp"

namespace sl
{

Blood::Blood(int x, int y, float xspeed, float yspeed)
	:Entity(x, y, 6, 6, "Blood")
	,xspeed(xspeed)
	,yspeed(yspeed)
	,timer(4096)
{
	
	if (Settings::fuckYouSingletonHack()->get("blood_visible"))
	{
		std::stringstream ss;
		ss << "blood"
		   << Random::get().random(4)
		   << ".png";
		addDrawable(std::make_unique<Sprite>(ss.str().c_str(), 3, 3));
	}
}

const Types::Type Blood::getType() const
{
	return Entity::makeType("Blood");
}

/*	  Entity private methods	  */
void Blood::onUpdate()
{
	pos.x += xspeed;
	pos.y += yspeed;
	xspeed *= 0.9f;
	yspeed *= 0.9f;
	if (xspeed < 0.2f && xspeed > -0.2f)
	{
		xspeed = 0.f;
	}
	if (yspeed < 0.2f && yspeed > -0.2f)
	{
		yspeed = 0.f;
	}
	if (--timer <= 0)
	{
		this->destroy();
	}
}

} // sl
