#include "NPC/ClothingLayers.hpp"

#include "Utility/Assert.hpp"

namespace sl
{
namespace ClothingLayers
{

Object::Object()
	:panties(false)
	,bra(false)
	,socks(false)
	,outfit(false)
	,accessory(false)
{
}

uint8_t Object::toFlag() const
{
	uint8_t ret = Body;
	if (panties)
	{
		ret |= Panties;
	}
	if (bra)
	{
		ret |= Bra;
	}
	if (socks)
	{
		ret |= Socks;
	}
	if (outfit)
	{
		ret |= Outfit;
	}
	if (accessory)
	{
		ret |= Accessory;
	}
	return ret;
}

void Object::fromFlag(uint8_t flag)
{
	panties = (flag & Panties) != 0;
	bra = (flag & Bra) != 0;
	socks = (flag & Socks) != 0;
	outfit = (flag & Outfit) != 0;
	accessory = (flag & Accessory) != 0;
}

bool& Object::fromEnum(ClothingType type)
{
	switch (type)
	{
	case ClothingType::Panties:
		return panties;
	case ClothingType::Bra:
		return bra;
	case ClothingType::Socks:
		return socks;
	case ClothingType::Outfit:
		return outfit;
	case ClothingType::Accessory:
		return accessory;
	default:
		ERROR("invalid clothing layer. please update this function.");
	}
	return panties;
}

bool Object::fromEnum(ClothingType type) const
{
	return const_cast<Object&>(*this).fromEnum(type);
}

} // ClothingLayers
} // sl
