#include "NPC/Dialogue/Attribute.hpp"

namespace sl
{

Attribute::Attribute(float normalLowerEnd, float normalUpperEnd, const std::function<float()>& value)
	:normalLowerEnd(normalLowerEnd)
	,normalUpperEnd(normalUpperEnd)
	,value(value)
{
}


float Attribute::getValue() const
{
	return value();
}
	
float Attribute::getExpectedDifference() const
{
	// let's assume for now that within the normal spectrum
	// that there's a uniform distribution among loli stats
	// so the distance would be 2 * (0 + 1 + 2 +...(n - 1)/2) total, so divie by n later
	// if upper - lower = n which gives us (n / 2)((n-1) / 2)/2 * 2 / n = (n-1)/4
	return (normalUpperEnd - normalLowerEnd - 1) / 4.f;
}

} // sl
