#ifndef SL_ATTRIBUTERANGE_HPP
#define SL_ATTRIBUTERANGE_HPP

#include <memory>

#include "Parsing/SyntaxTree/Expressions/Expression.hpp"

namespace sl
{

class AttributeRange
{
public:
	AttributeRange(std::unique_ptr<ls::Expression> val, float scalar);

	AttributeRange(std::unique_ptr<ls::Expression> min, std::unique_ptr<ls::Expression> max, float scalar);


	float calculateDifference(const ls::Bindings& context, float value) const;

	float getScalar() const;

private:
	std::unique_ptr<ls::Expression> min;
	//! If nullptr, then use min for max too. (ie no range)
	std::unique_ptr<ls::Expression> max;
	float scalar;
};

} // sl

#endif // SL_ATTRIBUTERANGE_HPP