#include "NPC/Dialogue/DialogueBindings.hpp"

#include <algorithm>
#include <iomanip>

#include "Engine/Game.hpp"
#include "NPC/NPC.hpp"
#include "NPC/Stats/Soul.hpp"
#include "NPC/SoulConjugator.hpp"
#include "Parsing/Binding/BoundString.hpp"
#include "Parsing/Binding/Bindings.hpp"
#include "Utility/DataToString.hpp"
#include "Utility/Memory.hpp"
#include "Utility/ProportionList.hpp"
#include "Utility/SentenceFormation.hpp"

namespace sl
{

// @TODO move?
static void logSexStats(const char *name, const Soul& soul)
{
	auto log = Logger::log(Logger::NPC, Logger::Debug);
	log << "Sex Stats of " << name << std::endl;
#define LOGSEXEXP(e) log << #e << ": " << std::setprecision(2) << soul.getSexAbility(Soul::SexType::e, 0.f) * 100 << "%" << std::endl
	LOGSEXEXP(Vaginal);
	LOGSEXEXP(Anal);
	LOGSEXEXP(Oral);
	LOGSEXEXP(Handjob);
	LOGSEXEXP(Thighsex);
	LOGSEXEXP(Footjob);
	LOGSEXEXP(Masturbation);
	LOGSEXEXP(Molestation);
#undef LOGSEXEXP
	log << "Arousal: " << std::setprecision(2) << soul.getArousal() * 100 << "%" << std::endl;
	log << "Orgasm: " << std::setprecision(2) << soul.getOrgasm() * 100 << "%\n" << std::endl;
}

// @TODO externalize this in loliscript files somewhere
static void registerRandomizedWords(ls::Bindings& context)
{
	context.registerFunction("local", "cunny", [] {
		Random& rng = Random::get();
		std::vector<std::string> adjectives;
		if (rng.chance(0.3f))
		{
			adjectives.push_back(
				ProportionList<std::string>(
					"cute", 2.0,
					"adorable", 1.0,
					"perfect", 1.0,
					"hairless", 1.0).get(rng));
		}
		if (rng.chance(0.7f))
		{
			adjectives.push_back(
				ProportionList<std::string>(
					"little", 1.5,
					"prepubescent", 1.0,
					"tiny", 1.0).get(rng));
		}
		return concatAdjectives(adjectives,
			ProportionList<std::string>(
				"cunny", 2.0,
				"pussy", 2.0,
				"vagina", 1.3,
				"slit", 1.1).get(rng));
	});

	context.registerFunction("local", "little", [] {
		return ProportionList<std::string>(
			"little", 2.2,
			"small", 1.7,
			"tiny", 1.0,
			"itty-bitty", 0.4).get(Random::get());
	});
}

void registerDialogueBindings(Soul& player, Soul& npc, ls::Bindings& context)
{
	context.registerFunction("loli", "nationality", npc, &Soul::getNationality);
	context.registerFunction("loli", "firstName", npc, &Soul::getFirstName);
	context.registerFunction("loli", "lastName", npc, &Soul::getLastName);
	
	//TODO: fix member binding for stuff with reference params then change these
	context.registerFunction("loli", "knowledge", [&npc](std::string concept) {
		return npc.associations.getConceptKnowledge(concept);
	});
	context.registerFunction("loli", "shiftKnowledge", [&npc](std::string concept, float amount) {
		npc.associations.shiftConceptKnowledge(concept, amount);
	});
	context.registerFunction("loli", "setKnowledge", [&npc](std::string concept, float newValue) {
		npc.associations.shiftConceptKnowledge(concept, newValue);
	});
	context.registerFunction("loli", "association", [&npc](std::string concept1, std::string concept2) {
		return npc.associations.computeAssociation(concept1, concept2);
	});
	context.registerFunction("loli", "associate", [&npc](std::string concept1, std::string concept2, float amount) {
		npc.associations.associate(concept1, concept2, amount);
	});

#undef REGISTER_STATUS

	SoulConjugator conjugator(npc);
#define REGISTER_CONJ(field) \
	context.registerFunction("loli", #field, [=]() -> std::string { \
		return conjugator.field(); \
	})
	REGISTER_CONJ(fullName);
	REGISTER_CONJ(knownNameCasual);
	REGISTER_CONJ(knownNameFormal);
	REGISTER_CONJ(personalSubjectPronoun);
	REGISTER_CONJ(personalObjectPronoun);
	REGISTER_CONJ(possessivePronoun);
	REGISTER_CONJ(reflexivePronoun);
	REGISTER_CONJ(nameForPlayer);
#undef REGISTER_CONJ

	const int age = npc.getAgeDays();
	context.registerFunction("loli", "ageFormatted", [age]() -> std::string {
		return formatAge(age, true, true);
	});

	context.registerFunction("loli", "ageInYears", [age]() -> float {
		return age / 365.f;
	});

	context.registerFunction("loli", "nourishment", npc, &Soul::getNourishment);
	context.registerFunction("loli", "hydration", npc, &Soul::getHydration);
	context.registerFunction("loli", "urinaryUrges", npc, &Soul::getUrinaryUrges);
	context.registerFunction("loli", "urinate", [&npc] {
		while (npc.urinate().fluid > 0);
	});

	context.registerFunction("local", "offerJuice", [&npc] {
		// TODO: unify as part of other foods/drinks and remove this very specific function
		npc.getStatus().waterInDigestiveSystem += 250; // 250ml cup of juice!
	});

	context.registerFunction("local", "wakeupFromChloro", [&npc] {
		npc.getStatus().chloroformTimer = 0;
	});

	context.registerFunction("loli", "adjustMoodAxis", [&npc](int index, float amount) -> float {
		LSASSERT(index >= 0 && index < Mood::axes);
		const Mood::Axis axis = static_cast<Mood::Axis>(index);
		Mood& mood = npc.getStatus().currentMood;
		mood.adjustValue(axis, amount);
		return mood.getValue(axis);
	});

	context.registerFunction("loli", "moodAxis", [&npc](int index) -> float {
		LSASSERT(index >= 0 && index < Mood::axes);
		const Mood::Axis axis = static_cast<Mood::Axis>(index);
		Mood& mood = npc.getStatus().currentMood;
		return mood.getValue(axis);
	});

	// personality stuff
#define GETTER(method) \
	context.registerFunction("loli", #method, [&npc](const ls::Arguments& args) -> ls::Value { return ls::Value(npc.method()); })
	GETTER(gullibility);
	GETTER(dominance);
	GETTER(openToCautious);
	GETTER(organizedToCareless);
	GETTER(extrovertToIntrovert);
	GETTER(friendlyToUnkind);
	GETTER(nervousToConfident);

	// TODO: move to Soul?
	context.registerFunction("loli", "curiosity", [&npc]() {
		return 0.1f * (0.5f + npc.dominance() / 2)
		     + 0.4f * (0.5f + npc.nervousToConfident() / 2)
		     + 0.1f * (0.5f - npc.extrovertToIntrovert() / 2)
		     + 0.4f * (0.5f - npc.openToCautious() / 2);
	});

	context.registerFunction("loli", "willingness", npc, &Soul::getWillingness);

	context.registerFunction("loli", "adjustFear", [&npc](float amount) {
		npc.setFear(npc.getFear() + amount);
	});

	context.registerFunction("loli", "adjustMoodTo", [&npc](std::string targetName, float amplifier) {
		Mood target; // TODO choose based on param 0
		Mood& mood = npc.getStatus().currentMood;
		mood.gravitateTowards(target, amplifier);
	});

	context.registerFunction("local", "sexExp", [&player, &npc, &context](const ls::Arguments& args) -> ls::Value {
		VERIFY_ARG_COUNT(args, 2, 3);
		const Soul::SexType type = static_cast<Soul::SexType>(args[0].asInt());
		// to prevent repeated application, allow for each scene to have diminishing returns
		// as well as per-act. this is reduced hourly
		const float xp = args[1].asFloat();
		// this seems kinda hacky, but whatever, it's easy to access here...
		const std::string scenarioId = context.evaluateFunction("scenario", "id", ls::Parameters()).asString();
		const float loliDominance = args.count() >= 3 ? args[2].asFloat() : 0.f;
		npc.addSexExp(type, &scenarioId, xp, loliDominance);
		// @TODO: figure out how much the player should gain relatively.
		player.addSexExp(type, &scenarioId, xp / 3.f, -loliDominance); // negated since dom:sub has a dual relation
		logSexStats("player", player);
		logSexStats("loli", npc);
		return ls::Value();
	});

	auto registerSexAbilityGetters = [](ls::Bindings& context, const char *name, Soul *soul) {
		context.registerFunction(name, "sexAbility", [soul](const ls::Arguments& args) -> ls::Value {
			VERIFY_ARG_COUNT(args, 1, 2);
			const Soul::SexType type = static_cast<Soul::SexType>(args[0].asInt());
			const float dominance = args.count() >= 2 ? args[1].asFloat() : 0.f;
			return ls::Value(soul->getSexAbility(type, dominance));
		});

		context.registerFunction(name, "generalSexAbility", [soul]() -> float {
			const float dominance = -0.2f; // neutral (since should be slightly submissive I guess)
			// relative importance to general ability, I guess?
			const float importance[static_cast<int>(Soul::SexType::COUNT)] = {
				1.0f, // vaginal
				0.6f, // anal
				0.6f, // oral
				0.3f, // handjob
				0.2f, // thighsex
				0.1f, // footjob
				0.3f, // masturbation
				0.05f,// molestation
				0.02f,// oral (receive)
			};
			float total = 0.f;
			float ability = 0.f;
			for (int index = 0; index < static_cast<int>(Soul::SexType::COUNT); ++index)
			{
				ability += importance[index] * soul->getSexAbility(static_cast<Soul::SexType>(index), dominance);
				total += importance[index];
			}
			return ability / total;
		});

		context.registerFunction(name, "arouse", [name, soul](float amount) {
			soul->arouse(amount);
			logSexStats(name, *soul);
		});

		context.registerFunction(name, "arousal", *soul, &Soul::getArousal);

		context.registerFunction(name, "stimulate", [name, soul, &context](float amount) {
			soul->stimulate(amount);
			logSexStats(name, *soul);
		});

		context.registerFunction(name, "getOrgasm", *soul, &Soul::getOrgasm);

		context.registerFunction(name, "haveOrgasm", [name, soul](int cause) {
			soul->haveOrgasm(static_cast<Soul::SexType>(cause));
			logSexStats(name, *soul);
		});
		context.registerFunction(name, "orgasmCount", [soul, &context](const ls::Arguments& args) {
			int total = 0;
			if (args.count() == 0)
			{
				total = soul->getTotalOrgasmCount();
			}
			else
			{
				for (int i = 0; i < args.count(); ++i)
				{
					total += soul->getOrgasmCount(static_cast<Soul::SexType>(args[i].asInt()));
				}
			}
			return ls::Value(total);
		});

		context.registerFunction(name, "sexCount", [soul, &context](const ls::Arguments& args) -> ls::Value {
			int total = 0;
			if (args.count() == 0)
			{
				total = soul->getTotalSexCount();
			}
			else
			{
				for (int i = 0; i < args.count(); ++i)
				{
					total += soul->getSexCount(static_cast<Soul::SexType>(args[i].asInt()));
				}
			}
			return ls::Value(total);
		});
	};
	registerSexAbilityGetters(context, "loli", &npc);
	registerSexAbilityGetters(context, "player", &player);

	context.registerFunction("loli", "checkVaginalFit", npc, &Soul::checkVaginalFit);
	context.registerFunction("loli", "performVaginalInsertion", npc, &Soul::performVaginalInsertion);
	context.registerFunction("loli", "checkAnalFit", npc, &Soul::checkAnalFit);
	context.registerFunction("loli", "performAnalInsertion", npc, &Soul::performAnalInsertion);
	context.registerFunction("loli", "hoursUntilBirth", npc, &Soul::getHoursUntilPregnancy);

	context.registerFunction("player", "dickSize", [&player] {
		return 11.5f; // TODO get the actual data(it's in PLayerStats - should it be?)
	});

	context.registerFunction("loli", "breastsWithSize", [&npc] {
		Random& rng = Random::get();
		std::vector<std::string> adjectives;
		// TODO: base off npc.getOppai()
		adjectives.push_back(
			ProportionList<std::string>(
				"petite", 1.0,
				"prepubescent", 1.0,
				"flat", 1.0).get(rng));
		return concatAdjectives(adjectives,
			ProportionList<std::string>(
				"breasts", 2.0).get(rng));
	});

	// TODO: move to loliscript?
	context.registerFunction("local", "dickWithHardness", [&player] {
		Random& rng = Random::get();
		std::vector<std::string> adjectives;
		const float arousal = player.getArousal();
		if (arousal >= 0.75f)
		{
			adjectives.push_back(
				ProportionList<std::string>(
					"rock-hard", 1.0,
					"throbbing", 1.0).get(rng));
		}
		else if (arousal >= 0.5f)
		{
			adjectives.push_back(
				ProportionList<std::string>(
					"hard", 2.5,
					"awakened", 1.0).get(rng));
		}
		if (arousal < 0.25f)
		{
			adjectives.push_back(
				ProportionList<std::string>(
					"soft", 2.5,
					"flaccid", 1.0).get(rng));
			if (rng.chance(0.3f))
			{
				adjectives.push_back("floppy");
			}
		}
		return concatAdjectives(adjectives,
			ProportionList<std::string>(
				"cock", 2.0,
				"dick", 2.0,
				"penis", 1.3,
				"member", 1.1).get(rng));
	});


	// @TODO: remove these and externalize
	registerRandomizedWords(context);
}

} // sl
