#ifndef SL_FACINGDIRECTION_HPP
#define SL_FACINGDIRECTION_HPP

#include "Utility/Vector.hpp"

namespace sl
{

enum FacingDirection : int
{
	East = 0,
	North,
	West,
	South
};

static inline float facingDirToAngle(FacingDirection dir)
{
	return static_cast<int>(dir) * 90.f;
}

static const Vector2f directionalVectors[4] = {
	Vector2f( 1.f,  0.f),
	Vector2f( 0.f, -1.f),
	Vector2f(-1.f,  0.f),
	Vector2f( 0.f,  1.f)
};

static inline const Vector2f& facingDirToVector(FacingDirection dir)
{
	return directionalVectors[static_cast<int>(dir)];
}

static const char* directionalStrings[4] = {
	"east",
	"north",
	"west",
	"south"
};

static inline const char* facingDirToStr(FacingDirection dir)
{
	return directionalStrings[static_cast<int>(dir)];
}

} // sl

#endif // SL_FACINGDIRECTION_HPP