#ifndef SL_FAMILYGEN_HPP
#define SL_FAMILYGEN_HPP

#include "NPC/Stats/Soul.hpp"

namespace sl
{

class Random;
class World;

class FamilyGen
{
public:
	FamilyGen(const SoulGenerationSettings& settings, World& world, Random& rng);


	std::shared_ptr<Soul> createChild(int minAge, int maxAge, float maleChance = 0.5f);

	std::shared_ptr<Soul> getMother();

	std::shared_ptr<Soul> getFather();

	std::shared_ptr<Soul> getParent();

private:
	World& world;
	Random& rng;
	std::shared_ptr<Soul> mother;
	std::shared_ptr<Soul> father;
};

} // sl

#endif // SL_FAMILYGEN_HPP