#ifndef SL_GAMEOFTAG_HPP
#define SL_GAMEOFTAG_HPP

#include <vector>

#include "NPC/GroupAI/GroupAI.hpp"

namespace sl
{

class NPC;

class GameOfTag : public GroupAI<GameOfTag>
{
public:
	GameOfTag();


	// IGroupAI
	void onUpdate() override;

	bool isPersistent() const override;


	// GroupAI
	GroupAI<GameOfTag>::Membership addParticipant(NPC& participant) override;


	void setIt(NPC& it);

	NPC* getIt() const;

	bool isTaggingAllowedNow() const;

	bool isInGame(const NPC& npc) const;

	int getRoundsPlayed() const;
	 
private:
	void updateSpace();
	
	NPC *it;
	int cooldown;
	int roundsPlayed;
};

} // sl

#endif // SL_GAMEOFTAG_HPP