#include "NPC/LifeEvents.hpp"

#include "NPC/Stats/Soul.hpp"

namespace sl
{

std::map<std::string, LifeEvent> LifeEvents::events;

LifeEvents::LifeEvents(Soul& soul)
	:soul(soul)
{
}

void LifeEvents::happen(const std::string& key)
{
	const LifeEvent& ev = getEvent(key);
	const int time = ++timesOccured[key];
	const float c = ev.diminshingReturns(time);
	soul.getStatus().personalityModifiers += c * ev.personalityModifiers;
}

/*static*/ const LifeEvent& LifeEvents::getEvent(const std::string& key)
{
	if (events.empty())
	{
		// TODO: add in events here. maybe load from external file too?
	}
	return events.at(key);
}

} // sl
