/**
 * @section DESCRIPTION
 * A store for which LifeEvent has happened to an NPC. Also keeps track of what kind of modifier shifts to perform (ie first time impacts more, etc)
 * Also works as a database for all definitions of life events.
 */
#ifndef SL_LIFEEVENTS_HPP
#define SL_LIFEEVENTS_HPP

#include <map>
#include <string>

#include "NPC/LifeEvent.hpp"

namespace sl
{

class Soul;

class LifeEvents
{
public:
	LifeEvents(Soul& soul);

	void happen(const std::string& key);

	static const LifeEvent& getEvent(const std::string& key);

private:
	Soul& soul;
	std::map<std::string, int> timesOccured;

	static std::map<std::string, LifeEvent> events;
};

} // sl

#endif // SL_LIFEEVENTS_HPP