#ifndef SL_LOCATIONPATHCACHE_HPP
#define SL_LOCATIONPATHCACHE_HPP

#include <map>
#include <string>
#include <utility>

#include "Pathfinding/PathfindingCommon.hpp"

namespace sl
{

class NPC;
class Deserialize;
class Serialize;

namespace pf
{
class PathManager;
} // pf

class LocationPathCache
{
public:
	std::shared_ptr<const pf::Path> getPath(const std::string& from, const std::string to, NPC& npc, pf::PathManager& pathManager, const pf::WeightMap& weights, float heuristicStrength) const;

	void deserialize(Deserialize& in);

	void serialize(Serialize& out) const;

private:
	mutable std::map<std::pair<std::string, std::string>, std::shared_ptr<pf::Path>> paths;
};

} // sl

#endif // SL_LOCATIONPATHCACHE_HPP