#include "NPC/Locators/CustomTargetLocator.hpp"

#include "NPC/Behaviors/BehaviorContext.hpp"
#include "Utility/Assert.hpp"

namespace sl
{

CustomTargetLocator::CustomTargetLocator(std::function<Target(ai::BehaviorContext&)> customTarget)
	:customTarget(std::move(customTarget))
{
}


Target CustomTargetLocator::findTarget() const
{
	ERROR("This needs a BehaviorContext to work");
	return Target();
}

Target CustomTargetLocator::findTarget(ai::BehaviorContext& context) const
{
	return customTarget(context);
}

} // sl
