#include "NPC/Locators/DynamicTargetLocator.hpp"

#include "NPC/NPC.hpp"

namespace sl
{

DynamicTargetLocator::DynamicTargetLocator(const std::string& key)
	:npc(nullptr)
	,key(key)
{
}

DynamicTargetLocator::DynamicTargetLocator(const Soul& npc, const std::string& key)
	:npc(&npc)
	,key(key)
{
}


Target DynamicTargetLocator::findTarget() const
{
	ASSERT(npc);
	return findTargetImpl(*npc);
}

Target DynamicTargetLocator::findTarget(ai::BehaviorContext& context) const
{
	return findTargetImpl(*context.getNPC().getSoul());
}

// private
Target DynamicTargetLocator::findTargetImpl(const Soul& npc) const
{
	const TargetLocator *target = npc.getLocation(key);
	if (target != nullptr)
	{
		return target->findTarget();
	}
	return Target();
}

} // sl
