#ifndef SL_DYNAMICTARGETLOCATOR_HPP
#define SL_DYNAMICTARGETLOCATOR_HPP

#include <string>

#include "NPC/Locators/TargetLocator.hpp"
#include "Engine/Entity.hpp"

namespace sl
{

class Soul;

class DynamicTargetLocator : public TargetLocator
{
public:
	DynamicTargetLocator(const std::string& key);

	DynamicTargetLocator(const Soul& npc, const std::string& key);


	Target findTarget() const override;

	Target findTarget(ai::BehaviorContext& context) const override;


private:
	Target findTargetImpl(const Soul& npc) const;

	const Soul *npc;
	std::string key;
};

} // sl

#endif // SL_DYNAMICTARGETLOCATOR_HPP