#ifndef SL_ENTITYLOCATORCOMMON_HPP
#define SL_ENTITYLOCATORCOMMON_HPP

#include <functional>
#include <vector>

#include "Engine/Entity.hpp"
#include "NPC/Locators/Target.hpp"

namespace sl
{

enum class LocatorHeuristic
{
	ExactlyClosest,
	ApproximatelyClosest,
	Any,
	Random
};

static constexpr int LOCATOR_UNBOUNDED_DISTANCE = -1;
static constexpr int LOCATOR_NO_MAX_TARGETS = -1;


extern std::vector<Target> findTargetsImpl(const Entity& sourceEntity, Entity::Type queryType, LocatorHeuristic heuristic, int radius, const std::function<bool(Entity*)>& predicate, int maxTargets);

} // sl

#endif // SL_ENTITYLOCATORCOMMON_HPP