#ifndef SL_NPCTEXTBOX_HPP
#define SL_NPCTEXTBOX_HPP

#include <memory>

#include "Engine/Entity.hpp"
#include "Utility/IntrusiveList.hpp"

namespace sl
{

class AbstractTextBox;

class NPCTextBox : public Entity
{
public:
	NPCTextBox(const Entity& owner, std::string message);

	const Types::Type getType() const override;

	const std::string& getMessage() const;

	IntrusiveListNode<Entity> link;

private:
	void onUpdate() override;

	static int getWidth(const std::string& message);

	static int getHeight(const std::string& message);



	AbstractTextBox *textBox;

	int lifetime;

	const Entity *owner;

	float offset;
	//! Here so we can query for the purpose of not displaying too many duplicate messages
	std::string message;
};

} // sl

#endif // SL_NPCTEXTBOX_HPP