#ifndef SL_NAMEDENTITY_HPP
#define SL_NAMEDENTITY_HPP

#include "Engine/Serialization/DeserializeConstructor.hpp"
#include "Engine/Entity.hpp"
#include "Engine/Ref.hpp"

namespace sl
{

class NamedEntity : public Entity
{
public:
	NamedEntity(DeserializeConstructor);

	static void tag(const std::string& name, Entity *entity, const Vector2f& offset = Vector2f());

	void onUpdate() override;

	const Type getType() const override;

	Entity* getEntity();

	// Serializabl
	std::string serializationType() const override;

	bool shouldSerialize() const override;

	void serialize(Serialize& out) const override;

	void deserialize(Deserialize& in) override;

private:
	NamedEntity(const std::string& name, Entity *entity, const Vector2f& offset);

	std::string name;
	Ref<Entity> entity;
};

} // sl

#endif // SL_NAMEDENTITY_HPP