#ifndef SL_REGION_HPP
#define SL_REGION_HPP

#include "Engine/Entity.hpp"

namespace sl
{

class SuspiciousScenario;

class Region : public Entity
{
public:
	DECLARE_SERIALIZABLE_METHODS(Region)
	// TODO: add a type like PUBLIC, PRIVATE, SEMIPRIVATE?

	Region(const Rect<int>& bounds, std::string regionType, int priority = 0);

	void onUpdate() override;

	const Type getType() const override;

	const std::string& getRegionType() const;

	int getPriority() const;

	const SuspiciousScenario* getScenario() const;

	Region& setSuspiciousScenario(const SuspiciousScenario *scenario);

	Region& setRegionBounds(const Rect<int>& bounds);

private:
	std::string regionType;
	int priority;
	const SuspiciousScenario *suspiciousScenario;
};

} // sl

#endif // SL_REGION_HPP