/**
 * @section DESCRIPTION
 * Keeps track of which students are assigned to which desk (in which school).
 * Also manages desk-assignment which hopefully later will try and optimize the travel distance better.
 */
#ifndef SL_SCHOOLREGISTRY_HPP
#define SL_SCHOOLREGISTRY_HPP

#include "NPC/Stats/Soul.hpp"
#include "Engine/Scene.hpp"

namespace sl
{

class Deserialize;
class Serialize;
class NPC;

class SchoolRegistry
{
public:
	//class Key
	//{
	//public:
	//	Key(SchoolRegistry& reg, Soul::ID id);
	//	~Key();

	//	Entity* getDesk() const;

	//private:
	//	Key(Key&);
	//	Key& operator=(Key);

	//	SchoolRegistry *reg;
	//	Soul::ID id;
	//};

	//Key getKey(Soul::ID id) const;
	
	// @TODO: add unregister as well.
	void registerNPC(NPC& npc);

	void registerDesk(Entity *desk);

	Entity* getDesk(Soul::ID id);

	void serialize(Serialize& out) const;

	void deserialize(Deserialize& in);

private:

	std::vector<Entity*> freeDesks;
	//! Which desk an NPC uses, if it has been assigned yet.
	std::map<Soul::ID, Entity*> assignedDesks;
	std::map<Soul::ID, NPC*> desklessNPCs;

	//friend class Key;
};

} // sl

#endif // SL_SCHOOLREGISTRY_HPP