#include "NPC/SoulConjugator.hpp"

#include "NPC/Stats/Soul.hpp"

namespace sl
{

SoulConjugator::SoulConjugator(const Soul& soul)
	:soul(soul)
{
}

std::string SoulConjugator::fullName() const
{
	return soul.getFirstName() + " " + soul.getLastName();
}

std::string SoulConjugator::knownNameCasual() const
{
	return "<casual name>";
}

std::string SoulConjugator::knownNameFormal() const
{
	return "<formal name>";
}

std::string SoulConjugator::personalSubjectPronoun() const
{
	if (soul.getDNA().isMale())
	{
		return "he";
	}
	else
	{
		return "she";
	}
}

std::string SoulConjugator::personalObjectPronoun() const
{
	if (soul.getDNA().isMale())
	{
		return "him";
	}
	else
	{
		return "her";
	}
}

std::string SoulConjugator::possessivePronoun() const
{
	if (soul.getDNA().isMale())
	{
		return "his";
	}
	else
	{
		return "her";
	}
}

std::string SoulConjugator::reflexivePronoun() const
{
	if (soul.getDNA().isMale())
	{
		return "himself";
	}
	else
	{
		return "herself";
	}
}

std::string SoulConjugator::knownOrDefaultName(const std::string& defaultName) const
{
	if (knowsName())
	{
		return soul.getFirstName();
	}
	else
	{
		return defaultName;
	}
}

std::string SoulConjugator::nameForPlayer() const
{
	return "Mister";
}

// private
bool SoulConjugator::knowsName() const
{
	return soul.getFlags().get("knows_name").asBool();
}

bool SoulConjugator::knowsSurname() const
{
	return soul.getFlags().get("knows_surname").asBool();
}

} // sl
