#ifndef SL_SOULCONJUGATOR_HPP
#define SL_SOULCONJUGATOR_HPP

#include <string>

namespace sl
{

class Soul;

class SoulConjugator
{
public:
	SoulConjugator(const Soul& soul);

	std::string fullName() const;

	std::string knownNameCasual() const;

	std::string knownNameFormal() const;

	std::string personalSubjectPronoun() const;

	std::string personalObjectPronoun() const;

	std::string possessivePronoun() const;

	std::string reflexivePronoun() const;

	std::string knownOrDefaultName(const std::string& defaultName) const;

	std::string nameForPlayer() const;

private:
	bool knowsName() const;

	bool knowsSurname() const;

	const Soul& soul;
};


} // sl

#endif // SL_SOULCONJUGATOR_HPP