#include "NPC/States/KidnappedState.hpp"

#include "NPC/Behaviors/LoliBehaviors.hpp"
#include "NPC/NPC.hpp"
#include "NPC/Locators/Target.hpp"
#include "NPC/States/IdleState.hpp"
#include "Player/Player.hpp"
#include "Utility/Random.hpp"
#include "Utility/Memory.hpp"

namespace sl
{

KidnappedState::KidnappedState(NPC& owner)
	:NPCState(owner)
{
	behavior = ai::captiveNode();

	loadWalkAnims();

	owner.setDrawableSet("south");

	owner.setPathfindingWeightMap("npc_routine");
}

void KidnappedState::update()
{
#ifdef SL_DEBUG
	behavior->debugExecute(owner.getBehaviorContext());
#else
	behavior->execute(owner.getBehaviorContext());
#endif
}

void KidnappedState::handleEvent(const Event& event)
{
	if (event.getCategory() == Event::Category::NonBroadcasted && event.getName() == "update_drawables")
	{
		loadWalkAnims();
	}
}

void KidnappedState::onEnter()
{
	setPathManager("StaticGeometry");
}

} // sl