#ifndef SL_COPPATROLSTATE_HPP
#define SL_COPPATROLSTATE_HPP

#include "NPC/NPCState.hpp"
#include "NPC/Behaviors/BehaviorTreeNode.hpp"

namespace sl
{

class Car;
class PoliceForce;

class CopPatrolState : public NPCState
{
public:
	CopPatrolState(NPC& owner, Car *car);

	void update() override;

private:
	void onEnter() override;

	void onExit() override;

	void handleEvent(const Event& event) override;

	enum class State
	{
		Normal,
		Shooting
	};

	// car - can be nullptr if they're on foot. TODO: have multiple officers share a care and work as a squad?
	Car *car;
	PoliceForce *police;
	State state;
	int cooldown;
	std::unique_ptr<ai::BehaviorTreeNode> behaviorTree;
};

} // sl

#endif // SL_COPPATROLSTATE_HPP
