#include "NPC/States/ShopkeeperState.hpp"

#include "Engine/Events/Event.hpp"
#include "NPC/Behaviors/AcceptTalkWithPlayer.hpp"
#include "NPC/NPC.hpp"
#include "Player/Player.hpp"
#include "Utility/Memory.hpp"


namespace sl
{

ShopkeeperState::ShopkeeperState(NPC& owner, const std::string& dialogueStart)
	:NPCState(owner)
	,dialogueStart(dialogueStart)
{
	auto sprite = unique<Sprite>("candyshop/candychef.png", owner.getSoul()->appearance.getHairSwapID() | owner.getSoul()->appearance.getBodySwapID(), 12, 27 + 24);
	owner.addDrawableToSet("south", std::move(sprite));

	owner.setDrawableSet("south");

	// @todo put inventory init somewhere else (probably in something that gets set once every X days)
	Inventory& items = owner.getSoul()->items;
#define STUB_ADD(type, count) for (int i = 0; i < count; ++i, items.addItem(Item(Item::strToType(type))));
	STUB_ADD("candy", 10);
	STUB_ADD("chocolatebar", 5);
	STUB_ADD("lollipop", 3);
#undef STUB_ADD

	behavior = unique<ai::AcceptTalkWithPlayer>(dialogueStart);
}

void ShopkeeperState::update()
{
	behavior->execute(owner.getBehaviorContext());
}

} // sl