#ifndef SL_SLEEPINGSTATE_HPP
#define SL_SLEEPINGSTATE_HPP

#include "NPC/Behaviors/BehaviorTreeNode.hpp"
#include "NPC/NPCState.hpp"
#include "Utility/Time/GameTime.hpp"

namespace sl
{

class Bed;

class SleepingState : public NPCState
{
public:
	SleepingState(NPC& owner, const GameTime& wakeupTime, Bed *bed = nullptr);

	void update() override;

private:

	void onEnter() override;

	void onExit() override;


	GameTime wakeupTime;
	Bed *bed;
	std::unique_ptr<ai::BehaviorTreeNode> behavior;
};

} // sl

#endif // SL_SLEEPINGSTATE_HPP