#ifndef SL_COLORPREF_HPP
#define SL_COLORPREF_HPP

#include <SFML/Graphics/Color.hpp>

#include <string>

namespace sl
{

enum class ColorPref
{
	Red = 0,
	Green,
	Blue,
	Pink,
	White,
	Black,
	Purple,
	Orange,
	Yellow,
	Cyan,
	Brown
};

enum { COLOR_PREF_COUNT = 11 };

class ColorPrefInfo
{
public:
	ColorPrefInfo()
		:rgb(255, 0, 255)
		,name("invalid color")
	{
	}

	ColorPrefInfo(const sf::Color rgb, std::string name)
		:rgb(rgb)
		,name(std::move(name))
	{
	}

	sf::Color rgb;
	std::string name;
};

extern const ColorPrefInfo& getInfo(ColorPref color);

extern ColorPref colorPrefFromString(const std::string& name);

} // sl

#endif // SL_COLORPREF_HPP