#ifndef SL_CONCEPTS_HPP
#define SL_CONCEPTS_HPP

#include "NPC/Stats/Associations.hpp"

#include <map>
#include <string>
#include <vector>

namespace sl
{

class Concepts
{
public:
	const Associations& makeDefault() const;

	bool isRegisteredConcept(const std::string& concept) const;

	int getConceptIndex(const std::string& concept) const;

	int getConceptCount() const;

	const std::string& getConcept(int index) const;

	static const Concepts& get();

	static Concepts makeEmpty();
	
	// fine being public since we return a const for get()
	void registerConcept(const std::string& concept);

private:
	Concepts(bool loadFile);
	
	Associations defaultAssociations;
	std::map<std::string, int> registeredConcepts;
	std::vector<std::string> registeredConceptsFromIndex;
};

} // sl

#endif // SL_CONCEPTS_HPP