#include "NPC/Stats/GeneticStats.hpp"

#include "NPC/Stats/DNA.hpp"
#include "NPC/Stats/DNADatabase.hpp"

namespace sl
{

GeneticStats::GeneticStats()
	:strength(0)
	,dexterity(0)
	,beauty(0)
	,tallness(0)
	,heaviness(0)
	,willpower(0)
	,intelligence(0)
	,gullibility(0)
	,libido(0)
	,oppai(0)
	,vaginalTightness(0)
	,vaginalDepth(0)
	,analTightness(0)
	,pubertyStart(0)
	,personalityModifiers()
{
}

GeneticStats::GeneticStats(const DNA& dna)
	:strength(0)
	,dexterity(0)
	,beauty(0)
	,tallness(0)
	,heaviness(0)
	,willpower(0)
	,intelligence(0)
	,gullibility(0)
	,libido(0)
	,oppai(0)
	,vaginalTightness(0)
	,vaginalDepth(0)
	,analTightness(0)
	,pubertyStart(0)
	,personalityModifiers()
{
	for (int geneIndex = 0; geneIndex < DNA_SIZE; ++geneIndex)
	{
		*this += DNADatabase::get().getGene(dna, static_cast<DNA::Index>(geneIndex)).effects;
	}
}

GeneticStats& GeneticStats::operator+=(const GeneticStats& rhs)
{
	strength += rhs.strength;
	dexterity += rhs.dexterity;
	beauty += rhs.beauty;
	tallness += rhs.tallness;
	willpower += rhs.willpower;
	intelligence += rhs.intelligence;
	gullibility += rhs.gullibility;
	libido += rhs.libido;
	oppai += rhs.oppai;
	vaginalTightness += rhs.vaginalTightness;
	vaginalDepth += rhs.vaginalDepth;
	analTightness += rhs.analTightness;
	pubertyStart += rhs.pubertyStart;
	personalityModifiers += rhs.personalityModifiers;
	return *this;
}

GeneticStats operator+(const GeneticStats& lhs, const GeneticStats& rhs)
{
	GeneticStats result(lhs);
	result += rhs;
	return result;
}

}