#ifndef SL_GENETICSTATS_HPP
#define SL_GENETICSTATS_HPP

#include <cstdint>

#include "NPC/Stats/PersonalityModifiers.hpp"

namespace sl
{

class DNA;

class GeneticStats
{
public:
	GeneticStats();

	GeneticStats(const DNA& dna);

	GeneticStats& operator+=(const GeneticStats& rhs);


	/*		physical		*/
	//! genetic contribution to strength
	int8_t strength;
	//! genetic contribution to dexterity
	int8_t dexterity;
	//! genetic contribution to physical attractiveness
	int8_t beauty;
	//! genetic contribution to height in % variation
	int8_t tallness;
	//! genetic contribution to weight in % variation
	int8_t heaviness;

	// TODO: figure out if these should even have a genetic component, instead of 100% environmental
	/*		mental		*/
	//! genetic contribution to willpower
	int8_t willpower;
	//! genetic contribution to intelligence
	int8_t intelligence;
	//! genetic contribution to gullibility
	int8_t gullibility;
	//! genetic contribution to charisma
	int8_t charisma;
	
	/*		sexual		*/
	//! genetic contribution to libido in %
	int8_t libido;
	//! genetic contribution to breast size in %
	int8_t oppai;
	//! genetic vaginal tightness variation in %
	int8_t vaginalTightness;
	//! genetic vaginal depth variation in %
	int8_t vaginalDepth;
	//! genetic vaginal tightness variation in %
	int8_t analTightness;
	//! genetic deviation of puberty start in days
	int8_t pubertyStart;


	PersonalityModifiers personalityModifiers;
};

extern GeneticStats operator+(const GeneticStats& lhs, const GeneticStats& rhs);

} // sl

#endif