/**
 * @section DESCRIPTION
 * Contains functions for mapping hair/eye/etc colours to their proper
 * physical ColorSwapID values for when they're actully displayed
 */
#ifndef SL_NPCCOLORSWAPS_HPP
#define SL_NPCCOLORSWAPS_HPP

#include "NPC/Stats/DNA.hpp"

namespace sl
{

class ColorSwapID;

const ColorSwapID& toColorSwapID(DNA::HairColor hairColour);

const ColorSwapID& toColorSwapID(DNA::SkinColor hairColour);

const ColorSwapID& toColorSwapID(DNA::EyeColor eyeColour);

} // sl

#endif // SL_NPCCOLORSWAPS_HPP
