#ifndef SL_NUTRITION_HPP
#define SL_NUTRITION_HPP
namespace sl
{

class Nutrition
{
public:
	/**
	 * Construct an empty Nutrition object with 0 macros (0 calories)
	 */
	Nutrition();

	/**
	 * Constructs a Nutrition that is calories calories, using the ratios from other
	 */
	Nutrition(float calories, const Nutrition& other);

	float getTotalCalories() const;

	float getTotalCarbs() const;

	float getTotalFat() const;

	float getTotalProtein() const;

	Nutrition& operator+=(const Nutrition& rhs);

	Nutrition& operator-=(const Nutrition& rhs);



	float starch;
	float fiber;
	float sugar;

	float omega3;
	float polyunsaturated;
	float monounsaturated;
	float saturated;
	float trans;

	float protein;
};

class Serialize;
class Deserialize;

namespace AutoSerialize
{
void serialize(Serialize& out, const Nutrition& nutrition);
} // AutoSerialize

namespace AutoDeserialize
{
void deserialize(Deserialize& in, Nutrition& nutrition);
} // AutoDeserialize

} // sl

#endif // SL_NUTRITION_HPP