#ifndef SL_BLOOD_HPP
#define SL_BLOOD_HPP

#include "Engine/Entity.hpp"

namespace sl
{

class Noise : public Entity
{
public:
	class Level
	{
	public:
		static const float innocent;
		static const float concerning; // potentially suspicious things (minimum to investigatge)
		static const float serious;     // screams for help, etc
	};
	/**
	 * @param pos The position the noise occurs
	 * @param concernLevel The severity level of the noise (how much people will be concerned)
	 * @param radius How far people hear the noise from (game units(pixels))
	 */
	Noise(const Vector2f& pos, float concernLevel, float radius);
	
	enum class PremadeTypes
	{

	};
	


	float getConcernLevel() const;

	float getLoudness() const;



	const Types::Type getType() const override;

private:
	void onUpdate() override;
	

	float radius;
	float goalRadius;
	float concernLevel;
};

} // sl

#endif // SL_BLOOD_HPP
