#include "NPC/Stealth/Suspicion.hpp"

#include "Engine/ScenePos.hpp"
#include "NPC/NPC.hpp"
#include "Utility/Assert.hpp"

#include <numeric>

namespace sl
{

float computeLocationalSuspicion(NPC& viewer, Player& player)
{
	ERROR("implement this");
	return -1.f;
}

std::vector<NPC*> computeViewers(const ScenePos& pos)
{
	std::list<NPC*> npcsNear;
	pos.getScene()->cull(npcsNear, rectAround(pos.getPos(), 480.f));
	std::vector<NPC*> output;
	for (NPC *npc : npcsNear)
	{
		if (!npc->canSee(pos.getPos()) && !npc->canHear(pos.getPos(), 192.f))
		{
			output.push_back(npc);
		}
	}
	return output;
}

std::vector<NPC*> computeViewers(const NPC& npc)
{
	auto ret = computeViewers(ScenePos(npc));
	for (unsigned int i = 0; i < ret.size(); ++i)
	{
		if (&npc == ret[i])
		{
			std::swap(ret[i], ret.back());
			ret.pop_back();
		}
	}
	return ret;
}

float computePrivacy(const ScenePos& pos, Player *playerToExclude, std::vector<NPC*> npcsToExclude)
{
	// TODO: factor in playerToExclude
	const auto npcsNear = computeViewers(pos);
	const float watcherComponent = std::accumulate(
		npcsNear.begin(),
		npcsNear.end(),
		0.f,
		[&](float x, NPC *npc) {
			return std::find(npcsToExclude.begin(), npcsToExclude.end(), npc) != npcsToExclude.end()
				? x
				: x + 0.3f; // TODO: make it factor in their distance, etc
		});
	const float environmentComponent = pos.getScene()->getType() == "Town" ? 0.5f : 1.f;
	const float r = std::clamp(environmentComponent - watcherComponent, 0.f, 1.f);
	std::cout << "privacy() = " << r << std::endl;
	return r;
}


} // sl