#ifndef SL_SUSPICION_HPP
#define SL_SUSPICION_HPP

#include "NPC/Stealth/SuspicionContext.hpp"

#include <vector>

namespace sl
{

class ScenePos;
class NPC;
class Player;

extern float computeLocationalSuspicion(NPC& viewer, Player& player);

/**
 * @return All NPCs that can see {\param pos}
 */
extern std::vector<NPC*> computeViewers(const ScenePos& pos);

/**
 * @return All the OTHER NPCs that can see {\param npc} (ie excluding {\param npc}
 */
extern std::vector<NPC*> computeViewers(const NPC& npc);

extern float computePrivacy(const ScenePos& pos, Player *playerToExclude, std::vector<NPC*> npcsToExclude);

} // sl

#endif //SL_SUSPICION_HPP