/**
* @section DESCRIPTION
* Contextual information used when evaluating how suspicious a situation is.
* ie being at a mall at 7pm is fine, but 3am is suspicious
* or being in a park with kids is suspicious, but not if you're walking your dog
*/
#ifndef SL_SUSPICIONCONTEXT_HPP
#define SL_SUSPICIONCONTEXT_HPP

#include "Town/World.hpp"

namespace sl
{

class NPC;
class Soul;

class SuspicionContext
{
public:
	SuspicionContext(NPC& self);


	const GameTime& time() const;

	const Scene& scene() const;

	const World& world() const;

	const NPC& selfNPC() const;

	const Soul& selfSoul() const;

private:
	const NPC& self;
};

typedef std::function<float(const SuspicionContext&)> SuspicionModifier;

} // sl

#endif // SL_SUSPICIONCONTEXT_HPP