#include "NPC/Stealth/SuspiciousLocations.hpp"

#include "NPC/Stealth/SuspicionContext.hpp"

namespace sl
{

namespace SuspiciousLocations
{

SuspiciousScenario publicBathroom(bool isMale, const SuspiciousScenario *parent, float suspicionAmplifier)
{
	SuspiciousScenario scenario("public_bathroom", suspicionAmplifier * 10.f, parent);
	scenario.addModifier([isMale](const SuspicionContext& context) {
		return isMale == context.selfSoul().getDNA().isMale() ? 1.f : 0.f;
	});
	return scenario;
}

SuspiciousScenario school()
{
	SuspiciousScenario scenario("school", 10.f);
	return scenario;
}

const SuspiciousScenario* byKey(const std::string& name)
{
	static std::map<std::string, SuspiciousScenario> cachedScenarios;
	auto it = cachedScenarios.find(name);
	if (it == cachedScenarios.end())
	{
		if (name == "girls_bathroom")
		{
			it = cachedScenarios.insert(std::make_pair(name, publicBathroom(false))).first;
		}
		else if (name == "boys_bathroom")
		{
			it = cachedScenarios.insert(std::make_pair(name, publicBathroom(true))).first;
		}
		else if (name == "school_library")
		{
			return nullptr;
		}
		else if (name == "teachers_lounge")
		{
			return nullptr;
		}
		else if (name == "janitor_room")
		{
			return nullptr;
		}
		else if (name == "classroom")
		{
			return nullptr;
		}
		else if (name == "school_gym")
		{
			return nullptr;
		}
		else
		{
			ERROR("invalid suspicious location \"" + name + "\".");
		}
	}
	return &it->second;
}

} // SuspiciousLocations

} // s;