#ifndef SL_SUSPICIOUSSCENARIO_HPP
#define SL_SUSPICIOUSSCENARIO_HPP

#include <functional>
#include <string>

#include "NPC/Stealth/SuspicionContext.hpp"

namespace sl
{

class SuspiciousScenario
{
public:
	SuspiciousScenario(std::string type, float baseSuspicion, const SuspiciousScenario *parent = nullptr);


	SuspiciousScenario& addModifier(SuspicionModifier modifier);

	float getSuspicion(const SuspicionContext& context) const;

private:
	std::string type;
	float baseSuspicion;
	std::vector<SuspicionModifier> modifiers;
	const SuspiciousScenario *parent;
};

} // sl

#endif // SL_SUSPICIOUSSCENARIO_HPP
