#ifndef SL_THROWNITEM_HPP
#define SL_THROWNITEM_HPP

#include "Engine/Entity.hpp"
#include "Engine/Serialization/DeserializeConstructor.hpp"
#include "Items/Item.hpp"

namespace sl
{

class Deserialize;
class Serialize;

class ThrownItem : public Entity
{
public:
	DECLARE_SERIALIZABLE_METHODS(ThrownItem)

	// @TODO hook this up to actual items in the inventory and maybe don't hardcode the arc calculation here?
	ThrownItem(const Vector2f& start, const Vector2f& target, Item item);

	ThrownItem(DeserializeConstructor);

	const Types::Type getType() const override;

private:
	void onUpdate() override;
	
	Vector2f veloc;
	float heightVeloc;
	float currentHeight;
	Item item;
};

} // sl

#endif // SL_THROWNITEM_HPP
