#ifndef SL_URINE_HPP
#define SL_URINE_HPP

#include <cstdint>

namespace sl
{

struct Urine
{
	//! The urobilin (yellowness) content in ul (microlitre)
	uint16_t urobilin;
	//! The fluid content in ml (millilitre)
	uint16_t fluid;

	Urine& operator+=(const Urine& rhs)
	{
		urobilin += rhs.urobilin;
		fluid += rhs.fluid;
		return *this;
	}

	Urine& operator-=(const Urine& rhs)
	{
		urobilin -= rhs.urobilin;
		fluid -= rhs.fluid;
		return *this;
	}
};

} // sl

#endif // SL_URINE_HPP