#ifndef SL_LS_BOUNDNUMBER_HPP
#define SL_LS_BOUNDNUMBER_HPP

#include "Parsing/Binding/BoundVar.hpp"

namespace sl
{
namespace ls
{

template <typename T>
class BoundNumber : public BoundVar
{
public:
	BoundNumber(T& reference);

	void set(const Value& value) override;

	Value get() const;
private:
	T& variable;
};

template <typename T>
BoundNumber<T>::BoundNumber(T& reference)
	:variable(reference)
{
}


template <>
inline void BoundNumber<int>::set(const Value& value)
{
	variable = value.asInt();
}

template <>
inline void BoundNumber<bool>::set(const Value& value)
{
	variable = value.asBool();
}

template <typename T>
inline void BoundNumber<T>::set(const Value& value)
{
	variable = value.asFloat();
}

template <typename T>
Value BoundNumber<T>::get() const
{
	return Value(variable);
}

} // ls
} // sl

#endif // SL_LS_BOUNDNUMBER_HPP
