#ifndef SL_LS_FLAGS_HPP
#define SL_LS_FLAGS_HPP

#include <string>
#include <map>
#include "Parsing/Binding/Value.hpp"

namespace sl
{

class Serialize;
class Deserialize;

namespace ls
{

class Bindings;

class Flags
{
public:
	void set(const std::string& name, Value value);

	const Value& get(const std::string& name) const;

	bool exists(const std::string& name) const;

	void serialize(Serialize& out) const;

	void deserialize(Deserialize& in);

private:
	std::map<std::string, Value> flags;
};

extern void registerFlags(Bindings& context, Flags& flags, const std::string& scope);

} // ls
} // sl

#endif // SL_LS_FLAGS_HPP
