#include "Parsing/Binding/Parameters.hpp"

#include "Utility/Assert.hpp"
#include "Parsing/SyntaxTree/Expressions/Expression.hpp"
#include "Parsing/SyntaxTree/Expressions/FuncCall.hpp"
#include "Parsing/Binding/Bindings.hpp"

namespace sl
{
namespace ls
{

void Parameters::addParameter(std::unique_ptr<const Expression> expParam)
{
	expressions.push_back(std::move(expParam));
}

Value Parameters::getParameter(const Bindings& context, int parameterIndex) const
{
	ASSERT(parameterIndex >= 0 && parameterIndex < expressions.size());
	return expressions[parameterIndex]->evaluate(context);
}

int Parameters::size() const
{
	return expressions.size();
}

} // ls
} // sl
