#ifndef SL_LS_RUNTIMEERROR_HPP
#define SL_LS_RUNTIMEERROR_HPP

#include <exception>
#include <string>

namespace sl
{
namespace ls
{

class Statement;

class RuntimeError : public std::exception
{
public:
	RuntimeError(const std::string& info, const Statement *statement = nullptr);
	
	virtual ~RuntimeError() throw() = default;

	virtual const char* what() const throw();

	void annotate(const Statement *statement);

	bool isAnnotated() const;

private:
	std::string origInfo;
	std::string formattedInfo;
	bool annotated;
};

} // ls
} // sl

#endif // SL_LS_RUNTIMEERROR_HPP