#include "Parsing/Errors/SyntaxError.hpp"

namespace sl
{
namespace ls
{

SyntaxError::SyntaxError(const std::string& info)
	:info("Syntax error: ")
{
	this->info += info;
}

SyntaxError::SyntaxError(const SyntaxError& base, const std::string& info)
	:info(base.info)
{
	this->info += info;
}

const char * SyntaxError::what() const throw()
{
	return info.c_str();
}

} // ls
} // sl
