#ifndef SL_LS_PARSERUTIL_HPP
#define SL_LS_PARSERUTIL_HPP

#include <cstring>

namespace sl
{
namespace ls
{



static inline bool isValidIdentifierStart(char c)
{
	return (c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z');
}

static inline bool isValidIdentifierBody(char c)
{
	return isValidIdentifierStart(c) || (c >= '0' && c <= '9') || (c == '_');
}

static inline bool isKeyword(const char *c, const char *keyword, int len)
{
	return strncmp(c, keyword, len) == 0 && !isValidIdentifierBody(c[len]);
}

static inline bool isEnd(char c)
{
	return c == '\0' || c == '\n' || c == '\r';
}

static inline bool isWhitespace(char c)
{
	return c == ' ' || c == '\t';
}

static inline void eatWhitespace(const char*& c)
{
	while (isWhitespace(*c))
	{
		++c;
	}
}

} // ls
} // sl

#endif // SL_LS_PARSERUTIL_HPP