#ifndef SL_LS_STATEMENTPARSER_HPP
#define SL_LS_STATEMENTPARSER_HPP

#include <memory>
#include <vector>

#include "Parsing/SyntaxTree/Statements/Statement.hpp"


class Bindings;

namespace sl
{
namespace ls
{

class ExpressionParser;

extern std::unique_ptr<Statement> parseSingleStatement(const char *str);

extern std::unique_ptr<Statement> parseFile(const char *filename);

/**
 * @param strings The text to parse
 * @param first The first line to parse
 * @param last The line to stop BEFORE. ie first = 0, last = 10 gets you lines 0-9. If last = 0, then parse until end of strings
 * @param filename The filename to tag Statements with
 * @return An executable Statement resulting from the strings being parsed
 */
extern std::unique_ptr<Statement> parseStrings(ExpressionParser& expressionParser, const std::vector<std::string>& strings, std::size_t first = 0, std::size_t last = 0, const std::string& filename = "n/a");

extern void executeFile(const char *filename, Bindings& context);

extern void executeStrings(const std::vector<std::string>& strings, Bindings& context);

} // ls
} // sl

#endif // SL_LS_STATEMENTPARSER_HPP
