#include "Parsing/SyntaxTree/Expressions/FuncCall.hpp"

#include "Parsing/Binding/Parameters.hpp"
#include "Parsing/Binding/Bindings.hpp"

namespace sl
{
namespace ls
{

FuncCall::FuncCall(const std::string& filename, int uniqueId, const std::string& scope, const std::string& name, std::unique_ptr<const Parameters> parameters)
	:Expression(filename, uniqueId)
	,scope(scope)
	,name(name)
	,parameters(std::move(parameters))
{
}

Value FuncCall::onEvaluate(const Bindings& context) const
{
	return context.evaluateFunction(scope, name, *parameters);
}

void FuncCall::lint(LintBindings& context) const
{
	context.checkFunction(scope, name);
}

} // ls
} // sl
