#ifndef SL_LS_FUNCCALL_HPP
#define SL_LS_FUNCCALL_HPP

#include <memory>

#include "Parsing/SyntaxTree/Expressions/Expression.hpp"

namespace sl
{
namespace ls
{

class Parameters;

class FuncCall : public Expression
{
public:
	FuncCall(const std::string& filename, int uniqueId, const std::string& scope, const std::string& name, std::unique_ptr<const Parameters> parameters);


	Value onEvaluate(const Bindings& context) const override;

	void lint(LintBindings& context) const override;

private:
	FuncCall(FuncCall& other);
	FuncCall& operator=(FuncCall& other);


	const std::string scope;
	const std::string name;
	std::unique_ptr<const Parameters> parameters;
};

} // ls
} // sl

#endif // SL_LS_FUNCCALL_HPP
