#ifndef SL_LS_LITERAL_HPP
#define SL_LS_LITERAL_HPP

#include "Parsing/SyntaxTree/Expressions/Expression.hpp"

namespace sl
{
namespace ls
{

class Literal : public Expression
{
public:
	template <typename T>
	Literal(const std::string& filename, int uniqueId, T value)
		:Expression(filename, uniqueId)
		,value(std::move(value))
	{
	}

	Value onEvaluate(const Bindings& context) const override;

	void lint(LintBindings& context) const override {}

private:
	const Value value;
};

} // ls
} // sl

#endif // SL_LS_LITERAL_HPP
