#ifndef SL_LS_LOGICAL_HPP
#define SL_LS_LOGICAL_HPP

#include "Parsing/SyntaxTree/Expressions/Expression.hpp"

#include <memory>

namespace sl
{
namespace ls
{

class LogicalAnd : public Expression
{
public:
	LogicalAnd(const std::string& filename, int uniqueId, std::unique_ptr<const Expression> lhs, std::unique_ptr<const Expression> rhs);

	Value onEvaluate(const Bindings& context) const override;

	void lint(LintBindings& context) const override;

private:
	const std::unique_ptr<const Expression> lhs;
	const std::unique_ptr<const Expression> rhs;
};




class LogicalOr : public Expression
{
public:
	LogicalOr(const std::string& filename, int uniqueId, std::unique_ptr<const Expression> lhs, std::unique_ptr<const Expression> rhs);

	Value onEvaluate(const Bindings& context) const override;

	void lint(LintBindings& context) const override;

private:
	const std::unique_ptr<const Expression> lhs;
	const std::unique_ptr<const Expression> rhs;
};




class Inverse : public Expression
{
public:
	Inverse(const std::string& filename, int uniqueId, std::unique_ptr<const Expression> expression);

	Value onEvaluate(const Bindings& context) const override;

	void lint(LintBindings& context) const override;

private:
	const std::unique_ptr<const Expression> expression;
};

} // ls
} // sl

#endif // SL_LS_LOGICAL_HPP
