#ifndef SL_LS_RELATIONAL_HPP
#define SL_LS_RELATIONAL_HPPValue evaluate(const Bindings& context) const override

#include "Parsing/SyntaxTree/Expressions/Expression.hpp"

#include <memory>

namespace sl
{
namespace ls
{

class Equals : public Expression
{
public:
	Equals(const std::string& filename, int uniqueId, std::unique_ptr<const Expression> lhs, std::unique_ptr<const Expression> rhs);

	Value onEvaluate(const Bindings& context) const override;

	void lint(LintBindings& context) const override;

private:
	const std::unique_ptr<const Expression> lhs;
	const std::unique_ptr<const Expression> rhs;
};




class LessThan : public Expression
{
public:
	LessThan(const std::string& filename, int uniqueId, std::unique_ptr<const Expression> lhs, std::unique_ptr<const Expression> rhs);

	Value onEvaluate(const Bindings& context) const override;

	void lint(LintBindings& context) const override;

private:
	const std::unique_ptr<const Expression> lhs;
	const std::unique_ptr<const Expression> rhs;
};




class LessThanOrEqual : public Expression
{
public:
	LessThanOrEqual(const std::string& filename, int uniqueId, std::unique_ptr<const Expression> lhs, std::unique_ptr<const Expression> rhs);

	Value onEvaluate(const Bindings& context) const override;

	void lint(LintBindings& context) const override;

private:
	const std::unique_ptr<const Expression> lhs;
	const std::unique_ptr<const Expression> rhs;
};




class GreaterThan : public Expression
{
public:
	GreaterThan(const std::string& filename, int uniqueId, std::unique_ptr<const Expression> lhs, std::unique_ptr<const Expression> rhs);

	Value onEvaluate(const Bindings& context) const override;

	void lint(LintBindings& context) const override;

private:
	const std::unique_ptr<const Expression> lhs;
	const std::unique_ptr<const Expression> rhs;
};




class GreaterThanOrEqual : public Expression
{
public:
	GreaterThanOrEqual(const std::string& filename, int uniqueId, std::unique_ptr<const Expression> lhs, std::unique_ptr<const Expression> rhs);

	Value onEvaluate(const Bindings& context) const override;

	void lint(LintBindings& context) const override;

private:
	const std::unique_ptr<const Expression> lhs;
	const std::unique_ptr<const Expression> rhs;
};

} // ls
} // sl

#endif // SL_LS_RELATIONAL_HPP
