#include "Parsing/SyntaxTree/Expressions/Variable.hpp"

#include "Parsing/Binding/Bindings.hpp"

namespace sl
{
namespace ls
{

Variable::Variable(const std::string& filename, int uniqueId, const std::string& scope, const std::string& name)
	:Expression(filename, uniqueId)
	,scope(scope)
	,name(name)
{
}

Value Variable::onEvaluate(const Bindings& context) const
{
	return context.getVar(scope, name);
}

void Variable::lint(LintBindings& context) const
{
	// TODO: have some way in Bindings to check if it's actually a local
	// but this is probably fine by now since we usually only bind functions, not variables.
	// actually, this could still be bad because of enums
	// (but those I add to my syntax highlighting anyway so they're visually obvious when spelled wrong)
	if (scope != "local")
	{
		context.checkVariable(scope, name);
	}
}

} // ls
} // sl
