#ifndef SL_LS_VARIABLE_HPP
#define SL_LS_VARIABLE_HPP

#include <string>
#include "Parsing/SyntaxTree/Expressions/Expression.hpp"

namespace sl
{
namespace ls
{

class Variable : public Expression
{
public:
	Variable(const std::string& filename, int uniqueId, const std::string& scope, const std::string& name);

	Value onEvaluate(const Bindings& context) const override;

	void lint(LintBindings& context) const override;

private:
	const std::string scope;
	const std::string name;
};

} // ls
} // sl

#endif // SL_LS_VARIABLE_HPP
