#ifndef SL_LS_BLOCK_HPP
#define SL_LS_BLOCK_HPP

#include <vector>
#include "Parsing/SyntaxTree/Statements/Statement.hpp"

namespace sl
{
namespace ls
{

class Block : public Statement
{
public:
	Block(std::string filename, int line); //  Empty block
	Block(std::string filename, int line, std::vector<std::unique_ptr<Statement>> statements);

	void onExecute(Bindings& context) const override;

	void lint(LintBindings& context) const override;

private:
	const std::vector<std::unique_ptr<Statement>> statements;
};

} // ls
} // sl

#endif // SL_LS_BLOCK_HPP
