#ifndef SL_LS_CHANCEPROBABILITY_HPP
#define SL_LS_CHANCEPROBABILITY_HPP

#include "Parsing/SyntaxTree/Statements/Statement.hpp"
#include "Parsing/SyntaxTree/Expressions/Expression.hpp"

namespace sl
{
namespace ls
{

class ChanceProbability : public Statement
{
public:
	// TODO: differnet types if probabilites (persist, non-linear, etc)
	ChanceProbability(std::string filename, int line);

	void addCase(std::unique_ptr<const Expression> probability, std::unique_ptr<const Statement> body);

	void onExecute(Bindings& context) const override;

	void lint(LintBindings& context) const override;

private:
	std::vector<std::pair<std::unique_ptr<const Expression>, std::unique_ptr<const Statement>>> cases;
};

} // ls
} // sl

#endif // SL_LS_CHANCEPROBABILITY_HPP
