#ifndef SL_LS_IF_HPP
#define SL_LS_IF_HPP

#include "Parsing/SyntaxTree/Statements/Statement.hpp"
#include "Parsing/SyntaxTree/Expressions/Expression.hpp"

namespace sl
{
namespace ls
{

class If : public Statement
{
public:
	If(std::string filename, int line, std::unique_ptr<const Expression> condition, std::unique_ptr<const Statement> onTrue, std::unique_ptr<const Statement> onFalse = nullptr);

	void onExecute(Bindings& context) const override;

	void lint(LintBindings& context) const override;

private:
	const std::unique_ptr<const Expression> condition;
	const std::unique_ptr<const Statement> onTrue;
	const std::unique_ptr<const Statement> onFalse;
};

} // ls
} // sl

#endif // SL_LS_IF_HPP
