#include "Parsing/SyntaxTree/Statements/Proc.hpp"

namespace sl
{
namespace ls
{

Proc::Proc(std::string filename, int line, const std::string& scope, const std::string& name, std::unique_ptr<const Parameters> parameters)
	:Statement(std::move(filename), line)
	,scope(scope)
	,name(name)
	,parameters(std::move(parameters))
{
}

void Proc::onExecute(Bindings& context) const
{
	context.evaluateFunction(scope, name, *parameters);
}

void Proc::lint(LintBindings& context) const
{
	context.markLine(getLine());
	context.checkFunction(scope, name);
}

} // ls
} // sl