#ifndef SL_LS_PROC_HPP
#define SL_LS_PROC_HPP

#include <memory>
#include "Parsing/SyntaxTree/Statements/Statement.hpp"
#include "Parsing/Binding/Bindings.hpp"
#include "Parsing/Binding/Parameters.hpp"

namespace sl
{
namespace ls
{

class Proc : public Statement
{
public:
	Proc(std::string filename, int line, const std::string& scope, const std::string& name, std::unique_ptr<const Parameters> parameters);

	void onExecute(Bindings& context) const override;

	void lint(LintBindings& context) const override;

private:
	const std::string scope;
	const std::string name;
	std::unique_ptr<const Parameters> parameters;
};

} // ls
} // sl

#endif // SL_LS_PROC_HPP