#include "Parsing/SyntaxTree/Statements/SetVariable.hpp"

namespace sl
{
namespace ls
{

SetVariable::SetVariable(std::string filename, int line, const std::string& scope, const std::string& name, std::unique_ptr<const Expression> expression)
	:Statement(std::move(filename), line)
	,scope(scope)
	,name(name)
	,expression(std::move(expression))
{
}

void SetVariable::onExecute(Bindings& context) const
{
	context.setVar(scope, name, expression->evaluate(context));
}

void SetVariable::lint(LintBindings& context) const
{
	context.markLine(getLine());
	if (scope != "local")
	{
		context.checkVariable(scope, name);
	}
}

} // ls
} // sl
