#ifndef SL_LS_SETVARIABLE_HPP
#define SL_LS_SETVARIABLE_HPP

#include "Parsing/SyntaxTree/Statements/Statement.hpp"
#include "Parsing/SyntaxTree/Expressions/Expression.hpp"

namespace sl
{
namespace ls
{

class SetVariable : public Statement
{
public:
	SetVariable(std::string filename, int line, const std::string& scope, const std::string& name, std::unique_ptr<const Expression> expression);
	
	void onExecute(Bindings& context) const override;

	void lint(LintBindings& context) const override;

private:
	const std::string scope;
	const std::string name;
	const std::unique_ptr<const Expression> expression;
};

} // ls
} // sl

#endif // SL_LS_SETVARIABLE_HPP
