#ifndef SL_LS_STATEMENT_HPP
#define SL_LS_STATEMENT_HPP

#include "Parsing/Binding/Bindings.hpp"

#include <string>

namespace sl
{
namespace ls
{

class Statement : public SyntaxTreeNode
{
public:
	virtual ~Statement() = default;

	void execute(Bindings& context) const;

	int getLine() const;

protected:
	Statement(std::string filename, int line);
	
	virtual void onExecute(Bindings& context) const = 0;

private:
	int line;
};

} // ls
} // sl

#endif // SL_LS_STATEMENT_HPP
