#ifndef SL_LS_SWITCHCASE_HPP
#define SL_LS_SWITCHCASE_HPP

#include "Parsing/SyntaxTree/Statements/Statement.hpp"
#include "Parsing/SyntaxTree/Expressions/Expression.hpp"

namespace sl
{
namespace ls
{

class SwitchCase : public Statement
{
public:
	SwitchCase(std::string filename, int line, std::unique_ptr<const Expression> expression);

	void addCase(std::unique_ptr<const Expression> expression, std::unique_ptr<const Statement> body);

	/**
	 * @return true if properly set, false if a default statement already existed (likely an error)
	 */
	bool setDefault(std::unique_ptr<const Statement> body);

	void onExecute(Bindings& context) const override;

	void lint(LintBindings& context) const override;

private:
	const std::unique_ptr<const Expression> expression;
	std::vector<std::pair<std::unique_ptr<const Expression>, std::unique_ptr<const Statement>>> cases;
	std::unique_ptr<const Statement> defaultStatement;
};

} // ls
} // sl

#endif // SL_LS_SWITCHCASE_HPP
