#ifndef SL_LS_WHILELOOP_HPP
#define SL_LS_WHILELOOP_HPP

#include "Parsing/SyntaxTree/Statements/Statement.hpp"
#include "Parsing/SyntaxTree/Expressions/Expression.hpp"

namespace sl
{
namespace ls
{

class WhileLoop : public Statement
{
public:
	WhileLoop(std::string filename, int line, std::unique_ptr<const Expression> condition, std::unique_ptr<const Statement> body);

	void onExecute(Bindings& context) const override;

	void lint(LintBindings& context) const override;

private:
	std::unique_ptr<const Expression> condition;
	std::unique_ptr<const Statement> body;
};

} // ls
} // sl

#endif // SL_LS_WHILELOOP_HPP

