#ifndef SL_LS_SYNTAXTREENODE_HPP
#define SL_LS_SYNTAXTREENODE_HPP

#include <string>

#include "Parsing/Binding/LintBindings.hpp"

namespace sl
{
namespace ls
{

class SyntaxTreeNode
{
public:
	virtual ~SyntaxTreeNode() = default;

	const std::string& getUniqueId() const;

	const std::string& getFilename() const;

	virtual void lint(LintBindings& context) const = 0;

protected:
	SyntaxTreeNode(const std::string& filename, int uniqueId);

private:
	std::string uniqueId;
	std::string filename;
};

} // ls
} // sl

#endif // SL_LS_SYNTAXTREENODE_HPP