#ifndef SL_PF_HEURISTICS_HPP
#define SL_PF_HEURISTICS_HPP

#include "Pathfinding/NodeID.hpp"
#include "Pathfinding/PathfindingCommon.hpp"

namespace sl
{

namespace ai
{
class BehaviorContext;
} // ai

namespace pf
{

class ManhattanDistance
{
public:
	ManhattanDistance(const NodeID& target, float factor = 1.f);


	float operator()(const NodeID& node, ai::BehaviorContext*) const;

private:
	NodeID target;
	float factor;
};

} // pf
} // sl

#endif // SL_PF_HEURISTICS_HPP
