#include "Pathfinding/NodeID.hpp"

#include "Engine/Serialization/AutoDefineObjectSerialization.hpp"
#include "Engine/Scene.hpp"

namespace sl
{
namespace pf
{

NodeID::NodeID(Vector2i pos, Scene *scene)
	:NodeID(pos.x, pos.y, scene)
{
}

NodeID::NodeID(int x, int y, Scene *scene)
	:x(x)
	,y(y)
	,scene(scene)
{
}

Vector2f NodeID::scenePos() const
{
	return Vector2f(x * scene->getTileSize(), y * scene->getTileSize());
}

} // pf

DEF_SERIALIZE_OBJ_CTOR(pf::NodeID, &pf::NodeID::getX, &pf::NodeID::getY, &pf::NodeID::getScene)

} // sl