#include "Pathfinding/NodePredicates/Or.hpp"

namespace sl
{
namespace pf
{

Or::Or(std::initializer_list<NodePredicate> predicates)
	:predicates(std::move(predicates))
{
}

bool Or::operator()(const NodeID& node, ai::BehaviorContext *context) const
{
	for (const NodePredicate& pred : predicates)
	{
		if (pred(node, context))
		{
			return true;
		}
	}
	return false;
}


} // pf
} // sl