#ifndef SL_PF_PATHGRID_HPP
#define SL_PF_PATHGRID_HPP

#ifdef SL_DEBUG
	#include "Utility/Vector.hpp"
	#include <map>
	#include <set>
#endif // SL_DEBUG

namespace sl
{
namespace pf
{

class PathGrid
{
public:
	virtual ~PathGrid() {}


	virtual bool isSolid(int x, int y) const = 0;

	virtual bool canGoRight(int x, int y) const = 0;

	virtual bool canGoLeft(int x, int y) const = 0;

	virtual bool canGoUp(int x, int y) const = 0;

	virtual bool canGoDown(int x, int y) const = 0;

	virtual int getWidth() const = 0;

	virtual int getHeight() const = 0;

	virtual int getTileSize() const = 0;

	virtual void update(int64_t timestamp) {}
};

} // pf
} // sl

#endif // SL_PF_PATHGRID_HPP