#include "Pathfinding/PathManager.hpp"

#include "Utility/Assert.hpp"
#include "Pathfinding/NodePredicates/IsNode.hpp"

namespace sl
{
namespace pf
{

PathManager::~PathManager()
{
}

std::map<std::string, WeightFunc> defaultWeights;
std::shared_ptr<Path> PathManager::getPath(const PathSpec& spec, Priority priority)
{
	ERROR("please implement");
	return nullptr;
}

std::shared_ptr<Path> PathManager::getPath(NodeID from, NodeID to)
{
	if (defaultWeights.empty())
	{
		defaultWeights.insert(std::make_pair("Scene", noHeuristic));
	}
	return getPath(PathSpec{ from, IsNode(to), &defaultWeights, noHeuristic, nullptr }, Priority::Medium);
}

} // pf
} // sl
