#ifndef SL_PF_PATHFINDINGCOMMON_HPP
#define SL_PF_PATHFINDINGCOMMON_HPP

#include <functional>
#include <map>
#include <memory>
#include <string>

#include "Pathfinding/Node.hpp"
#include "Pathfinding/NodeID.hpp"
#include "Pathfinding/Path.hpp"
#include "Utility/Vector.hpp"

namespace sl
{

namespace ai
{
class BehaviorContext;
} // al

namespace pf
{

extern float uniformWeight(const NodeID&, ai::BehaviorContext*);

extern float noHeuristic(const NodeID& node, ai::BehaviorContext*);

typedef std::function<bool(const NodeID&, ai::BehaviorContext *context)> NodePredicate;

typedef std::function<float(const NodeID&, ai::BehaviorContext *context)> WeightFunc;

typedef std::map<std::string, WeightFunc> WeightMap;

typedef std::map<const NodeID, const NodeID> Portals;

} // pf
} // sl

#endif // SL_PF_PATHFINDINGCOMMON_HPP
