#ifndef SL_PF_REALTIMEPATHGRID_HPP
#define SL_PF_REALTIMEPATHGRID_HPP

#include <string>

#include "Pathfinding/PathGrid.hpp"

namespace sl
{
class Scene;
namespace pf
{

class RealTimePathGrid : public PathGrid
{
public:
	// @todo potentially allow for multiple types
	RealTimePathGrid(Scene& scene, const std::string& type);

	//---------------------  PathGrid  ---------------------
	bool isSolid(int x, int y) const override;

	bool canGoRight(int x, int y) const override;

	bool canGoLeft(int x, int y) const override;

	bool canGoUp(int x, int y) const override;

	bool canGoDown(int x, int y) const override;

	int getWidth() const override;

	int getHeight() const override;

	int getTileSize() const override;

private:
	Scene& scene;
	std::string type;
	const int tileSize;
};

} // pf
} // sl

#endif // SL_PF_REALTIMEPATHGRID_HPP
