#ifndef SL_PF_VERTEX_HPP
#define SL_PF_VERTEX_HPP

#include <SFML/Graphics.hpp>
#include <vector>
#include <utility>
#include "Engine/Graphics/RenderTarget.hpp"

namespace sl
{
namespace pf
{

class Vertex
{
public:
	Vertex(int x, int y);

	void addVertex(const Vertex *vertex, float weight = 1);

	void linkVertices(Vertex *vertex, float weight  = 1);

	void draw(RenderTarget& target) const;

	int heapIndex;
	std::size_t distIndex;

	int x, y;
	std::vector<std::pair<const Vertex*, int> > edges;

private:
	sf::CircleShape circle;
	std::vector<sf::VertexArray> lines;
};

} // pf
} // sl

#endif // SL_PF_VERTEX_HPP
