#ifndef SL_ACTIONCHOOSER_HPP
#define SL_ACTIONCHOOSER_HPP

#include "Engine/GUI/GUIWidget.hpp"
#include "Engine/Input/Controller.hpp"

namespace sl
{

class Player;

namespace gui
{

class ActionChooser : public GUIWidget
{
public:
	ActionChooser(Player& player, CustomAction& actionToPerform);

private:
	void onUpdate(int x, int y) override;

	void close();

	class Layer
	{
	public:
		Layer(GUIWidget& base, Layer *parent);

		Layer(GUIWidget& base, Layer *parent, std::unique_ptr<GUIWidget> w);

		~Layer();


		void setList(std::unique_ptr<GUIWidget> w);

		Layer *parent;
		std::unique_ptr<Layer> child;
	
	private:	
		GUIWidget& base;
		GUIWidget *list;
	};

	std::unique_ptr<Layer>& layer(int depth);

	Layer root;
	CustomAction actionToBind;
	CustomAction& actionToPerform;
	Player& player;
};

} // gui
} // sl

#endif // SL_ACTIONCHOOSER_HPP