#include "Player/Actions/PlayerConsumeItemAction.hpp"

#include "Items/Item.hpp"
#include "Items/ItemToDrawables.hpp"

namespace sl
{

PlayerConsumeItemAction::PlayerConsumeItemAction(int itemType)
	:itemType(itemType)
{
}

std::string PlayerConsumeItemAction::getName() const
{
	return "Consume " + Item(itemType).getName();
}

std::string PlayerConsumeItemAction::getShortName() const
{
	return "Consume";
}

std::unique_ptr<Drawable> PlayerConsumeItemAction::getIcon() const
{
	return itemToDrawable(itemType, false);
}

PlayerAction::Usability PlayerConsumeItemAction::canUse(Player& player, NPC *target) const
{
	return Usability::Useable;
}

float PlayerConsumeItemAction::use(Player& player, NPC *target)
{
	return SUCCESS;
}

} // sl