#ifndef SL_PLAYERPUNCHACTION_HPP
#define SL_PLAYERPUNCHACTION_HPP

#include "Player/Actions/PlayerAction.hpp"

namespace sl
{

class PlayerPunchAction : public PlayerAction
{
public:
	PlayerPunchAction();


	std::string getName() const override;

	std::unique_ptr<Drawable> getIcon() const override;

	Usability canUse(Player& player, NPC *target) const override;

	float use(Player& player, NPC *target) override;

	void abort() override;

	float usageRadius() const override
	{
		return 12.f;
	}

private:
	float progress;
	bool hit;
};

} // sl

#endif // SL_PLAYERPUNCHACTION_HPP