#ifndef SL_PLAYERSTALKITEMACTION_HPP
#define SL_PLAYERSTALKITEMACTION_HPP

#include "Items/Item.hpp"
#include "Player/Actions/PlayerAction.hpp"

namespace sl
{

class PlayerStalkItemAction : public PlayerAction
{
public:
	PlayerStalkItemAction(Item::Type itemType);

	std::string getName() const override;

	std::string getShortName() const override;

	std::unique_ptr<Drawable> getIcon() const override;

	Usability canUse(Player& player, NPC *target) const override;

	float use(Player& player, NPC *target) override;

	void abort() override;

	float usageRadius() const override;

private:
	Item item;
	float progress;
};

} // sl

#endif // SL_PLAYERSTALKITEMACTION_HPP