#include "Player/Actions/PlayerStripAction.hpp"

#include "Engine/Graphics/Sprite.hpp"
#include "NPC/Stats/Soul.hpp"
#include "NPC/NPC.hpp"
#include "Police/CrimeEntity.hpp"


namespace sl
{

static const ClothingType clothingTypesInOrderToStrip[] = {
	ClothingType::Accessory,
	ClothingType::Outfit,
	ClothingType::Panties,
	ClothingType::Bra,
	ClothingType::Socks
};

PlayerStripAction::PlayerStripAction()
	:progress(0.f)
{
}

std::string PlayerStripAction::getName() const
{
	return "Strip";
}

std::unique_ptr<Drawable> PlayerStripAction::getIcon() const
{
	return std::make_unique<Sprite>("actions/strip.png");
}

PlayerAction::Usability PlayerStripAction::canUse(Player& player, NPC *target) const
{
	if (target)
	{
		for (const ClothingType clothingType : clothingTypesInOrderToStrip)
		{
			if (target->getSoul()->appearance.clothingLayers.fromEnum(clothingType) && !target->getSoul()->appearance.getClothing(clothingType).empty())
			{
				return Usability::Useable;
			}
		}
	}
	return Usability::NoTarget;
}

float PlayerStripAction::use(Player& player, NPC *target)
{
	if (target)
	{
		for (const ClothingType clothingType : clothingTypesInOrderToStrip)
		{
			bool& wearing = target->getSoul()->appearance.clothingLayers.fromEnum(clothingType);
			if (wearing && !target->getSoul()->appearance.getClothing(clothingType).empty())
			{
				progress = std::clamp(progress + 0.1f, 0.f, 1.f);
				// TODO: non-linear progress, etc. maybe a way to hit a button to hit her?
				if (progress == SUCCESS)
				{
					wearing = false;
					target->refreshDrawables();
					switch (clothingType)
					{
					case ClothingType::Panties:
						target->makeTextBubble(Random::get().choose({ "N-No.. my panties...", "Don't hurt me..." }));
						break;
					case ClothingType::Accessory:
						target->makeTextBubble("Hey, what are you doing?");
						break;
					default:
						target->makeTextBubble(Random::get().choose({ "No! My clothes!", "Help!", "Don't take my clothes!", "You're ripping it!" }));
						break;
					}

					//CrimeEntity(target->getPos, 
					progress = 0.f;
					return SUCCESS;
				}
				return progress;
			}
		}
	}
	return FAILURE;
}

void PlayerStripAction::abort()
{
	progress = 0.f;
}

} // sl