#ifndef SL_PLAYERSUBDUEITEMACTION_HPP
#define SL_PLAYERSUBDUEITEMACTION_HPP

#include "Player/Actions/PlayerAction.hpp"

namespace sl
{

class PlayerSubdueItemAction : public PlayerAction
{
public:
	PlayerSubdueItemAction(int itemType);

	std::string getName() const override;

	std::string getShortName() const override;

	std::unique_ptr<Drawable> getIcon() const override;

	Usability canUse(Player& player, NPC *target) const override;

	float use(Player& player, NPC *target) override;

	void abort() override;

	bool hasCustomFinishStateChange() const override;

private:
	int itemType;
	float progress;
};

} // sl

#endif // SL_PLAYERSUBDUEITEMACTION_HPP