#ifndef SL_PLAYERTHROWITEMACTION_HPP
#define SL_PLAYERTHROWITEMACTION_HPP

#include "Items/Inventory.hpp"
#include "Player/Actions/PlayerAction.hpp"

namespace sl
{

class PlayerThrowItemAction : public PlayerAction
{
public:
	PlayerThrowItemAction(int itemType);

	std::string getName() const override;

	std::string getShortName() const override;

	std::unique_ptr<Drawable> getIcon() const override;

	Usability canUse(Player& player, NPC *target) const override;

	float use(Player& player, NPC *target) override;

private:
	std::vector<Inventory::ItemRef> query(Player& player) const;

	int itemType;
};

} // sl

#endif // SL_PLAYERTHROWITEMACTION_HPP