#include "Player/Fetishes.hpp"

#include "Utility/Assert.hpp"
#include "Utility/JsonUtil.hpp"

namespace sl
{

static const char *fetishesFile = "data/fetishes.json";

Fetishes::Fetishes()
{
	auto file = tryReadJsonFile(fetishesFile);
	for (const std::pair<std::string, json11::Json>& fetish : file.object_items())
	{
		ASSERT(fetish.second.is_bool());
		enabled.insert(std::make_pair(fetish.first, fetish.second.bool_value()));
	}
}

bool Fetishes::isEnabled(const std::string& id) const
{
	return enabled.at(id);
}

void Fetishes::set(const std::string& id, bool value)
{
	enabled[id] = value;

	json11::Json::object out;
	for (const std::pair<std::string, bool>& fetish : enabled)
	{
		out[fetish.first] = fetish.second;
	}
	saveJsonFile(fetishesFile, json11::Json(std::move(out)));
}

const std::map<std::string, bool>& Fetishes::list() const
{
	return enabled;
}

/*static*/ Fetishes& Fetishes::get()
{
	static Fetishes instance;
	return instance;
}

} // sl
