#include "Player/PlayerStats.hpp"

#include "Engine/Serialization/Serialization.hpp"
#include "Engine/Serialization/Impl/SerializeSoul.hpp"
#include "Town/World.hpp"

namespace sl
{

PlayerStats::PlayerStats(std::shared_ptr<Soul> soul)
	:soul(std::move(soul))
	,money(1)
	,girth(11.5f) // average girth is 11.5cm around
	//,hotbar(this->soul->items)
	,currentActionId(NO_CUSTOM_ACTION)
{
}

void PlayerStats::serialize(Serialize& out) const
{
	AutoSerialize::serialize(out, soul);
	SAVEVAR(i, money);
	SAVEVAR(f, girth);
	permFlags.serialize(out);
	out.i("currentActionId", static_cast<int>(currentActionId));
	stalkingData.serialize(out);
}

void PlayerStats::deserialize(Deserialize& in)
{
	AutoDeserialize::deserialize(in, soul);
	LOADVAR(i, money);
	LOADVAR(f, girth);
	permFlags.deserialize(in);
	currentActionId = static_cast<CustomAction>(in.i("currentActionId"));
	stalkingData.deserialize(in);
}

} // sl