#ifndef SL_STALKINGDATA_HPP
#define SL_STALKINGDATA_HPP

#include "NPC/Stats/Soul.hpp"
#include "NPC/NPCPhoto.hpp"
#include "Utility/Time/GameDate.hpp"

#include <map>

namespace sl
{

class Deserialize;
class Serialize;
	
class StalkingData
{
public:

	float getFamiliarity(Soul::ID id, const GameDate& today) const;

	std::vector<Soul::ID> topStalked(int n) const;

	struct Info
	{
		float familiarity;
	};
	Info getInfo(Soul::ID id) const;


	void stalk(Soul::ID id, const GameDate& date);

	void stalk(Soul::ID id, const GameTime& date, NPCPhoto photo);

	// TODO: decide whether we should store photos here or somewhere else
	// maybe they should be stored in one common area, but referenced here?
	struct PhotoInfo
	{
		GameTime time;
		NPCPhoto photo;
		Soul::ID id;
	};
	const std::vector<PhotoInfo> getPhotos() const { return photos; }


	void serialize(Serialize& out) const;

	void deserialize(Deserialize& in);

	// struct def is not public so we can serialize it using AutoSerialize
	struct Data
	{
		float computeFamiliarity(const GameDate& today) const;

		const GameDate& lastStalked() const;

		std::map<GameDate, float> stalkedByDay;
	};

private:
	std::map<Soul::ID, Data> data;
	std::vector<PhotoInfo> photos;
};

} // sl

#endif // SL_STALKINGDATA_HPP