#ifndef SL_PLAYERPERFORMINGACTIONSTATE_HPP
#define SL_PLAYERPERFORMINGACTIONSTATE_HPP

#include "Player/Actions/PlayerAction.hpp"
#include "Player/PlayerState.hpp"

namespace sl
{

class Animation;
class NPC;

class PlayerPerformingActionState : public PlayerState
{
public:
	PlayerPerformingActionState(Player& player, NPC *target, std::unique_ptr<PlayerAction> action);

	void update() override;

private:

	void onEnter() override;

	void onExit() override;

	NPC *target;
	std::unique_ptr<PlayerAction> action;
	Animation *progressDial;
};

} // namespace sl

#endif // SL_PLAYERPERFORMINGACTIONSTATE_HPP