#ifndef SL_PLAYERSHOPPINGSTATE_HPP
#define SL_PLAYERSHOPPINGSTATE_HPP

#include <map>
#include <string>

#include "Engine/GUI/WidgetHandle.hpp"
#include "Player/PlayerState.hpp"

namespace sl
{

class NPC;
class Item;

namespace gui
{
class TextLabel;
template <typename T>
class WidgetList;
} // gui

class PlayerShoppingState : public PlayerState
{
public:
	PlayerShoppingState(Player& player, NPC& npc);

	void update() override;

	void onSceneEnter() override;

	void onSceneExit() override;

	void handleEvent(const Event& event) override;

private:

	void updateItemList();


	//!NPC the player is talking to
	NPC& npc;
	//!Dialogue box GUI to display
	gui::WidgetHandle<> widget;
	std::unique_ptr<Inventory::ItemRef> selectedItem;
	typedef std::map<Inventory::ItemRef, int, Inventory::ItemComp> ItemListContainer;
	gui::WidgetList<ItemListContainer::value_type> *itemList;
	gui::TextLabel *buyButton;
};

} // namespace sl

#endif // SL_PLAYERSHOPPINGSTATE_HPP