#ifndef SL_PLAYERTALKSTATE_HPP
#define SL_PLAYERTALKSTATE_HPP

#include <map>
#include <string>

#include "Engine/GUI/WidgetHandle.hpp"
#include "NPC/Dialogue/DialogueGUI.hpp"
#include "Player/PlayerState.hpp"
#include "Utility/Sequencer/Sequencer.hpp"

namespace sl
{

class NPC;

class PlayerTalkState : public PlayerState
{
public:
	PlayerTalkState(Player& player, NPC& npc, const std::string& startingSituation);

	void update() override;

	void onSceneEnter() override;

	void onSceneExit() override;

	void handleEvent(const Event& event) override;

private:


	//!NPC the player is talking to
	NPC& npc;
	//!Dialogue box GUI to display
	gui::WidgetHandle<DialogueGUI> dialogue;
	//!Sequences available
	std::map<std::string, Sequencer> sequences;
	//!The current sequence to process. Gets set back to null when the current one finishes
	Sequencer *currentSequence;
};

} // namespace sl

#endif // SL_PLAYERTALKSTATE_HPP