#ifndef SL_PLAYERWALKSTATE_HPP
#define SL_PLAYERWALKSTATE_HPP

#include "Player/Actions/PlayerAction.hpp"
#include "Player/PlayerState.hpp"

namespace sl
{

class PlayerWalkState : public PlayerState
{
public:
	PlayerWalkState(Player& player);

	PlayerWalkState(Player& player, std::unique_ptr<PlayerAction> action);

	void update() override;

private:
	void switchCurrentAction(CustomAction id);

	void performAction(NPC *target);

	/**
	 * @param valid [output] All valid targets. This is added to, not cleared.
	 * @return failReason The 1st failure reason if no targets were added to NPC
	 */
	PlayerAction::Usability getActionTargets(std::vector<NPC*>& valid) const;


	CustomAction actionChooserResult;
	std::unique_ptr<PlayerAction> currentAction;
};

} // namespace sl

#endif // SL_PLAYERWALKSTATE_HPP
