#ifndef SL_CRIME_HPP
#define SL_CRIME_HPP

#include <cstdint>

namespace sl
{

class Crime
{
public:
	enum class Type
	{
		SexualAssault = 0,
		Murder,
		Kidnapping,
		Rape,
		StatRape,
		AttemptedRape,
		AttemptedKidnapping,
		Assault
	};
	Crime(); // for serialization
	Crime(Type type, uint64_t victimID, bool consensual);

	Type type;
	uint64_t victim;
	int id;
	//! This is to mark whether someone will report the crime against themselves.
	bool consensual;

//private:
	static int currentID;
};

} // sl

#endif // SL_CRIME_HPP