#include "Police/CrimeDatabase.hpp"

#include "Utility/Assert.hpp"

namespace sl
{

CrimeDatabase CrimeDatabase::instance;

CrimeDatabase::CrimeDatabase()
{
	init();
}



void CrimeDatabase::define(Crime::Type, const Entry& entry)
{
	ERROR("don't use this?");
}

const CrimeDatabase::Entry& CrimeDatabase::getEntry(Crime::Type type) const
{
	return entries.at(type);
}

/*static*/ CrimeDatabase& CrimeDatabase::get()
{
	return instance;
}

void CrimeDatabase::init()
{
	entries.insert(std::make_pair(Crime::Type::SexualAssault, Entry(
		"Sexual Assault",
		"...",
		3 * 12
	)));
	entries.insert(std::make_pair(Crime::Type::Murder, Entry(
		"Murder",
		"...",
		25 * 12
	)));
	entries.insert(std::make_pair(Crime::Type::Kidnapping, Entry(
		"Kidnapping",
		"...",
		7 * 12
	)));entries.insert(std::make_pair(Crime::Type::Rape, Entry(
		"Rape",
		"...",
		8 * 12
	)));
	entries.insert(std::make_pair(Crime::Type::StatRape, Entry(
		"Statutory Rape",
		"...",
		4 * 12
	)));
	entries.insert(std::make_pair(Crime::Type::AttemptedRape, Entry(
		"Attempted Rape",
		"...",
		3 * 12
	)));
	entries.insert(std::make_pair(Crime::Type::AttemptedKidnapping, Entry(
		"Attempted Kidnapping",
		"...",
		4 * 12
	)));
	entries.insert(std::make_pair(Crime::Type::Assault, Entry(
		"Assault",
		"...",
		2 * 12
	)));
}

} // sl