#ifndef SL_CRIMEDATABASE_HPP
#define SL_CRIMEDATABASE_HPP

#include <map>
#include <string>

#include "Police/Crime.hpp"

namespace sl
{

class CrimeDatabase
{
public:
	class Entry
	{
	public:
		Entry(const std::string& name, const std::string& desc, int sentenceLengthInMonths)
			:name(name)
			,desc(desc)
			,sentenceLengthInMonths(sentenceLengthInMonths)
		{
		}

		std::string name;
		std::string desc;
		int sentenceLengthInMonths;
	};

	CrimeDatabase();



	void define(Crime::Type, const Entry& entry);

	const Entry& getEntry(Crime::Type type) const;

	static CrimeDatabase& get();

private:
	void init();


	std::map<Crime::Type, Entry> entries;

	static CrimeDatabase instance;
};

} // sl

#endif // SL_CRIMEDATABASE_HPP