#ifndef SL_CRIMEENTITY_HPP
#define SL_CRIMEENTITY_HPP

#include "Engine/Entity.hpp"
namespace sl
{

class CrimeEntity : public Entity
{
public:
	static constexpr int INDEFINITE = -1;
	CrimeEntity(const Vector2f& pos, int crimeId, bool constantNoise, int lifetime);

	const Types::Type getType() const override;

	void noiseImpulse();

	void report();

	int getCrimeId() const;

private:
	void onUpdate() override;

	int crimeId;
	bool constantNoise;
	int lifetime;
};

} // sl

#endif // SL_CRIMEENTITY_HPP