#include "Police/CrimeUtil.hpp"

#include "Engine/Events/Event.hpp"
#include "Town/World.hpp"
#include "NPC/NPC.hpp"
#include "NPC/Stats/Soul.hpp"
#include "Police/CrimeDatabase.hpp"
#include "Police/CrimeEntity.hpp"
#include "Police/CriminalRecords.hpp"
#include "Player/Player.hpp"
#include "Player/PlayerStats.hpp"
#include "Utility/Memory.hpp"

namespace sl
{

int commitCrime(NPC& npc, Crime::Type type, bool consensual)
{
	const CrimeDatabase& crimeDB = CrimeDatabase::get();
	Scene *scene = npc.getScene();
	ASSERT(scene != nullptr);
	World *world = scene->getWorld();
	ASSERT(world != nullptr);

	// @todo make it search the world instead maybe
	const Crime crime(type, npc.getSoul()->getID(), consensual);
	world->getPolice().recordCrime(crime);
	const int crimeId = crime.id;

	// What if it's in her sleep? Should she still know? I guess in that case, don't use this helper util...
	npc.getSoul()->setCrimeReported(crimeId, false);

	scene->addEntityToList(new CrimeEntity(npc.getPos(), crimeId, false, 10));

	return crimeId;
}

} // sl
