#ifndef SL_TEST_TEST_HPP
#define SL_TEST_TEST_HPP

#include <iostream>
#include <numeric>

#define CHECK(cond) do { \
	if (!(cond)) { \
		err << "check [" << (#cond) << "] failed." <<std::endl; \
		return false; \
	} } while (false)

#define CHECK_EQ(x, y) do { \
	auto xv = (x); \
	auto yv = (y); \
	if (!(xv == yv)) { \
		err << "check " << (#x) << " (" << xv << ") == " << (#y) << " (" << yv << ") failed." <<std::endl; \
		return false; \
	} } while (false)

#define CHECK_NEQ(x, y) do { \
	auto xv = (x); \
	auto yv = (y); \
	if (!(xv != yv)) { \
		err << "check " << (#x) << " (" << xv << ") != " << (#y) << " (" << yv << ") failed." <<std::endl; \
		return false; \
	} } while (false)

#define CHECK_LEQ(x, y) do { \
	auto xv = (x); \
	auto yv = (y); \
	if (!(xv <= yv)) { \
		err << "check " << (#x) << " (" << xv << ") <= " << (#y) << " (" << yv << ") failed." <<std::endl; \
		return false; \
	} } while (false)

#define CHECK_GEQ(x, y) do { \
	auto xv = (x); \
	auto yv = (y); \
	if (!(xv >= yv)) { \
		err << "check " << (#x) << " (" << xv << ") >= " << (#y) << " (" << yv << ") failed." <<std::endl; \
		return false; \
	} } while (false)

#define CHECK_L(x, y) do { \
	auto xv = (x); \
	auto yv = (y); \
	if (!(xv < yv)) { \
		err << "check " << (#x) << " (" << xv << ") < " << (#y) << " (" << yv << ") failed." <<std::endl; \
		return false; \
	} } while (false)

#define CHECK_G(x, y) do { \
	auto xv = (x); \
	auto yv = (y); \
	if (!(xv > yv)) { \
		err << "check " << (#x) << " (" << xv << ") > " << (#y) << " (" << yv << ") failed." <<std::endl; \
		return false; \
	} } while (false)

#define CHECK_EQ_FLOAT_EPS(x, y, eps) do { \
	auto xv = (x); \
	auto yv = (y); \
	if (xv < yv - eps || xv > yv + eps) { \
		err << "check " << (#x) << " (" << xv << ") == " << (#y) << " (" << yv << ") failed." <<std::endl; \
		return false; \
	} } while (false)
#define CHECK_EQ_FLOAT(x, y) do { \
	auto xv = (x); \
	CHECK_EQ_FLOAT_EPS(x, y, std::numeric_limits<decltype(xv)>::epsilon()); \
	} while (false)

namespace sl
{
namespace test
{

class Test
{
public:
	virtual ~Test() {}

	virtual bool run(std::ostream& err) = 0;
};

} // test
} // sl

#endif // SL_TEST_TEST_HPP