#ifndef SL_CARCONTROLS_HPP
#define SL_CARCONTROLS_HPP

namespace sl
{

class CarControls
{
public:
	CarControls();

	
	void turnLeft();
	
	void turnRight();
	
	void accelerate();
	
	void brake();
	
	void reverse();
	
	void toggleCruiseSpeed();

	void reset();

	/**
	 * Finds the rotation of the wheel
	 * @return Wheel rotation (1.f = fully left, -1.f = fully right, 0.f = middle)
	 */
	float getWheelRotation() const;

	float getPedalPosition() const;

	bool isReverse() const;

	bool isBraking() const;

	bool isSpeedLimited() const;

	

private:

	bool isTurningRight;
	bool isTurningLeft;
	bool isPedalDown;
	bool isBackPedalDown;
	bool isBrakeDown;
	bool cruiseSpeed;
};

} // sl

#endif // SL_CARCONTROLS_HPP
