#ifndef SL_CARSPECS_HPP
#define SL_CARSPECS_HPP

#include <string>

namespace sl
{

class CarSpecs
{
public:
	enum Model
	{
		Van = 0,
		IceCreamTruck,
		CopCar,
		SportsCar,
		Sedan,
		LuxerySedan,
		Schoolbus,
		Supercar,

		NumOfModels //  Keep this as the last one, and don't use it as an actual Model
	};

	static const CarSpecs& getSpecs(Model model);


	std::string modelName;
	float turnSpeed;
	float turnMax;
	float acceleration;
	float accelerationReverse;
	float brakes;
	float topSpeed;
	float topSpeedReverse;
	float grip;
	std::string filename;
	int trunkCapacity;
	int passangerCapacity;

private:
	CarSpecs();

	static void init();

	static int initialized;
	static CarSpecs specs[NumOfModels];
};

}

#endif
