#ifndef SL_CONTAINER_HPP
#define SL_CONTAINER_HPP

#include <memory>
#include <vector>

#include "Engine/Entity.hpp"
#include "NPC/Stats/Soul.hpp"

namespace sl
{

class Container : public Entity
{
public:
	DECLARE_SERIALIZABLE_METHODS(Container)

	Container(const Vector2f& pos);


	const Types::Type getType() const override;

	bool isStatic() const override;


	void setClosed(bool closed);

	bool isClosed() const { return closed; }

	bool hasNPCs() const;

	std::shared_ptr<Soul> takeNPC();

	void addNPC(std::shared_ptr<Soul> npc);

private:

	void onUpdate() override;

	bool closed;
	std::vector<std::shared_ptr<Soul>> NPCs;
};

} // sl

#endif // SL_CONTAINER_HPP
