#include "Town/Generation/ConditionalPrototype.hpp"

#include "Town/Generation/ConditionalPrototypeLimit.hpp"
#include "Utility/Random.hpp"

namespace sl
{
namespace towngen
{

ConditionalPrototype::ConditionalPrototype(const StaticEntityPrototype& prototype, ConditionalPrototypeLimit *limit, float probability)
	:prototype(prototype)
	,limit(limit)
	,probability(probability)
{
}

void ConditionalPrototype::generate(Random& rng, Scene& scene, int tileSize, map::MapStaticEntityData& minimapStaticEntityData, const Vector2i& offset)
{
	if (rng.chance(probability))
	{
		//	make sure we haven't hit the limit
		if (limit == nullptr || limit->use())
		{
			prototype.generate(rng, scene, tileSize, minimapStaticEntityData, offset);
		}
	}
}

}	//	end of towngen namespace
}	//	end of sl namespace
