#include "Town/Generation/ConditionalPrototypeLimit.hpp"

namespace sl
{

namespace towngen
{

ConditionalPrototypeLimit::ConditionalPrototypeLimit(int limit)
	:limit(limit)
	,uses(0)
{
}

void ConditionalPrototypeLimit::reset()
{
	uses = 0;
}

bool ConditionalPrototypeLimit::use()
{
	if (uses < limit)
	{
		++uses;
		return true;
	}
	return false;
}

int ConditionalPrototypeLimit::usesLeft() const
{
	return limit - uses;
}

}	//	end of towngen namespace

}	//	end of sl namespace