#ifndef SL_TOWNGEN_CONDITIONALPROTOTYPELIMIT_HPP
#define SL_TOWNGEN_CONDITIONALPROTOTYPELIMIT_HPP

namespace sl
{

namespace towngen
{

class ConditionalPrototypeLimit
{
public:
	ConditionalPrototypeLimit(int limit);

	/**
	 * Resets the uses to 0
	 */
	void reset();
	/**
	 * Attempts to use up one of the available uses of this limit
	 * @return True if it reduced the limit, False if limit was already hit
	 */
	bool use();

	/**
	 * How many uses there are left under this limit
	 * @return Number of uses left
	 */
	int usesLeft() const;

private:

	int limit;

	int uses;
};

}	//	end of towngen namespace

}	//	end of sl namespace

#endif // SL_TOWNGEN_CONDITIONALPROTOTYPELIMIT_HPP