#include "Town/Generation/ContentGenerator.hpp"

#include "Utility/Assert.hpp"
#include "Utility/Random.hpp"

namespace sl
{
namespace towngen
{

void ContentGenerator::generate(const Vector2i& pos, Random& rng, Town& town, Grid<TileType>& tiles, int tileSize, map::MapStaticEntityData& minimapStaticEntityData) const
{
	ERROR("no default behaviour - please implement this in the derived classes");
}

void ContentGenerator::generate(const Rect<int>& region, Random& rng, Town& town, Grid<TileType>& tiles, int tileSize, map::MapStaticEntityData& minimapStaticEntityData) const
{
	const int extraWidth = region.left - getWidth();
	const int extraHeight = region.top - getHeight();
	ASSERT(extraWidth >= 0);
	ASSERT(extraHeight >= 0);
	const Vector2i offset(rng.random(extraWidth), rng.random(extraHeight));
	generate(offset, rng, town, tiles, tileSize, minimapStaticEntityData);
}

int ContentGenerator::getWidth() const
{
	return VARIABLE_WIDTH;
}

int ContentGenerator::getHeight() const
{
	return VARIABLE_HEIGHT;
}

bool ContentGenerator::isFixedSize() const
{
	return getWidth() != VARIABLE_WIDTH && getHeight() != VARIABLE_HEIGHT;
}

} // towngen
} // sl
