#include "Town/Generation/GenerationTimer.hpp"

#include "Utility/Logger.hpp"

namespace sl
{
namespace towngen
{

GenerationTimer::GenerationTimer()
	:time(std::chrono::steady_clock::now())
{
}


void GenerationTimer::operator()(const char *message)
{
	const auto now = std::chrono::steady_clock::now();
	const auto timedif = now - time;
	time = now;
	const int timeInMs = 1000 * std::chrono::duration_cast<std::chrono::duration<double>>(timedif).count();
	Logger::log(Logger::TownGen, Logger::Debug) << "[" << timeInMs << "]  -  " << message << std::endl;
}

} // towngen
} // sl