#ifndef SL_TOWNGEN_EDITINGUNDO_HPP
#define SL_TOWNGEN_EDITINGUNDO_HPP

#include <functional>
#include <vector>

#include "Engine/Entity.hpp"
#include "Town/Generation/Interiors/HomeObjectPrototype.hpp"
#include "Town/Generation/Interiors/HomeObjectPrototypeInstance.hpp"

namespace sl
{
namespace towngen
{

class EditingUndo : public Entity
{
public:
	EditingUndo(const HomeObjectPrototypeInstance& instance, const Rect<int>& bounds);


	void addEntityToUndo(Entity *entity);

	void addHeightMapToUndo(HeightMap *map);

	void addUndoFunc(const std::function<void()>& func);

	void undo();


	const HomeObjectPrototypeInstance& getInstance() const;

private:
	void onUpdate() override;

	const Entity::Type getType() const override;


	HomeObjectPrototypeInstance instance;
	std::vector<Entity*> entitiesToDelete;
	std::vector<HeightMap*> heightMapsToDelete;
	std::vector<std::function<void()>> toExecute;
};

} // towngen
} // sl

#endif // SL_TOWNGEN_EDITINGUNDO_HPP
