#ifndef SL_TOWNGEN_HOMECONFIG_HPP
#define SL_TOWNGEN_HOMECONFIG_HPP

#include <string>
#include <vector>

#include "NPC/Stats/SoulGenerationSettings.hpp"
#include "Utility/Rect.hpp"

namespace sl
{

class Random;
class Town;

namespace towngen
{

class HomeConfig
{
public:
	//! A constant to set width and/or height in worldBounds to if you want it to be automatically determined
	static const int AUTOMATIC;
	/**
	 * worldBounds The area in worldspace (tiles) that the building takes up in the overworld
	 * 
	 */
	HomeConfig(const Rect<int>& worldBounds, const SoulGenerationSettings& familysettings);


	class LevelConfig
	{
	public:
		LevelConfig(std::string name, const Vector2i& tileOffset);

		bool operator<(const LevelConfig& rhs) const;

		std::string name;
		Vector2i tileOffset;
	};

	void addAboveLevel(LevelConfig&& config);

	void addBelowLevel(LevelConfig&& config);

	void generate(Town& town, Random& rng) const;

private:


	Rect<int> worldBounds;
	std::vector<LevelConfig> above;
	std::vector<LevelConfig> below;
	SoulGenerationSettings familySettings;
};

} // towngen
} // sl

#endif // SL_TOWNGEN_HOMECONFIG_HPP
