#ifndef SL_HOMEDATABASE_HPP
#define SL_HOMEDATABASE_HPP

#include "Town/Generation/Interiors/HomeObjectPrototype.hpp"

#include <map>
#include <string>

namespace sl
{
namespace towngen
{

class HomeObjectDatabase
{
public:
	typedef std::map<std::string, HomeObjectPrototype> Data;

	 void reload();

	 const HomeObjectPrototype* getPrototype(const std::string& id) const;

	 Data::const_iterator begin() const;

	 Data::const_iterator end() const;

	 int size() const;



	static HomeObjectDatabase& get();

private:
	HomeObjectDatabase();

	Data prototypes;
};

} // towngen
} // sl

#endif // SL_HOMEDATABASE_HPP