#ifndef SL_HOMETILEDATABASE_HPP
#define SL_HOMETILEDATABASE_HPP

#include "Town/Generation/Interiors/HomeObjectPrototype.hpp"

#include <SFML/Graphics/Rect.hpp>

#include <map>
#include <string>

namespace sl
{
namespace towngen
{

class HomeTileDatabase
{
public:
	class Prototype
	{
	public:
		Prototype(const std::string& fname, const Vector2i& offset, int tileSize);

		const std::string& getFilename() const;

		sf::IntRect getTextureRect() const;


	private:
		std::string fname;
		Vector2i offset;
		int tileSize;
	};
	typedef std::map<std::string, Prototype> Data;

	 void reload();

	 const Prototype* getPrototype(const std::string& id) const;

	 Data::const_iterator begin() const;

	 Data::const_iterator end() const;

	 int size() const;



	static HomeTileDatabase& get();

private:
	HomeTileDatabase();

	Data prototypes;
};

} // towngen
} // sl

#endif // SL_HOMETILEDATABASE_HPP