/**
 * @section DESCRIPTION
 * A blueprint for placing a parking lot inside of a yard
 */
#ifndef SL_TOWNGEN_PARKINGLOTGENERATOR_HPP
#define SL_TOWNGEN_PARKINGLOTGENERATOR_HPP

#include "Town/Generation/ContentGenerator.hpp"

namespace sl
{
namespace towngen
{

class ParkingLotGenerator : public ContentGenerator
{
public:
	ParkingLotGenerator(int layers, bool isAbove);

	void generate(const Rect<int>& area, Random& rng, Town& town, Grid<TileType>& tiles, int tileSize, map::MapStaticEntityData& minimapStaticEntityData) const override;

	int getHeight() const override;

	/**
	 * Computes the height in tiles that a parking lot would take
	 * @param layerCount the number of layers for the lot
	 * @return The tiles high the lot needs to be
	 */
	static int getHeight(int layerCount);


private:

	int layers;
	bool isAbove;
};

} // towngen
} // sl

#endif // SL_TOWNGEN_PARKINGLOTGENERATOR_HPP