#ifndef SL_TOWNGEN_STATICENTITYPROTOTYPE_HPP
#define SL_TOWNGEN_STATICENTITYPROTOTYPE_HPP

#include "Town/Generation/EntityPrototype.hpp"
#include "Engine/Entity.hpp"

namespace sl
{
namespace towngen
{

class StaticEntityPrototype : public EntityPrototype
{
public:
	enum Type
	{
		Tree,
		FenceH,
		FenceV,
		ChainLinkFenceH,
		ChainLinkFenceV,
		Dumpster
	};

	StaticEntityPrototype(int x, int y, Type type);


	void generate(Random& rng, Scene& scene, int tileSize, map::MapStaticEntityData& minimapStaticEntityData, const Vector2i& offset = Vector2i(0, 0)) const override;

	Type getType() const;

	int getX() const;

	int getY() const;

	/**
	 * Region occupied (in tiles)
	 */
	Rect<int> box() const;

	static const Vector2i& size(Type tyoe);

private:
	int x;
	int y;
	Type type;
};

} // towngen
} // sl

#endif // SL_TOWNGEN_STATICENTITYPROTOTYPE_HPP