#ifndef SL_TOWNGEN_YARDOBJECTPROTOTYPE_HPP
#define SL_TOWNGEN_YARDOBJECTPROTOTYPE_HPP

#include <memory>
#include <string>

#include "Town/Generation/BuildingAttachment.hpp"
#include "Utility/Rect.hpp"
#include "Utility/Vector.hpp"

namespace sl
{
namespace towngen
{

class YardObjectPrototype : public BuildingAttachment
{
public:
	YardObjectPrototype(const Rect<int> bounds, const std::string& fname, const Vector2i& imageOrigin = Vector2i()); 


	void generate(const Vector2i& pos, Random& rng, Town& town, map::MapStaticEntityData& minimapStaticEntityData, bool& isPlayerGenerated, const SoulGenerationSettings& npcSettings, const ColorSwapID *forceSwap = nullptr) const override;

	int getWidth() const override;

	int getHeight() const override;

	enum class Premade
	{
		Trashcan,
		Trashbin,
	};
	static std::unique_ptr<YardObjectPrototype> create(Premade config);

private:

	Rect<int> bounds;
	std::string fname;
	Vector2i imageOrigin;
};

} // towngen
} // sl

#endif // SL_TOWNGEN_YARDOBJECTPROTOTYPE_HPP