#ifndef SL_LOADBASEDFOURWAYTRAFFICCONTROLLER_HPP
#define SL_LOADBASEDFOURWAYTRAFFICCONTROLLER_HPP

#include "Engine/Entity.hpp"

namespace sl
{

class TrafficLight;

class LoadBasedFourWayTrafficController : public Entity
{
public:
	LoadBasedFourWayTrafficController(TrafficLight *north, TrafficLight *east, TrafficLight *west, TrafficLight *south);


	const Types::Type getType() const override;

private:
	void onUpdate() override;
	
	void computeBestFlag();

	
	
	TrafficLight *lights[4];

	const int greenTime;
	const int yellowTime;
	int state;
	int alarm;
	
	
	unsigned char bestFlag;
	static const int conflicts[8][4];
};

} // sl

#endif // SL_LOADBASEDFOURWAYTRAFFICCONTROLLER_HPP