#ifndef SL_LOCATIONMARKER_HPP
#define SL_LOCATIONMARKER_HPP

#include "Engine/Entity.hpp"
#include "Town/Map/Icon.hpp"

namespace sl
{

class LocationMarker : public Entity
{
public:
	DECLARE_SERIALIZABLE_METHODS(LocationMarker)

	LocationMarker(int x, int y, const Entity::Type& markerName);

	LocationMarker(int x, int y, const Entity::Type& markerName, const std::string& fname);


	const Type getType() const override;

	map::Icon& editIcon();


private:
	void initIcon();

	void onUpdate() override;

	void onEnter() override;


	Entity::Type markerName;
	//! Only for serialization
	std::string fname;
	map::Icon icon;
};

} // sl

#endif // SL_LOCATIONMARKER_HPP