#ifndef SL_MAP_MAPDATA_HPP
#define SL_MAP_MAPDATA_HPP

#include <vector>

#include "Town/TownTiles.hpp"
#include "Town/Generation/StaticEntityPrototype.hpp"

namespace sl
{

template <typename T>
class Grid;


namespace map
{

class MapStaticEntityData;

class MapData
{
public:
	MapData(int tilesWide, int tilesHigh, const Grid<TileType> *tiles, const std::vector<towngen::StaticEntityPrototype> *prototypes, const MapStaticEntityData *entities)
		:tilesWide(tilesWide)
		,tilesHigh(tilesHigh)
		,tiles(tiles)
		,prototypes(prototypes)
		,entities(entities)
	{
	}

	int getWidth() const
	{
		return tilesWide;
	}

	int getHeight() const
	{
		return tilesHigh;
	}

	const Grid<TileType>* getTiles() const
	{
		return tiles;
	}

	const std::vector<towngen::StaticEntityPrototype>* getPrototypes() const
	{
		return prototypes;
	}

	const MapStaticEntityData* getEntities() const
	{
		return entities;
	}


private:

	const int tilesWide;
	const int tilesHigh;
	const Grid<TileType> *tiles;
	const std::vector<towngen::StaticEntityPrototype> *prototypes;
	const MapStaticEntityData *entities;
};

} // map
} // sl

#endif // SL_MAP_MAPDATA_HPP
