#ifndef SL_MAP_MAPGUI_HPP
#define SL_MAP_MAPGUI_HPP

#include <set>

#include "Engine/GUI/GUIWidget.hpp"

namespace sl
{

class Town;
class LocationMarker;

namespace gui
{
class TextLabel;
}

namespace map
{

class Map;

class MapGUI : public gui::GUIWidget
{
public:
	MapGUI(Map& map, Town& town, const Rect<int>& box);

private:
	enum class State
	{
		Default,
		AddMarker,
	};
	void onLeftClick(int x, int y);
	
	void onMouseHover(int x, int y) override;
	
	void changeState(State newState);

	//Vector2f guiToMapSpace(int x, int y) const;

	
	State state;
	Map& map;
	Town& town;
	std::set<LocationMarker*> icons;
	gui::TextLabel *hoverText;
};

} // map
} // sl

#endif // SL_MAP_MAPGUI_HPP