#ifndef SL_MAP_MAPSTATICENTITYDATA_HPP
#define SL_MAP_MAPSTATICENTITYDATA_HPP

#include "Utility/Grid.hpp"

namespace sl
{

class Entity;

template <typename T>
struct Rect;

namespace map
{

class MapStaticEntityData
{
public:
	enum class StaticEntity
	{
		None,
		Tree,
		Fence,
		Building
	};

	MapStaticEntityData(int width, int height, int tileSize);


	void set(const Entity& entity, StaticEntity type);

	void set(const Rect<int>& boundsInTiles, StaticEntity type);

	void set(int x, int y, StaticEntity type);

	StaticEntity get(int x, int y) const;

	int getWidth() const;

	int getHeight() const;

private:
	
	const int tileSize;
	Grid<StaticEntity> data;
};

} // map
} // sl

#endif // SL_MAP_MINIMAPSTATICENTITYDATA_HPP