#ifndef SL_THREEWAYTRAFFICCONTROLLER_HPP
#define SL_THREEWAYTRAFFICCONTROLLER_HPP

#include "Engine/Entity.hpp"

namespace sl
{

class TrafficLight;

class ThreeWayTrafficController : public Entity
{
public:
	// Makes an assumption that North = the other street
	ThreeWayTrafficController(TrafficLight& north, TrafficLight& east, TrafficLight& west);


	const Types::Type getType() const override;

private:
	void onUpdate() override;

	class State
	{
	public:
		State(bool northLeft, bool eastStraight, bool eastLeft, bool westLeft)
			:northLeft(northLeft)
			,eastStraight(eastStraight)
			,eastLeft(eastLeft)
			,westLeft(westLeft)
		{
		}

		const bool northLeft;
		const bool eastStraight;
		const bool eastLeft;
		const bool westLeft;
	};


	TrafficLight& north;
	TrafficLight& east;
	TrafficLight& west;
	std::vector<State> states;
	const int greenTime;
	const int yellowTime;
	int state;
	int alarm;
};

}

#endif