#include "Utility/Assert.hpp"

#include <fstream>
#include <iostream>

namespace sl
{

namespace ass
{

/*		static prototypes here			*/
static void outputAssertionToConsole(const std::string& message);

static void outputAssertionToFile(const std::string& message, const std::string& filename);


void onAssertionFail(AssertionLevel level, const std::string& message)
{
	outputAssertionToConsole(message);
	outputAssertionToFile(message, "failedasserts.txt");
	//system("failedasserts.txt");
	//std::cin.get();
	//exit(1);
}

/*		static definitions here			*/
void outputAssertionToConsole(const std::string& message)
{
	std::cout << message;
}

void outputAssertionToFile(const std::string& message, const std::string& filename)
{
	std::fstream fs(filename.c_str(), std::fstream::out);
	if (fs.is_open())
	{
		fs << message;
	}
	else
	{
		std::cerr << "couldn't save failed ASSERT to file " << filename << std::endl;
	}
	fs.close();
}

}

}
