#ifndef SL_CONTAINERALGORITHMS_HPP
#define SL_CONTAINERALGORITHMS_HPP

namespace sl
{

template <typename T, typename V>
void insertInto(T& container, V val)
{
	container.insert(container.end(), std::move(val));
}

template <typename T, typename V>
void mergeInto(T& target, V& src)
{
	for (auto& elem : src)
	{
		insertInto(target, std::move(elem));
	}
	src.clear();
}

} // sl

#endif // SL_CONTAINERALGORITHMS_HPP