#ifndef SL_DECLARENAMEDVECTOR_HPP
#define SL_DECLARENAMEDVECTOR_HPP

// TODO: avoid the N parameter by getting MU_NARG() to work in MacroUtil
//#include "Utility/MacroUtil.hpp"
#include "Utility/Vector.hpp"

// hack around a bug in MSVC++ when passing __VA_ARGS__ to another macro
// info: https://stackoverflow.com/questions/10002296/macroized-parameters
#define DECLARE_NAMED_VECTOR_FIELDS_HELPER(N, args_list) DECLARE_NAMED_VECTOR_FIELDS_##N args_list

#define DECLARE_NAMED_VECTOR_BODY(name, T, N, ...) namespace sl { \
	class name : public sl::Vector<T, N> { \
	public: \
		DECLARE_NAMED_VECTOR_FIELDS_HELPER(N, (__VA_ARGS__)) \
		name() = default; \
		name(const sl::Vector<T, N>& copy) :sl::Vector<T, N>(copy) {} \
		name& operator=(const sl::Vector<T, N>& rhs) { \
			sl::Vector<T, N>::operator=(rhs); return *this; \
		} \
		name(sl::Vector<T, N>&& moved) :sl::Vector<T, N>(moved) {} \
		name& operator=(sl::Vector<T, N>&& rhs) { \
			sl::Vector<T, N>::operator=(rhs); return *this; \
		} \
	}; } // sl

#define DECLARE_NAMED_VECTOR_FIELDS_2(f0, f1) \
	Field& f0() { return at<0>(); } \
	const Field& f0() const { return at<0>(); } \
	Field& f1() { return at<1>(); } \
	const Field& f1() const { return at<1>(); }

#define DECLARE_NAMED_VECTOR_FIELDS_3(f0, f1, f2) \
	DECLARE_NAMED_VECTOR_FIELDS_2(f0, f1) \
	inline Field& f2() { return at<2>(); } \
	inline const Field& f2() const { return at<2>(); }

#define DECLARE_NAMED_VECTOR_FIELDS_4(f0, f1, f2, f3) \
	DECLARE_NAMED_VECTOR_FIELDS_3(f0, f1, f2) \
	inline Field& f3() { return at<3>(); } \
	inline const Field& f3() const { return at<3>(); }

#define DECLARE_NAMED_VECTOR_FIELDS_5(f0, f1, f2, f3, f4) \
	DECLARE_NAMED_VECTOR_FIELDS_4(f0, f1, f2, f3) \
	inline Field& f4() { return at<4>(); } \
	inline const Field& f4() const { return at<4>(); }

#define DECLARE_NAMED_VECTOR_FIELDS_6(f0, f1, f2, f3, f4, f5) \
	DECLARE_NAMED_VECTOR_FIELDS_5(f0, f1, f2, f3, f4) \
	inline Field& f5() { return at<5>(); } \
	inline const Field& f5() const { return at<5>(); }

#define DECLARE_NAMED_VECTOR_FIELDS_7(f0, f1, f2, f3, f4, f5, f6) \
	DECLARE_NAMED_VECTOR_FIELDS_6(f0, f1, f2, f3, f4, f5) \
	inline Field& f6() { return at<6>(); } \
	inline const Field& f6() const { return at<6>(); }

#endif // SL_DECLARENAMEDVECTOR_HPP