#ifndef SL_INCREMENT_HPP
#define SL_INCREMENT_HPP

namespace sl
{

template <typename T>
class Increment
{
public:
	Increment(const T& init = 0, const T& incr = 1)
		:x(init)
		, incr(incr)
	{
	}

	T operator()()
	{
		T ret(x);
		x += incr;
		return ret;
	}


private:

	T x;
	T incr;
};

} // sl

#endif //SL_INCREMENT_HPP