#ifndef SL_MAPUTIL_HPP
#define SL_MAPUTIL_HPP

#include <vector>
#include <map>

namespace sl
{

template <typename K, typename V>
std::vector<K> getKeys(const std::map<K, V>& map)
{
	std::vector<K> keys;
	keys.reserve(map.size());
	for (const auto& entry : map)
	{
		keys.push_back(entry.first);
	}
	return keys;
}

template <typename K, typename V>
std::vector<V> getValues(const std::map<K, V>& map)
{
	std::vector<V> values;
	values.reserve(map.size());
	for (const auto& entry : map)
	{
		values.push_back(entry.second);
	}
	return values;
}


} // sl

#endif // SL_MAPUTIL_HPP