#ifndef SL_RANGES_HPP
#define SL_RANGES_HPP

#include <vector>

namespace sl
{

template <typename T>
static std::vector<T> range(const T& begin, const T& end)
{
	std::vector<T> output;
	for (T it = begin; it != end; ++it)
	{
		output.push_back(it);
	}
	return output;
}

template <typename T>
static std::vector<T> rangeInclusive(const T& begin, const T& end)
{
	std::vector<T> output = range(begin, end);
	output.push_back(end);
	return output;
}

template <typename T>
static std::vector<T> enumRangeInclusive(const T& begin, const T& end)
{
	std::vector<T> output;
	for (int it = static_cast<int>(begin), last = static_cast<int>(end); it <= last; ++it)
	{
		output.push_back(static_cast<T>(it));
	}
	return output;
}

} // sl

#endif // SL_RANGES_HPP