#ifndef SL_SEQUENCE_JOIN_HPP
#define SL_SEQUENCE_JOIN_HPP

#include <memory>

#include "Utility/Sequencer/SequencedEvent.hpp"

namespace sl
{

class SequenceJoin : public SequencedEvent
{
public:
	SequenceJoin();

	SequenceJoin(const SequenceJoin& copy);

	SequenceJoin(SequenceJoin&& move);

	~SequenceJoin();

	SequenceJoin& operator=(const SequenceJoin& rhs);

	SequenceJoin& operator=(SequenceJoin&& rhs);

	bool isInstantaneouslySequenced() const override;

	bool sequence() override;

	void resetSequence() override;

private:
	void signalReached();

	void signalNotReached();


	std::shared_ptr<int> joinCounter;
	bool reached;
};

} // sl

#endif // SL_SEQUENCE_JOIN_HPP