#ifndef SL_SEQUENCED_FUNCTION_HPP
#define SL_SEQUENCED_FUNCTION_HPP

#include <functional>

#include "Utility/Sequencer/SequencedEvent.hpp"

namespace sl
{

class SequencedFunction : public SequencedEvent
{
public:
	SequencedFunction(std::function<void()> function);

	SequencedFunction(std::function<void()> function, int preTime, int postTime);

	bool sequence() override;

	bool isInstantaneouslySequenced() const override;

private:
	std::function<void()> function;
	bool isInstantaneous;
	int frameToFire;
	int countdown;
};

class SequencedBoolFunction : public SequencedEvent
{
public:
	SequencedBoolFunction(std::function<bool()> function, bool isInstantaneous = false);

	bool sequence() override;

	bool isInstantaneouslySequenced() const override;

private:
	std::function<bool()> function;
	bool isInstantaneous;
};

} // sl

#endif // SL_SEQUENCED_FUNCTION_HPP