#include "Utility/Sequencer/Sequencer.hpp"

#include "Utility/Sequencer/SequencedEvent.hpp"

namespace sl
{

Sequencer::Sequencer()
	:index(0)
{
}

Sequencer::Sequencer(Sequencer&& rhs)
	:sequencedEvents(std::move(rhs.sequencedEvents))
	,index(rhs.index)
{
}

bool Sequencer::tick()
{
	while (index < sequencedEvents.size() && sequencedEvents[index]->isInstantaneouslySequenced())
	{
		sequencedEvents[index]->sequence(); 
		++index;
	}

	if (index < sequencedEvents.size() && sequencedEvents[index]->sequence())
	{
		++index;
	}
	return index >= sequencedEvents.size();
}

void Sequencer::reset()
{
	index = 0;
}

void Sequencer::clearList()
{
	sequencedEvents.clear();
	reset();
}

void Sequencer::registerEvent(std::unique_ptr<SequencedEvent> sequencedEvent)
{
	sequencedEvents.push_back(std::move(sequencedEvent));
}

}