#ifndef SL_SEQUENCER_HPP
#define SL_SEQUENCER_HPP

#include <memory>
#include <vector>

#include "Utility/Sequencer/SequencedEvent.hpp"

namespace sl
{

class Sequencer
{
public:
	Sequencer();

	Sequencer(Sequencer&& rhs);

	/**
	 * Advances one tick along the sequence
	 * @return True if the sequence is finished
	 */
	bool tick();

	/**
	 * Resets the sequence back to the first step
	 */
	void reset();

	/**
	 * Clears all sequenced events out of the list and resets everything
	 */
	void clearList();

	/**
	 * Adds an event to the sequence
	 * @param The event to add
	 */
	void registerEvent(std::unique_ptr<SequencedEvent> sequencedEvent);

private:
//	Sequencer(const Sequencer&);
//	Sequencer& operator=(const Sequencer&);

	std::vector<std::unique_ptr<SequencedEvent>> sequencedEvents;
	int index;
};

}

#endif
