#ifndef SL_STRING_HPP
#define SL_STRING_HPP

#include <cstdint>
#include <string>

namespace sl
{

class String
{
public:
	template <int N>
	String(const char (&str)[N])
		:ref(new Ref({ str, N, 2 }))
	{
		// the 2 is so that it can never have the refs go below 1
	}

	String(const std::string& str);

	String(const String& other);

	String(String&& other);

	~String();

	String& operator=(const String& rhs);

	String& operator=(String&& rhs);

	std::string toStd() const;

	const char* toC() const;

	operator const char*() const;

private:

	void addref() const;

	void unref();

	void breakOff();

	struct Ref
	{
		char *str;
		int len;
		int count;
	};
	Ref *ref;
};

} // sl

#endif // SL_STRING_HPP
