#include "Utility/Time/DateUtil.hpp"

namespace sl
{

bool isLeapYear(int year)
{
	return (year % 400 == 0 || (year % 4 == 0 && year % 100 != 0));
}

int daysInMonth(int month, int year)
{
	static const int daysPerMonth[12] = {
		31,
		28,
		31,
		30,
		31,
		30,
		31,
		31,
		30,
		31,
		30,
		31
	};

	if (month == 1 && isLeapYear(year))
	{
		return daysPerMonth[month] + 1;
	}
	else
	{
		return daysPerMonth[month];
	}
}

}