#ifndef SL_GAMEDATE_HPP
#define SL_GAMEDATE_HPP

#include <cstdint>

namespace sl
{

enum class Month
{
	January = 0,
	February,
	March,
	April,
	May,
	June,
	July,
	August,
	September,
	October,
	November,
	December
};

class GameDate
{
public:
	GameDate(int year, int yearDay);

	GameDate(int year, Month month, int monthDay);

	int getYear() const;

	int getMonthDay() const;

	int getDay() const;

	int getMonth() const;

	int getDayOfWeek() const;

	void advance(int days);


	bool operator==(const GameDate& rhs) const;

	bool operator<(const GameDate& rhs) const;

	bool operator<=(const GameDate& rhs) const { return *this == rhs || *this < rhs; }

	uint64_t u64() const;

	uint16_t year;
	uint16_t day;
};

} // sl

#endif // SL_GAMEDATE_HPP