#ifndef SL_GAMETIME_HPP
#define SL_GAMETIME_HPP

#include <cstdint>

#include "Utility/Time/GameDate.hpp"
#include "Utility/Time/TimeOfDay.hpp"

namespace sl
{

class GameTime
{
public:
	// the preferred constructor
	GameTime(const GameDate& date, const TimeOfDay& time);

	GameTime(int year, int yearDay, const TimeOfDay& time);

	GameTime(int year, Month month, int monthDay, const TimeOfDay& time);

	bool operator==(const GameTime& rhs) const;

	bool operator<(const GameTime& rhs) const;

	bool operator<=(const GameTime& rhs) const { return *this == rhs || *this < rhs; }

	static constexpr uint64_t dayToSeconds = 60 * 60 * 24;

	uint64_t u64() const;

	GameDate date;
	TimeOfDay time;
};

struct TimeInterval
{
	TimeInterval(const GameTime& start, const GameTime& end);

	bool isWithin(const GameTime& time) const;

	GameTime start;
	GameTime end;
};

} // sl

#endif // SL_GAMETIME_HPP