#ifndef SL_RECURRINGTIMEINTERVALGENERATOR_HPP
#define SL_RECURRINGTIMEINTERVALGENERATOR_HPP

#include "Utility/Time/TimeIntervalGenerator.hpp"
#include "Utility/Time/RecurringTimeInterval.hpp"

namespace sl
{

class RecurringTimeIntervalGenerator : public TimeIntervalGenerator
{
public:
	RecurringTimeIntervalGenerator(const RecurringTimeInterval& interval);

	std::vector<TimeInterval> generate(const GameTime& start, const GameTime& end) const override;

	bool isWithin(const GameTime& time) const override;

private:

	RecurringTimeInterval interval;
};

} // sl

#endif // SL_RECURRINGTIMEINTERVALGENERATOR_HPP