#include "Utility/Time/TimeOfDay.hpp"

#include <Utility/Assert.hpp>
// TODO: remove
#include "Utility/Logger.hpp"
#include <algorithm>

namespace sl
{

TimeOfDay::TimeOfDay(int totalSeconds)
	:seconds(std::clamp(totalSeconds, 0, 24*60*60 - 1))
{
	// TODO: figure out why this is caused. for the @DEMO this is just hacked into a log though.
	//ASSERT(seconds >= 0 && seconds < 24 * 60 * 60);
	if (totalSeconds < 0 || totalSeconds >= 24 * 60 * 60)
	{
		Logger::log(Logger::Utility, Logger::Useless) << "TimeOfDay::totalSeconds = " << totalSeconds << std::endl;
	}
}

TimeOfDay::TimeOfDay(int hour, int minute, int second)
	:TimeOfDay(hour * 3600 + minute * 60 + second)
{
}

int TimeOfDay::getHour() const
{
	return seconds / 3600;
}

int TimeOfDay::getMinutes() const
{
	return (seconds / 60) % 60;
}

int TimeOfDay::getSeconds() const
{
	return seconds % 60;
}

int TimeOfDay::getTotalSeconds() const
{
	return seconds;
}

void TimeOfDay::setHour(int hour)
{
	const int mod = 24 * 60 * 60;
	const int hourdiff = hour - getHour();
	seconds = (((seconds + hourdiff * 3600) % mod) + mod) % mod;
}

void TimeOfDay::setMinutes(int minutes)
{
	ERROR("not implemented");
}

void TimeOfDay::setSeconds(int seconds)
{
	ERROR("not implemented");
}

int TimeOfDay::advance(int secondsToIcrement)
{
	seconds += secondsToIcrement;
	const int secondsInDay = 24 * 60 * 60;
	const int days = seconds / secondsInDay;
	seconds %= secondsInDay;
	return days;
}

bool TimeOfDay::operator<(const TimeOfDay& rhs) const
{
	return seconds < rhs.seconds;
}

} // sl