#ifndef SL_TIMEOFDAY_HPP
#define SL_TIMEOFDAY_HPP

namespace sl
{

class TimeOfDay
{
public:
	TimeOfDay(int totalSeconds);

	TimeOfDay(int hour, int minute, int second = 0);

	int getHour() const;
	int getMinutes() const;
	int getSeconds() const;
	int getTotalSeconds() const;

	void setHour(int hour);
	void setMinutes(int minutes);
	void setSeconds(int seconds);

	/**
	 * Advances the time by the desired amount
	 * @param seconds The number of seconds to advance by
	 * @return The number of days that will have passed as a result
	 */
	int advance(int secondsToIcrement);

	bool operator<(const TimeOfDay& rhs) const;
	TimeOfDay& operator=(const TimeOfDay&) = default;

private:
	int seconds;
};

} // sl

#endif // SL_TIMEOFDAY_HPP