#include <iostream>

#include "Engine/Game.hpp"
#include "NPC/Stats/DNADatabase.hpp"
#include "Parsing/Parsers/ParserTester.hpp"
#include "Utility/Random.hpp"

#include "Tests/TestRunner.hpp"

#pragma comment(linker, "/SUBSYSTEM:windows /ENTRY:mainCRTStartup")

// TODO: remove this crap once MacroUtil is working
//#include "Utility/MacroUtil.hpp"
//template <typename T>
//void printIt(const T& data) { std::cout << data; }
//template <typename T, typename... Args>
//void printIt(const T& data, Args... args)
//{
//	std::cout << data << ", ";
//	printIt(args...);
//}
//template <typename T>
//struct Bracketed
//{
//	Bracketed(const T& t) : t(t) {}
//	T t;
//};
//template <typename T>
//std::ostream& operator<<(std::ostream& os, const Bracketed<T>& b)
//{
//	os << "(" << b.t << ")";
//	return os;
//}
//#define APPLYPRINT(x) x
//#define PRINT(x) (std::cout << x
//#define PRINT_NARG(...) std::cout << (MU_NARG(__VA_ARGS__));
//Bracketed(x)
int main(int argc, const char **argv)
{
	//MU_VA_MAP_IMPL_2(PRINT, 1, 2, 3)
	//printIt(MU_VA_MAP_IMPL_N(2, APPLYPRINT, 1, 2));
	int errorCode = 0;
#ifndef SL_DEBUG
	try
#endif // !SL_DEBUG
	{
		sl::Game game;
		// after game so logger / etc is initialized.
		// These are just other things - maybe they should be unit tests?
		// But they don't really have any assertions. Command line args too?
		//sl::DNADatabase::get().test(sl::Random::get(), 100, 10000, "english");
		//sl::ls::useParser();
		if (argc >= 2 && strncmp(argv[1], "-lint", 5) == 0)
		{
			sl::test::runTests(std::cerr, {"DialogueLintTest"});
		}
		else
		{
#ifdef SL_DEBUG
			ASSERT(sl::test::runAlwaysTests(std::cerr));
#endif // SL_DEBUG
			errorCode = game.run();
		}
	}
#ifndef SL_DEBUG
	catch (std::exception& e)
	{
		//std::cerr << "Uncaught exception occured:\n" << e.what();
		ERROR(std::string("Uncaught exception occured:\n") + e.what());
		errorCode = 1;
		//std::cin.get();
	}
	catch (...)
	{
		//std::cerr << "Error: something occured that wasn't a std::exception";
		ERROR("uncaught random other exception. wtf?");
		errorCode = 2;
		//std::cin.get();
	}
#endif // !SL_DEBUG
	return errorCode;
}
